commit 545de2ffec6ae9a80738de1b2c8cf820249a2530
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Sep 23 20:47:44 2018 +0300

    Fix possible double transpose of custom CQM if --level is not set
    
    Bug reported by Nicolas Gaullier

commit b63c73dc5c37e5405bf032c9113c1daced3e45a4
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Aug 7 22:42:22 2018 +0200

    cli: Fix linking with --system-libx264 on x86

commit fb17a6b5b51d02020fb0cadea2b27c7803e734ba
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Aug 21 15:11:21 2018 +0300

    Fix CAVLC+RDO in 4:4:4

commit 303c484ec828ed0d8bfe743500e70314d026c3bd
Author: Alexandra Hájková <alexandra.khirnova@gmail.com>
Date:   Wed Jul 11 19:28:20 2018 +0000

    ppc: Optimize quant functions
    
    1) using xxpermdi + merge instead of 2 merges improves quant_8x8
    performance by 5%
    
    2) use vec_splats instead of vec_splat
    
    checkasm timings when compiled with gcc:
                      C:            AltiVec:
                                    before: after:
    quant_2x2_dc:      57            163      46
    quant_4x4_dc:     141            162      57
    
    dequant_4x4_cmp:  104            101      45
    dequant_4x4_flat: 104            106      46
    dequant_8x8_cmp:  412            208     147
    dequant_8x8_flat: 414            212     149

commit 44f1671369b54734db1775fe5155f17041344d8f
Author: Alexandra Hajkova <alexandra.khirnova@gmail.com>
Date:   Sun Jul 8 13:04:43 2018 -0500

    ppc: Add support for Power9-only vec_absd
    
    Increases overall encoding speed on POWER9 by 8%.

commit f8afe3820c84798e9e50623cf7349bdb98765926
Author: Alexandra Hájková <alexandra.khirnova@gmail.com>
Date:   Fri Jun 29 16:50:20 2018 +0000

    ppc: Optimize sub8x8_dct_dc

commit 411c957d82d357250f3a3099727b1a2c84caaee9
Author: Alexandra Hájková <alexandra.khirnova@gmail.com>
Date:   Thu Jun 21 18:36:32 2018 +0000

    ppc: AltiVec add16x16_idct_dc

commit 53fe16e51349c43c483e81afb1f08a39f843a234
Author: Alexandra Hájková <alexandra.khirnova@gmail.com>
Date:   Sat Jun 23 14:58:17 2018 +0000

    ppc: Optimize add8x8_idct_dc

commit 62dcebbce2c3f34998aeb2ea76b89f51306e78e9
Author: Luca Barbato <lu_zero@gentoo.org>
Date:   Thu Jul 12 10:41:22 2018 +0200

    ppc: Add compatibility macros for vec_xxpermdi

commit d1a53926fb90e9f4a4f1605f4b2a8a945a73e1d2
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Jun 25 00:09:51 2018 +0200

    Prefer a monotonic clock source if available

commit 1d18f0e025e994b93233b8e8afa0c691bccc8fda
Author: Kieran Kunhya <kierank@obe.tv>
Date:   Wed Aug 30 16:05:41 2017 +0100

    Add Sony XAVC, a flavour of AVC-Intra

commit bc136ec6a0f863c42686a3bc9fa4c7820f83d413
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Jul 2 20:20:03 2018 +0300

    Cosmetics: Fix indentation for multiline function prototypes
    
    It was broken in "Drop the x264 prefix" patch.

commit 6dd1d3b5d9e16a5951ececb7351cd63f02b36435
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Apr 16 23:54:43 2018 +0300

    Cosmetics: Use consistent "inline" attribute position
    
    Place it immediately after "static".

commit 3d9ec58f27f1cd6732484246aaad59158b98af47
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Jan 25 22:17:57 2018 +0100

    x86: AVX-512 plane_copy and plane_copy_swap
    
    Avoid the scalar C wrapper by utilizing opmasks to prevent overreading the
    input buffer.

commit 698c5a32e63a3ed6b976ed196abe479efd78530b
Author: Emanuele Ruffaldi <emanuele.ruffaldi@gmail.com>
Date:   Sat Jan 6 02:34:39 2018 +0100

    4:0:0 (monochrome) encoding support
    
    Virtually zero increase in compression efficiency compared to 4:2:0 with empty
    chroma planes. Performance is better though, especially with fast settings.

commit 814e61e88c809bb00d17c200a04e9c7d42a19bb5
Author: Diego Biurrun <diego@biurrun.de>
Date:   Sun Feb 5 09:02:43 2017 +0100

    Makefile improvements
    
     * Coalesce some install recipe lines
    
     * Remove empty addition of GPLed filters
    
     * Install libdir in recipes that directly require it
    
     * Coalesce etags/TAGS rules
    
     * Simplify fprofiled rule

commit 28e4879842a86cc6bb63db0f5f386a3e9268fd46
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Apr 22 22:49:15 2018 +0200

    x86inc: Improve SAVE/LOAD_MM_PERMUTATION macros
    
    Use register numbers instead of copying the full register names. This makes it
    possible to change register widths in the middle of a function and keep the
    mmreg permutations intact which can be useful for code that only needs larger
    vectors for parts of the function in combination with macros etc.
    
    Also change the LOAD_MM_PERMUTATION macro to use the same default name as the
    SAVE macro. This simplifies swapping from ymm to xmm registers or vice versa:
    
        SAVE_MM_PERMUTATION
        INIT_XMM <cpuflags>
        LOAD_MM_PERMUTATION

commit 8badb910847e94abb66686009e424bdce355c9f4
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Mar 31 13:49:56 2018 +0200

    x86inc: Optimize VEX instruction encoding
    
    Most VEX-encoded instructions require an additional byte to encode when src2
    is a high register (e.g. x|ymm8..15). If the instruction is commutative we
    can swap src1 and src2 when doing so reduces the instruction length, e.g.
    
        vpaddw xmm0, xmm0, xmm8 -> vpaddw xmm0, xmm8, xmm0

commit 0a84d986e7020f8344f00752e3600b9769cc1e85
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Mar 31 01:16:06 2018 +0200

    x86inc: Fix VEX -> EVEX instruction conversion
    
    There's an edge case that wasn't properly handled.

commit 9d33c8fefbb506377b943aba11cd99c74258c5de
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Jul 31 22:54:33 2018 +0300

    configure: Fix required version checks for lavf and swscale

commit 34843deb060248514ecd9edd88d72c2c2d6b906a
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Jul 20 08:37:43 2018 +0300

    Fix float division by zero in weightp analysis

commit 1c3174775c6c1789aaf10172e4cb619f91ecff4a
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed Jul 18 21:56:33 2018 +0300

    Fix undefined behavior of left shift for CAVLC encoding

commit a0253ebee0f4d854cf89934b5f420275862d0b5b
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Jul 2 20:59:16 2018 +0300

    Fix integer overflow in slicetype_path_cost
    
    The path cost for high resolutions can exceed COST_MAX.

commit 2af2742821f0b08a4295055b41875e660d5a7746
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Jun 29 13:14:01 2018 +0200

    cli: Fix preset help listing
    
    It was previously incorrect when --chroma-format or --bit-depth was
    specified in configure.

commit f5d929ab8faf2319dda10836f51803ba25f0ad07
Author: Luca Barbato <lu_zero@gentoo.org>
Date:   Sat Jun 23 13:14:28 2018 +0200

    ppc: Fix zigzag_interleave
    
    The permv array has 3 elements

commit 7737e6ad4acf1058aeb0f9802e2a3ca1e0a30d29
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Jun 2 20:35:10 2018 +0200

    Fix clang stack alignment issues
    
    Clang emits aligned AVX stores for things like zeroing stack-allocated
    variables when using -mavx even with -fno-tree-vectorize set which can
    result in crashes if this occurs before we've realigned the stack.
    
    Previously we only ensured that the stack was realigned before calling
    assembly functions that accesses stack-allocated buffers but this is
    not sufficient. Fix the issue by changing the stack realignment to
    instead occur immediately in all CLI, API and thread entry points.

commit 26b99cce1f03f023dee98bef2ec3cd2eff319f8e
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Apr 1 20:49:29 2018 +0300

    Fix missing bs_flush in AUD writing

commit da6b29b553bb56e16e99527733849735c2ea264c
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Apr 1 20:39:30 2018 +0300

    Fix possible undefined behavior of right shift
    
    32-bit shifts are only defined for values in the range 0-31.

commit 7e457290cdd6da592ae63aa25facc47cd09d2128
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Apr 1 20:34:18 2018 +0300

    Make bs_align_10 imply bs_flush
    
    Now behaves the same as bs_align_0 and bs_align_1.

commit 6afb67c6d7b71fcc6fc14d167f1fcf55623846f4
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Apr 1 17:52:47 2018 +0300

    Fix theoretically incorrect cost_mv_fpel free

commit 57dd6274e2da70bdb8220bc159976e3ac2aea017
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Apr 1 17:42:46 2018 +0300

    configure: Fix ambiguous "$(("

commit 0e6425e03e28213e73ae770df5e08fffba72d290
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Feb 19 19:53:38 2018 +0300

    Fix --qpmax default value in fullhelp

commit 5f7f950c80e330728ecb07bc133e17456870121a
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Mar 31 01:31:57 2018 +0200

    x86: Correctly use v-prefix for instructions with opmasks
    
    This was always required, but accidentally happened to work correctly
    in a few cases.

commit 3d90057e15abf257320c89bb7146fb0c92687fa6
Author: Martin Storsjö <martin@martin.st>
Date:   Sat Mar 31 00:10:14 2018 +0300

    configure: Only use gas-preprocessor with armasm for compiler=CL
    
    This picks the right assembler automatically for arm and aarch64
    llvm-mingw targets.
    
    This doesn't get the right assembler for clang setups when clang
    acts like MSVC and uses MSVC headers though (where it perhaps
    should use armasm as before), but that's probably an even more
    obscure setup.

commit 7d0ff22e8c96de126be9d3de4952edd6d1b75a8c
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed Jan 17 22:03:06 2018 +0300

    Remove ARRAY_SIZE macro which is identical to ARRAY_ELEMS

commit 4a158b00943c334ec9e0aabe6a919900c32e360e
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Jan 6 17:47:42 2018 +0100

    x86inc: Correctly set mmreg variables

commit 40b47eed1338cef1ac66c98b4e393dfcf5d998ae
Author: Diego Biurrun <diego@biurrun.de>
Date:   Sun Feb 5 09:02:49 2017 +0100

    .gitignore: Ignore TAGS file

commit 6fce82284a0fb3edfa299b904b1559452a3b1094
Author: Diego Biurrun <diego@biurrun.de>
Date:   Sun Feb 5 09:02:51 2017 +0100

    Minor configure improvements
    
     * Drop empty addition of GPLed filters
    
     * Replace backticks with $()

commit ca5408b13cf0e58a7505051861f20a63a7a6aec1
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Jan 1 15:05:48 2018 +0100

    Bump dates to 2018

commit b019515ef4ad77022b849283c62612157e8458a7
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Jan 16 17:43:24 2018 +0100

    Merge zero buffers
    
    Improves cache efficiency.

commit d75b93b0e82cefa93e5db2d6b0be475566101431
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed Jan 17 18:19:44 2018 +0300

    rdo: Use ALIGNED_ARRAY for stack arrays

commit 9384a7389b251b59a079ccc3d1af9edd42e3d5e6
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Jan 15 21:42:59 2018 +0100

    Correctly align buffers for AVX and AVX-512
    
    Fixes segfaults on Windows where the stack is only 16-byte aligned.

commit b00bcafe53a166b63a179a2f41470cd13b59f927
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Dec 24 22:59:09 2017 +0300

    Cosmetics

commit 7c6b3ad50d9210d27be6953dfa6d24e5d183be18
Author: Alexandra Hájková <alexandra.khirnova@gmail.com>
Date:   Sun May 21 17:40:45 2017 +0000

    ppc: Add load_deinterleave_chroma_fenc_altivec
    
    5x speed up vs C code.

commit b461e015fd7efe3bb740ef0716bc41d76eff30c9
Author: Martin Storsjö <martin@martin.st>
Date:   Thu Oct 26 13:09:46 2017 +0300

    Update to the latest upstream version of gas-preprocessor
    
    This version supports converting aarch64 assembly for MS armasm64.exe.

commit 61e8b5cc482b08d51e18b336081073736d963e7e
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Oct 22 09:59:28 2017 +0200

    input: Add a workaround for swscale overread bugs
    
    swscale can read past the end of the input buffer, which may result in
    crashes if such a read crosses a page boundary into an invalid page.
    
    Work around this by adding some padding space at the end of the buffer when
    using memory-mapped input frames. This may sometimes require copying the
    last frame into a new buffer on Windows since the Microsoft memory-mapping
    implementation has very limited capabilities compared to POSIX systems.

commit 1221f097473a049a52fbb47aff2733321bd4661a
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Oct 22 10:50:46 2017 +0200

    filters/resize: Upgrade to a newer libavutil API
    
    Use the AVComponentDescriptor depth field instead of depth_minus1.

commit 99ca611d2e667553e026f487dc787b595dde84c5
Author: Martin Storsjö <martin@martin.st>
Date:   Wed Oct 18 10:40:02 2017 +0300

    aarch64: Use ldurb/sturb for loads/stores with negative offsets
    
    The assembler (both gas and clang/llvm) automatically fixes this,
    armasm64 doesn't. We can fix it in gas-preprocessor, but we should
    also be using the right instruction form.

commit f745815e593b788d846182c8d42eed4f72f7c33c
Author: Martin Storsjö <martin@martin.st>
Date:   Mon Oct 16 22:50:27 2017 +0300

    configure: Add support for building with MSVC/armasm for ARM64

commit 7b13b31be60ed65bee615bab28c422e2df027ee1
Author: Martin Storsjö <martin@martin.st>
Date:   Mon Oct 16 22:50:26 2017 +0300

    arm: Check for __ELF__ instead of !__APPLE__, for using .arch/.fpu
    
    For windows, when building with armasm, we already filtered these out
    with gas-preprocessor.
    
    By filtering them out already in the source, we can also build directly
    with clang for windows (which also require wrapping the assembler in
    gas-preprocessor for converting instructions to thumb form, but
    gas-preprocessor doesn't and shouldn't filter out them in the clang
    configuration).

commit 12ca9a69e855c4d4b9000894f478bce665e4e02c
Author: Martin Storsjö <martin@martin.st>
Date:   Mon Oct 16 22:50:25 2017 +0300

    aarch64: Don't .set a symbol named st2
    
    This confuses gas-preprocessor, which tries to replace actual
    st2 instructions by the integer 1 or 2.

commit 06c8f6bab0fc8fa9b2df9a1af5d10c87c515edb4
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Oct 14 14:11:26 2017 +0200

    Shrink the i4x4_mode cost_table array
    
    Only 17 elements are actually used. It was originally padded to 64 bytes to
    avoid cache line splits in the x86 assembly, but those haven't really been
    an issue on x86 CPU:s made in the past decade or so.
    
    Benchmarking shows no performance impact from dropping the padding, so
    might as well remove it and save some cache.

commit 344699fd386890ac1cf80a70a68a3ae16767ed62
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Oct 11 18:02:26 2017 +0200

    x86: Remove some legacy CPU detection hacks
    
    Some ancient Pentium-M and Core 1 CPU:s had slow SSE units, and using MMX
    was preferable. Nowadays many assembly functions in x264 completely lack MMX
    implementations and falling back to C code will likely make things worse.
    
    Some misconfigured virtualized systems could sometimes also trigger this code
    path and cause assertions.

commit 0fe75403d7b40c0209c3df992632956292065cdc
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Oct 11 17:58:36 2017 +0200

    lavf: Upgrade to the new core decoding API

commit dae7f18d2cc5c7eccfb73649cda458e3c8e2256e
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Mon Oct 9 12:04:22 2017 -0400

    lavf: Upgrade to some newer API:s
    
     * Use the codec parameters API instead of the AVStream codec field.
     * Use av_packet_unref() instead of av_free_packet().
     * Use the AVFrame pts field instead of pkt_pts.

commit 12611ec99bb52f4f2c1b114138d867b3a2aa182b
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Oct 8 21:41:16 2017 +0200

    x86: AVX-512 load_deinterleave_chroma_fdec

commit d93851ec282eb069f91a6eddab3284f7766cd5bd
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Oct 8 21:23:12 2017 +0200

    x86: AVX-512 load_deinterleave_chroma_fenc

commit 5b62ab59be01579ab37033cc86527df922efb843
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Oct 7 12:06:51 2017 +0200

    x86: AVX-512 mbtree_fix8_pack and mbtree_fix8_unpack
    
    Takes advantage of opmasks to avoid having to use scalar code for the tail.
    
    Also make some slight improvements to the checkasm test.

commit 08476ab1c0a9b741198677731373b173657fa079
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Oct 7 11:34:16 2017 +0200

    x86: Faster mbtree_fix8_unpack
    
    Use a different multiplier in order to eliminate some shifts.
    
    About 25% faster than before.

commit e3fae10bf7db9571d5c69ad910f10df625bad73e
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Sep 22 17:28:18 2017 +0300

    Don't force fast-intra for subme < 3
    
    It have caused significant quality hit without any meaningful (if any) speed up.

commit bdf27e783a8eb4a5bcae0cd0a950d6dc3d995bfe
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Sep 22 17:18:55 2017 +0300

    Make ref and i4x4_mode costs global instead of static
    
    Fixes some thread safety doubts and makes code cleaner.
    Downside: slightly higher memory usage when calling multiple encoders from the same application.

commit fefc3fa1fa98a7bac4eaf3c8e6e1c52b7e427ddd
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Sep 22 17:05:06 2017 +0300

    Fix thread safety of x264_threading_init() and use of X264_PTHREAD_MUTEX_INITIALIZER with win32thread

commit 694d031c1d120a8b578f60eeccf14fcf9ca4200e
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Sep 22 16:59:13 2017 +0300

    configure: Improvements
    
    Log result of pkg-config checks to config.log.
    Fix lavf support detection for pkg-config fallback case.
    Fix detection of linking dependencies errors for lavf/lsmash/gpac.
    Cosmetics.

commit 5d4031618e9feedcb527fd4e5a91bc06e30b70b4
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Aug 17 23:51:14 2017 +0300

    flv: Fix one frame video total duration

commit 8b9c89d331f5a2d6335ff9b08abc8d5c94428731
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Aug 17 23:46:23 2017 +0300

    flv: Split FrameType and CodecID values

commit 95cdb743463f723cea58c8ae01d7762f7ae9965c
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Tue Aug 8 15:40:45 2017 +0200

    Support writing the alternative transfer SEI message

commit c98d02bebd6dd04b61306ee27712aeff96f19f29
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Tue Aug 8 14:56:43 2017 +0200

    Support 04/2017 color matrix and transfer values

commit 71ed44c7312438fac7c5c5301e45522e57127db4
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Fri Jan 6 15:23:38 2017 +0100

    Unify 8-bit and 10-bit CLI and libraries
    
    Add 'i_bitdepth' to x264_param_t with the corresponding '--output-depth' CLI
    option to set the bit depth at runtime.
    
    Drop the 'x264_bit_depth' global variable. Rather than hardcoding it to an
    incorrect value, it's preferable to induce a linking failure. If applications
    relies on this symbol this will make it more obvious where the problem is.
    
    Add Makefile rules that compiles modules with different bit depths. Assembly
    on x86 is prefixed with the 'private_prefix' define, while all other archs
    modify their function prefix internally.
    
    Templatize the main C library, x86/x86_64 assembly, ARM assembly, AARCH64
    assembly, PowerPC assembly, and MIPS assembly.
    
    The depth and cache CLI filters heavily depend on bit depth size, so they
    need to be duplicated for each value. This means having to rename these
    filters, and adjust the callers to use the right version.
    
    Unfortunately the threaded input CLI module inherits a common.h dependency
    (input/frame -> common/threadpool -> common/frame -> common/common) which
    is extremely complicated to address in a sensible way. Instead duplicate
    the module and select the appropriate one at run time.
    
    Each bitdepth needs different checkasm compilation rules, so split the main
    checkasm target into two executables.

commit 2451a7282463f68e532f2eee090a70ab139bb3e7
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Fri Jan 6 17:50:40 2017 +0100

    Change default QP parameters initialization
    
    qp is modified to require a valid value before use, while qp_max is set
    to maximum allowable value (and clipped later on).
    
    This is needed so that param functions do not depend on bit depth size.

commit 7839a9e1f03b49e3e0cbfcb3091093af7c6d54ee
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Tue Jan 17 17:07:42 2017 +0100

    aarch64: Set the function symbol prefix in a single location

commit 498cca0b74ab90c363b761083c7fdcf56fc60904
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Tue Jan 17 17:04:19 2017 +0100

    arm: Set the function symbol prefix in a single location

commit 8f2437d33301faaf0e2fcaff16e2b01e9bbe27ae
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Fri Jan 27 11:58:33 2017 +0100

    Drop the x264 prefix from static functions and variables

commit 4e2ed4087ac1621f946b83366e1f53a1326d7424
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Aug 17 23:25:31 2017 +0300

    configure: Check for strtok_r compiler support

commit d1eebb2927da15c41c7c180d398b0cdad3d1f396
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Aug 6 17:17:55 2017 +0200

    cabac: Make the cabac_contexts array static
    
    Also drop the x264 prefix from all static cabac arrays.

commit 3f9f6554a4cfa4189855756860a61ceb2f2a41a3
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Aug 17 18:04:13 2017 +0200

    x86: AVX-512 pixel_satd_x3 and pixel_satd_x4

commit dd399ab862e2271e869bc8aefcb3166180ecdb10
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Aug 14 23:13:44 2017 +0200

    x86: Shrink the x86-64 cabac coeff_last tables
    
    Use dword instead of qword entries. Cuts the size of the tables in half
    which allows each table fit inside a single cache line.
    
    When PIC is disabled dwords are enough to store absolute addresses.
    
    When PIC is enabled we can store dword offsets relative to the start of
    the table and simply add the address of the table to the offset in order
    to calculate the full address. This approach also have the advantage of
    eliminating a whole bunch of run-time .data relocations.

commit d463a92e3b6f8ec04d54cc6c437892f9ffa98e29
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Aug 16 15:59:16 2017 +0200

    x86inc: Support creating global symbols from local labels
    
    On ELF platforms such symbols needs to be flagged as functions with the
    correct visibility to please certain linkers in some scenarios.

commit 67b5c961046621a4554a9577e68cd9e31a212091
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Aug 15 16:11:32 2017 +0200

    x86inc: Use .rdata instead of .rodata on Windows
    
    The standard section for read-only data on Windows is .rdata. Nasm will
    flag non-standard sections as executable by default which isn't ideal.

commit f15d366510cc60d9d9b2aeb576cade5b94509f37
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Aug 5 00:43:26 2017 +0200

    x86inc: Set the correct cpuflag for AES-NI instructions

commit 1ae63361304e952ac625a7016f2cf4a64e39a314
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Aug 5 00:09:52 2017 +0200

    x86inc: Enable AVX emulation for floating-point pseudo-instructions
    
    There are 32 pseudo-instructions for each floating-point comparison
    instruction, but only 8 of them are actually valid in legacy-encoded mode.
    The remaining 24 requires the use of VEX-encoded (v-prefixed) instructions
    and can therefore be disregarded for this purpose.

commit 1e27313c12154dd3922ef7ab9508a4320e83c2ac
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Aug 4 23:09:00 2017 +0200

    configure: Increase x86 stack alignment on clang

commit e9a5903edf8ca59ef20e6f4894c196f135af735e
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Oct 22 20:18:39 2017 +0300

    x86: Fix stack alignment for x264_cabac_encode_ue_bypass call
    
    Fix MSVS fprofiled build for win64

commit 45e6eb6006d1d23b6f69a1cfb62a86dc67092a81
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Oct 22 16:18:29 2017 +0300

    mips: Fix incorrect pointers to msa optimized functions

commit 09705c0b68232a05da8cc672c7c6092071eb4a21
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Aug 11 16:41:31 2017 +0200

    Fix cpu capabilities listing on older x86 operating systems
    
    Some cpuflags would previously be displayed incorrectly when running older
    operating systems without AVX support on modern CPU:s.

commit ba24899b0bf23345921da022f7a51e0c57dbe73d
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Jun 24 15:12:57 2017 +0200

    x86: AVX-512 pixel_avg_weight_w8

commit d3214e6b102701911fc9d5fc92435e79e8b49100
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Jun 24 14:26:25 2017 +0200

    x86: AVX-512 pixel_avg_weight_w16

commit 1d9dee2e9be717fcde416854f902db776312f141
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Jun 22 19:51:28 2017 +0200

    x86: AVX-512 sub8x16_dct_dc

commit f672795407bf90045e399eb057e5b2426d79f961
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Jun 22 11:26:21 2017 +0200

    x86: AVX-512 sub8x8_dct_dc

commit 0af1c6d0d0cc54ba4f888db39247774edcf19b44
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Jun 1 22:13:19 2017 +0200

    x86: AVX-512 add8x8_idct

commit 9034085265e5ca56e801c3efbf5c538fcc17c82b
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Jun 10 16:01:53 2017 +0200

    x86: AVX-512 sub16x16_dct

commit 774c6c76d081305d9c891091e1d4694acb3f8a68
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Jun 7 16:55:48 2017 +0200

    x86: AVX-512 sub8x8_dct

commit 2d653411c2135377fb8c956e897880ff997b50ec
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Jun 8 21:14:08 2017 +0200

    x86: AVX-512 sub4x4_dct

commit 07483f72d7e1a4f7079a429dd1370f4221006862
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun May 28 16:12:33 2017 +0200

    x86: AVX-512 mbtree_propagate_list
    
    Uses gathers and scatters in combination with conflict detections to
    vectorize the scalar part.
    
    Also improve the checkasm test to try different mb_y values and check
    for out-of-bounds writes.

commit 1a88481b85da964aadae1e05347342b03be17712
Author: James Darnley <jdarnley@obe.tv>
Date:   Fri Jun 9 14:08:16 2017 +0200

    x86inc: Add aesni cpuflag define
    
    Upstreaming this from FFmpeg. Unused in x264.

commit 98e9543b4c39360326e6d5bf266c0c634cb9ee2e
Author: Martin Storsjö <martin@martin.st>
Date:   Mon May 29 12:13:03 2017 +0300

    aarch64: Update the var2 functions to the new signature
    
    The existing functions could easily be used by just calling them
    twice - this would give the following cycle numbers from checkasm:
    
    var2_8x8_c:      4110
    var2_8x8_neon:   1505
    var2_8x16_c:     8019
    var2_8x16_neon:  2545
    
    However, by merging both passes into the same function, we get the
    following speedup:
    var2_8x8_neon:   1205
    var2_8x16_neon:  2327

commit 824802ad5a877244fb9eb48a892ed348736af5b0
Author: Martin Storsjö <martin@martin.st>
Date:   Mon May 29 12:13:02 2017 +0300

    arm: Update the var2 functions to the new signature
    
    The existing functions could easily be used by just calling them
    twice - this would give the following cycle numbers from checkasm:
    
                 Cortex A7     A8     A9   A53
    var2_8x8_c:       7302   5342   5050  4400
    var2_8x8_neon:    2645   1612   1932  1715
    var2_8x16_c:     14300  10528  10020  8637
    var2_8x16_neon:   5127   2695   3217  2651
    
    However, by merging both passes into the same function, we get the
    following speedup:
    var2_8x8_neon:    2312   1190   1389  1300
    var2_8x16_neon:   4862   2130   2293  2422

commit 6f8aa71ce797be01fd2ebe53c072a6696ea19828
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Feb 15 22:00:25 2017 +0100

    Add support for levels 6, 6.1, and 6.2
    
    These levels were added in the 2016-10 revision of the H.264 specification and
    improves support for content with high resolutions and/or high frame rates.
    
    Level 6.2 supports 8K resolution at 120 fps.
    
    Also shrink the x264_levels array by using smaller data types.

commit 2baa28c880d11377115bbd5508e72053f6ba61f5
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Mar 23 17:51:09 2017 +0100

    Use a larger integer type for the slice_table array
    
    Makes it possible to use slicing with resolutions larger than 2^24 pixels.

commit c9d2c1c80b25c6ae15c41b200ec44ac2dabce725
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Feb 19 10:48:33 2017 +0100

    analyse: Reduce the size the cost_mv arrays
    
    Use a dynamic size depending on the MV range. Reduces memory consumption by
    up to a few megabytes.
    
    Drop a related old miscompilation check since it may otherwise cause an
    out-of-bounds memory access.
    
    Also remove an unused extern variable declaration.

commit d46a5a463f0de5ec479d256af72bba3de4ba2d1a
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed May 31 02:52:16 2017 +0300

    Fix CABAC+8x8dct in 4:4:4
    
    Use the correct ctxIdxInc calculation for coded_block_flag.

commit 79b36f27a57dd511eefead6d5422689220c767b5
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Jun 6 02:07:21 2017 +0300

    Fix 8x8dct in lossless encoding
    
    Change V and H intra prediction in lossless (TransformBypassModeFlag == 1)
    macroblocks to correctly adhere to the specification. Affects lossless
    encoding with 8x8dct or mix of lossless with normal macroblocks.
    
    8x8dct has already been disabled in lossless mode for some time due to
    being out-of-spec but this will allow us to re-enable it again.

commit 68a550217c8d0fae6229c5b322b6810fe9652ef3
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Jun 8 18:35:21 2017 +0300

    mbtree: Fix buffer overflow
    
    Could occur on the 1st pass in combination with --fake-interlaced and
    some input heights due to allocating a too small buffer.

commit df79067c0cf33da712d344b5f8869be7eaf326f3
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue May 23 16:40:26 2017 +0200

    x86: Avoid self-relative expressions on macho64
    
    Functions that uses self-relative expressions in the form of [foo-$$]
    appears to cause issues on 64-bit Mach-O systems when assembled with nasm.
    Temporarily disable those functions on macho64 for the time being until
    we've figured out the root cause.

commit f1ac7122645bbeb56e7a4401f71a7055cb2431c4
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon May 22 23:59:32 2017 +0300

    configure: Don't try to detect clang by $CC
    
    Only check if option -Werror=unknown-warning-option is supported before adding it

commit b4d811df4fd7dbb9220fe2c8f2a2c2a6ba2bbc87
Author: Martin Storsjö <martin@martin.st>
Date:   Mon May 22 13:10:46 2017 +0300

    checkasm: Use the right variable in a loop condition
    
    Prior to this, this loop hasn't run at all. The condition has been
    the same since it was introduced in 5b0cb86f.
    
    This issue was pointed out by a clang warning.

commit a3d24462ae284bf03958f0ed41e824dd7d48e15e
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon May 22 22:02:34 2017 +0300

    x86: Fix linking with 8-bit depth shared libx264

commit d1fe6fd1c0930d88da90f23f6d5fdb6ceaf6b0a9
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon May 15 00:18:36 2017 +0200

    x86: Only enable AVX-512 in 8-bit mode

commit 6151882671b6f9e1ceec2cdb76dd1123c8dc766f
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri May 12 00:43:43 2017 +0200

    x86: AVX-512 cabac_block_residual

commit 4579616543f2e701ee9510f5eb57e31a3ef99e10
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed May 10 18:36:59 2017 +0200

    x86: AVX-512 pixel_sad_x3 and pixel_sad_x4
    
    Covers all variants: 4x4, 4x8, 8x4, 8x8, 8x16, 16x8, and 16x16.

commit 993eb2079e45619098241e14806fc70030968af6
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun May 7 23:35:49 2017 +0200

    x86: AVX-512 pixel_sad
    
    Covers all variants: 4x4, 4x8, 4x16, 8x4, 8x8, 8x16, 16x8, and 16x16.

commit 2463174c119cef4f7e6a36a1151054fbb268b082
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu May 4 21:53:28 2017 +0200

    x86: AVX-512 decimate_score
    
    Also drop the MMX versions and improve the SSE2, SSSE3 and AVX2 versions.

commit 49fb50a67cc41e4bed2dd66f7beed12797249cd9
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon May 1 14:55:45 2017 +0200

    x86: AVX-512 pixel_var2_8x8 and 8x16

commit 92c074e27f6bfccee42b41c183203b7b2763a94d
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon May 1 14:54:32 2017 +0200

    Rework pixel_var2
    
    The functions are only ever called with pointers to fenc and fdec and the
    strides are always constant so there's no point in having them as parameters.
    
    Cover both the U and V planes in a single function call. This is more
    efficient with SIMD, especially with the wider vectors provided by AVX2 and
    AVX-512, even when accounting for losing the possibility of early termination.
    
    Drop the MMX and XOP implementations, update the rest of the x86 assembly
    to match the new behavior. Also enable high bit-depth in the AVX2 version.
    
    Comment out the ARM, AARCH64, and MIPS MSA assembly for now.

commit 4c48f9e751e969188d606eb15aeada7f652c9db9
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Apr 29 14:26:40 2017 +0200

    x86: AVX-512 pixel_var_8x8, 8x16, and 16x16
    
    Make the SSE2, AVX, and AVX2 versions a bit faster.
    
    Drop the MMX and XOP versions.

commit 1cf7baa462ca52de7f07d6e4c795853900bb50bb
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Apr 28 21:35:25 2017 +0200

    x86: AVX-512 pixel_sa8d_8x8

commit 386050088a66aa66bcaebb9b6b4b0a2b6af76a73
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Apr 13 23:56:04 2017 +0200

    x86: AVX-512 pixel_satd
    
    Covers all variants: 4x4, 4x8, 4x16, 8x4, 8x8, 8x16, 16x8, and 16x16.

commit 2eceefe89fea91bbc7d5af2a1b4a9047d8da7805
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Apr 19 16:39:48 2017 +0200

    x86: AVX-512 deblock_strength
    
    Also drop the MMX version and make some slight improvements to the SSE2,
    SSSE3, AVX, and AVX2 versions.

commit 3081ffa1c540d1df05123e0fab1937985573ac78
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Apr 12 16:21:09 2017 +0200

    x86: AVX-512 plane_copy_deinterleave_v210

commit 95dc64c4efdf16404e58be9ff9da4e0acaa1a4b2
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Apr 9 20:34:28 2017 +0200

    x86: AVX-512 memzero_aligned
    
    Reorder some elements in the x264_t.mb.pic struct to reduce the amount
    of padding required.
    
    Also drop the MMX implementation in favor of SSE.

commit c0cd7650cb65164d183d8f77d0697b7569a52917
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Apr 7 21:34:40 2017 +0200

    x86: AVX and AVX-512 memcpy_aligned
    
    Reorder some elements in the x264_mb_analysis_list_t struct to reduce the
    amount of padding required.
    
    Also drop the MMX implementation in favor of SSE.

commit f29fbc6fd23e9bc2d800eb1246e8fa19a203b831
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Apr 6 16:06:34 2017 +0200

    x86: AVX-512 dequant_8x8_flat16

commit 40aca29a164d5e5e6589d507bdcae6717d72f6bf
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 4 20:54:12 2017 +0200

    x86: AVX-512 dequant_8x8

commit 74f7802bb7bd301299f8229a0552a7caf2b55434
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 4 20:01:26 2017 +0200

    x86: AVX-512 dequant_4x4

commit 3451ba3af49e58a720277615df3d8e4a4171986f
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Mar 28 22:59:56 2017 +0200

    x86: AVX-512 mbtree_propagate_cost
    
    Also make the AVX and AVX2 implementations slightly faster.

commit 75f6f9b228c3498b8c9b0d97fc925c0a7e6e6f43
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Mar 27 18:19:53 2017 +0200

    x86: AVX-512 coeff_last

commit c3a1d1d892a79bc460c7fc192b0bf7a32c2ce0b2
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Mar 26 18:29:37 2017 +0200

    x86: AVX-512 zigzag_interleave_8x8_cavlc

commit edb22f57ba03718c1cb9781ba005aec20a1e50e0
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Mar 26 11:34:18 2017 +0200

    x86: AVX-512 zigzag_scan_8x8_field

commit 77b9a818fc622d0cdaa96aeb37339fbd5b1ef857
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Mar 25 22:13:22 2017 +0100

    x86: AVX-512 zigzag_scan_4x4_field

commit 724a577237f27cdb0c0fd18ef8ed32d39430796b
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Mar 25 19:14:28 2017 +0100

    x86: AVX-512 zigzag_scan_8x8_frame
    
    The vperm* instructions ignores unused bits, so we can pack the permutation
    indices together to save cache and just use a shift to get the right values.

commit 2b2f039512bde7c097280255c6376cf9a901e08e
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Mar 25 19:14:22 2017 +0100

    x86: AVX-512 zigzag_scan_4x4_frame

commit 1878c7f2af0a9c73e291488209109782c428cfcf
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri May 12 00:03:10 2017 +0200

    checkasm: x86: More accurate ymm/zmm measurements
    
    YMM and ZMM registers on x86 are turned off to save power when they haven't
    been used for some period of time. When they are used there will be a
    "warmup" period during which performance will be reduced and inconsistent
    which is problematic when trying to benchmark individual functions.
    
    Periodically issue "dummy" instructions that uses those registers to
    prevent them from being powered down. The end result is more consitent
    benchmark results.

commit 472ce3648aea3ddc16b7716eb114f4bcdb8fea8f
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Mar 25 10:16:09 2017 +0100

    x86: AVX-512 support
    
    AVX-512 consists of a plethora of different extensions, but in order to keep
    things a bit more manageable we group together the following extensions
    under a single baseline cpu flag which should cover SKL-X and future CPUs:
     * AVX-512 Foundation (F)
     * AVX-512 Conflict Detection Instructions (CD)
     * AVX-512 Byte and Word Instructions (BW)
     * AVX-512 Doubleword and Quadword Instructions (DQ)
     * AVX-512 Vector Length Extensions (VL)
    
    On x86-64 AVX-512 provides 16 additional vector registers, prefer using
    those over existing ones since it allows us to avoid using `vzeroupper`
    unless more than 16 vector registers are required. They also happen to
    be volatile on Windows which means that we don't need to save and restore
    existing xmm register contents unless more than 22 vector registers are
    required.
    
    Also take the opportunity to drop X264_CPU_CMOV and X264_CPU_SLOW_CTZ while
    we're breaking API by messing with the cpu flags since they weren't really
    used for anything.
    
    Big thanks to Intel for their support.

commit d2b5f4873e2147452a723b61b14f030b2ee760a5
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Mar 18 18:50:36 2017 +0100

    x86: Change assembler from yasm to nasm
    
    This is required to support AVX-512.
    
    Drop `-Worphan-labels` from ASFLAGS since it's enabled by default in nasm.
    
    Also change alignmode from `k8` to `p6` since it's more similar to `amdnop`
    in yasm, e.g. use long nops without excessive prefixes.

commit 8c2974255b01728d4eda2434cc1997c4a3ca5eff
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat May 6 12:26:56 2017 +0200

    x86: Add some additional cpuflag relations
    
    Simplifies writing assembly code that depends on available instructions.
    
    LZCNT implies SSE2
    BMI1 implies AVX+LZCNT
    AVX2 implies BMI2
    
    Skip printing LZCNT under CPU capabilities when BMI1 or BMI2 is available,
    and don't print FMA4 when FMA3 is available.

commit 93bc2cbc66f0bf4616965dcd7e0eba89201c8086
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Apr 14 16:16:49 2017 +0200

    x86: Faster SSE2 pixel_sad_16x16 and 16x8
    
    Also make the order of fenc/fdec arguments a bit more consistent.

commit 8ae2b62462176cd731a1cb8b5bdc9a38cba0fbe4
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon May 15 00:40:52 2017 +0300

    msvs/icl: Improve target host detection

commit 181a920ad5d0acdc3a08418c0e9c95be4785b814
Author: Alexandra Hájková <alexandra@khirnov.net>
Date:   Sat May 13 17:14:52 2017 +0000

    ppc: Optimize add8x8_idct_dc
    
    Increases speedup compared to C from 2x to 6x.

commit d0b905b901c5ee5989777cf437a7f20c1fa0a794
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Feb 19 10:33:16 2017 +0100

    analyse: Faster min/max MV clipping
    
    Values only needs to be clipped in one direction.

commit 1bde30193eb91d1bc69b00a27e6874eb88ed4eab
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Feb 16 20:04:10 2017 +0100

    slicetype_mb_cost: Clip MVs based on MV range
    
    Improves cost calculations, especially when a short MV range is used.

commit dcf406978b9dda5c2b8aab80af5c1c47c78efd92
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jan 29 21:38:43 2017 +0100

    Support YUYV and UYVY packed 4:2:2 raw input
    
    Packed YUV is arguably more common than planar YUV when dealing with raw
    4:2:2 content.
    
    We can utilize the existing plane_copy_deinterleave() functions with some
    additional minor constraints (we cannot assume any particular alignment
    or overread the input buffer).
    
    Enables assembly optimizations on x86.

commit aaa9aa83a111ed6f1db253d5afa91c5fc844583f
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Apr 20 21:58:23 2017 +0200

    x86: Utilize 3-arg instructions in AVX deblock
    
    Avoids some redundant register-register moves.

commit a52d41c4d135c79373a86c3a82dcc2ec3f88b025
Author: Martin Storsjö <martin@martin.st>
Date:   Fri Mar 24 11:33:46 2017 +0200

    configure: Support targeting ARM with MSVC tools
    
    Set up the right gas-preprocessor as assembler frontend in these cases,
    using armasm as actual assembler.
    
    Don't try to add the -mcpu -mfpu options in this case.
    
    Check whether the compiler actually supports inline assembly.
    
    Check for the ARMv7 features in a different way for the MSVC compiler.

commit b22a5db3c481b10b4a6ec190978d97b377750a12
Author: Martin Storsjö <martin@martin.st>
Date:   Fri Mar 24 11:33:45 2017 +0200

    configure: Check for -lshell32 before forcibly adding it into LDFLAGSCLI
    
    When targeting the Windows Phone API subset, there is no shell32.lib.
    
    When targeting Windows Phone/RT, the CLI itself won't be built, but
    LDFLAGSCLI are included in all later cases of cc_check within configure.
    Therefore only add -lshell32 there if it actually is usable.

commit 0aed59e74808f1cd22ee47c055a8eb4f367b2f55
Author: Martin Storsjö <martin@martin.st>
Date:   Thu May 4 22:00:51 2017 +0300

    arm: Always unconditionally declare .arch armv7-a
    
    We already unconditionally declare .fpu neon and try to build all the
    neon codepaths (but only execute them conditionally based on a runtime
    check).
    
    This fixes builds targeting armv6, where the rbit instruction isn't
    available. This instruction is only used within a neon function in
    any case, so there's little point in emulating it.

commit 196d7676c8f40b7c1f8f2f4af64e09ebf4c9816b
Author: Martin Storsjö <martin@martin.st>
Date:   Fri Mar 24 11:33:44 2017 +0200

    arm: Use .section .rodata for non-elf, non-mach platforms as well
    
    If targeting windows with armasm, gas-preprocessor can rewrite the
    .section .rodata into the right construct for that platform.

commit 9bffbabfecf0bda066362a1b76b62c5085257e18
Author: Martin Storsjö <martin@martin.st>
Date:   Fri Mar 24 11:33:41 2017 +0200

    gas-preprocessor: Support conversion of additional arm instructions into thumb
    
    Convert muls into mul+cmp.
    
    Convert "and r0, sp, #xx" into "mov r0, sp", "and r0, r0, #xx".
    
    Convert ldr with a too large shift into add+ldr. This only works in the
    special case when the base register is the same as the target for the ldr.

commit 2e9bd88f27ed8f5f058e7e220070b7a15965cb8e
Author: Martin Storsjö <martin@martin.st>
Date:   Fri Mar 24 11:33:40 2017 +0200

    arm: Explicitly declare using the .text segment in the function macro
    
    This fixes one issue in building with MS armasm via gas-preprocessor.
    Without the .text segment specification, the object files assembled
    fine, but linking failed. (armasm source files don't get the text/code
    segment implied automatically if nothing is specified.)

commit 64843af913e76fd7fb590e9227f678add96e8a3c
Author: Martin Storsjö <martin@martin.st>
Date:   Fri Mar 24 11:33:39 2017 +0200

    osdep: Use the EXPAND macro on other cases of ALIGNED_ARRAY_EMU
    
    EXPAND is already used on the other cases where ALIGNED_ARRAY_EMU
    is used on all platforms (originally needed for ICL, later also
    required by MSVC); apply the same change (originally from 21ba91ae)
    for the cases that only are used on ARM.
    
    This fixes use of ALIGNED_ARRAY_16 with MSVC when targeting ARM.

commit 757091fe3abd0af0f45d11f52b652f0be2fb76f5
Author: Martin Storsjö <martin@martin.st>
Date:   Fri Mar 24 11:33:38 2017 +0200

    Update to the latest version of gas-preprocessor.pl
    
    From http://git.libav.org/?p=gas-preprocessor.git
    
    This update contains changes from myself only.

commit d13705191cdcbcd10d87524dbb0c26ba998d8dcc
Author: Martin Storsjö <martin@martin.st>
Date:   Fri Mar 24 11:33:37 2017 +0200

    arm: Skip using gas-preprocessor for iOS on arm as well
    
    The few constructs that differ can easily be handled within the
    source itself - tested to be working since at least Xcode 6.

commit 3a3cfe32416efa4f966c0586411148236e4703c1
Author: Martin Storsjö <martin@martin.st>
Date:   Fri Mar 24 11:33:36 2017 +0200

    arm: Use const macros in arm assembly where applicable
    
    This unifies the source code style, and allows building the code
    with clang without gas-preprocessor.

commit 1e92821c5a52c80ca4d1a9b6d038bec84be48b0a
Author: Martin Storsjö <martin@martin.st>
Date:   Fri Mar 24 11:33:35 2017 +0200

    arm: Use commas between all macro arguments in arm assembly
    
    The clang built-in assembler requires proper commas between all macro
    arguments. As long as gas-preprocessor is used when building with clang,
    this isn't an issue.

commit a84e6a486b991bffb2cc9f86b6e236978d251d2c
Author: Martin Storsjö <martin@martin.st>
Date:   Fri Mar 24 11:33:34 2017 +0200

    aarch64: Skip invoking gas-preprocessor for iOS
    
    Clang can handle all the constructs used there these days, working
    since Xcode 6 at least.

commit 535fd2ec9985b9874d6ed23904404d0d2f5d40d6
Author: Martin Storsjö <martin@martin.st>
Date:   Fri Mar 24 11:33:33 2017 +0200

    aarch64: Use the const macro in the aarch64 checkasm assembly source
    
    This fixes building the source with clang for iOS without gas-preprocessor.

commit bec87ba69421572282e473cf8f2e11c77285ed88
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Apr 12 23:26:32 2017 +0200

    Windows: Add support for MSVC compilation with WSL
    
    In Windows 10 version 1703 (Creators Update) WSL supports calling native
    Windows binaries from the Bash shell, but it requires using full file
    names including extension, e.g. `cl.exe` instead of `cl`.
    
    We also don't have access to `cygpath`, so use a simple regex for
    converting the dependencies to Unix paths that `make` can understand.

commit 43e9a6157752c2a3c2cc6c6a7fa13da72033d1dd
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jan 29 22:58:24 2017 +0100

    cli: Improve the --fullhelp raw demuxer input-csp listing
    
    Use the same logic for indentation as the lavf demuxer.

commit 3538df12688fc4408f585c4e65ee92d5a4737b2c
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat May 20 21:17:59 2017 +0300

    x86inc: Remove argument from WIN64_RESTORE_XMM
    
    The use of rsp was pretty much hardcoded there and probably didn't work
    otherwise with stack_size > 0.

commit e4b0974a4ea3a727f6cc8941e9accf7ef3ba0637
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Apr 22 20:30:35 2017 +0200

    x86inc: Prefer r14/r15 over r12/r13 on x86-64
    
    Due to a peculiarity in the ModR/M addressing encoding, the r12 and r13
    registers sometimes requires an additional byte when used as a base register.
    
    r14 and r15 doesn't have that issue, so prefer using them.

commit 46a489b5e21cae3b4fea5d41cc285dcaf79d19e3
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Apr 20 19:16:51 2017 +0200

    x86inc: Make REP_RET identical to RET in SSSE3+ functions
    
    There's no point in emitting a rep prefix before ret on modern CPUs.

commit 50a9dd78263191474c948d53e837348abd0bf316
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Mar 29 16:43:57 2017 +0200

    x86inc: Fix call with memory operands
    
    We overload the `call` instruction with a macro, but it would misbehave when
    the macro argument wasn't a valid identifier. Fix it by explicitly checking
    if the argument is an identifier.

commit d13b4c3a9574cd2fbd5407c7dfc58eeff72d2080
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jan 29 16:41:33 2017 +0100

    osdep: Rework alignment macros
    
    Drop ALIGNED_N and ALIGNED_ARRAY_N in favor of using explicit alignment.
    
    This will allow us to increase the native alignment without unnecessarily
    increasing the alignment of everything that's currently 32-byte aligned.

commit 5840e200a0f1869a0596c5ed75c76f4d3221dd68
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Mon Jan 30 22:14:57 2017 +0100

    Move cabac_block_residual function declarations

commit a2d2621cc5741414b1f1adfbc08f19f1cc763847
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Mon Jan 30 22:14:59 2017 +0100

    Recursively delete conftest files
    
    On OS X, one of the conftest files might be a directory named `conftest.dSYM`.

commit 988ce459433fd3f978d632e8fc0ef9c19c94a6a1
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Mon Jan 30 22:14:56 2017 +0100

    Drop unused function declarations

commit fb3f97833cbe3305eb613633e604f424d6d2d096
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Fri Jan 27 18:06:39 2017 +0100

    x86: Adjust cache64_ssse3 function suffixes
    
    Makes those function names more consistent with other similar functions.

commit a77f3917cc6ba5e1d3c20ca649d4114217976d53
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Fri Jan 27 16:21:16 2017 +0100

    mc: Mark a function only used within the file as static

commit 0ca36bfa3d2bf272da88b1df5abfc0406662989a
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Fri Jan 27 16:21:15 2017 +0100

    ppc: Drop two unused static functions

commit d32d7bf1c6923a42cbd5ac2fd540ecbb009ba681
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri May 19 16:08:34 2017 +0200

    cli: Verify that yuv/y4m input has at least one frame of data
    
    Prevents a SIGBUS crash caused by attempting to access a memory-mapped
    region beyond the end of the input file.

commit 959e869c20ea151917695930d9ad0a7a9a2f90c5
Author: Kaustubh Raste <kaustubh.raste@imgtec.com>
Date:   Fri Apr 14 15:29:31 2017 +0530

    mips: Fix out-of-tree build
    
    Signed-off-by: Kaustubh Raste <kaustubh.raste@imgtec.com>

commit d6eb2c9630d40a2765d5092f87637f4e4d084ed1
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Mar 25 00:02:11 2017 +0100

    checkasm: Fix load_deinterleave_chroma_fdec test
    
    The function only writes to parts of the destination buffer but the test
    verifies the content of the entire buffer. The problem is that some earlier
    IDCT functions clobbers the same part of the buffer with garbage when
    benchmarked which would incorrectly cause test failures.
    
    Fix this by explicitly zeroing the buffers beforehand.

commit a472b60daae0cac17d91ddf62ad4f474ded63e5b
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Mar 24 22:27:42 2017 +0100

    checkasm: Fix compilation on hardened x86-64 ELF systems
    
    Normal PC-relative relocations cannot be used for resolving the address of
    external symbols on systems where ASLR results in the offset being larger
    than 32 bits. We are required to to go through the PLT instead.

commit 469ad705b1064207b6b1068d1e25a0a591021007
Author: Martin Storsjö <martin@martin.st>
Date:   Thu Mar 23 15:05:38 2017 +0200

    aarch64: Fix building checkasm for iOS
    
    On iOS, symbols are prefixed - this prefix gets added by the X()
    macro.

commit 93340ca300e7ce66f49e41b7c2ef4a0492a7e57c
Author: Martin Storsjö <martin@martin.st>
Date:   Thu Mar 23 15:05:37 2017 +0200

    configure: Always enable PIC in aarch64 assembly for apple platforms
    
    This is similar to what we do for 32-bit ARM assembly as well.
    
    Fixes linker errors such as `ld: Absolute addressing not allowed in
    arm64 code but used in '_x264_cabac_encode_terminal_asm' referencing
    '_x264_cabac_range_lps' for architecture arm64`.

commit 90a61ec76424778c050524f682a33f115024be96
Author: Alexandra Hájková <alexandra@khirnov.net>
Date:   Mon Dec 5 10:28:53 2016 +0000

    ppc: AltiVec plane_copy_deinterleave

commit bd6b66dbf9fcf67b7ebb23e4e9249083191fb984
Author: Alexandra Hájková <alexandra@khirnov.net>
Date:   Mon Jan 2 12:56:48 2017 +0000

    ppc: AltiVec plane_copy_deinterleave_v210

commit 00f1670087db1b025a8088289de8938bf88a0d8b
Author: Alexandra Hájková <alexandra@khirnov.net>
Date:   Wed Dec 7 19:48:02 2016 +0000

    ppc: AltiVec plane_copy_deinterleave_rgb
    
    Also add some missing vector types in ppccommon.h

commit 5e1ed367d725f895eeadf358861ab52521a420d3
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Thu Jan 19 17:43:57 2017 +0100

    ppc: Adjust AltiVec function suffix
    
    Architecture should always be the last element.

commit 28ebb95d92278069b80ee729eb1884fe0981c6ae
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Mon Jan 9 22:28:20 2017 +0100

    Move the x264_mdate() declaration to the appropriate header

commit 1d2420981aa004f051a0869c005776084f7d2a44
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Tue Jan 17 17:04:19 2017 +0100

    arm/aarch64: Correctly prefix integral function symbols

commit 4c4c495d58dbdea46a23947e4f202fc3b82fb891
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Jan 13 14:57:51 2017 +0100

    x86: Avoid using hardcoded function symbol prefixes

commit 2524fc3164d9f00b393d4254d2c5ea8f3b9d43b0
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Jan 18 21:57:14 2017 +0100

    x86: AVX2 high bit-depth load_deinterleave_chroma
    
    load_deinterleave_chroma_fenc: 50% faster than AVX
    load_deinterleave_chroma_fdec: 25% faster than AVX

commit cce50082129d3c92bd41bc0afc5a8c8d93084c9c
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Jan 18 21:46:55 2017 +0100

    x86: AVX2 load_deinterleave_chroma_fenc
    
    20% faster than SSSE3.

commit c22c10ddb21e9f5af1da83d37122e6f7388e1342
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Jan 17 21:59:47 2017 +0100

    x86: AVX2 plane_copy_deinterleave
    
    50% faster than SSSE3 in 8-bit.
    25% faster than AVX in high bit-depth.
    
    Also drop the MMX versions of deinterleave functions in favor of SSE2.

commit f4890275ca6523dfe5b4ae60279ae8597d9dbd4b
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Jan 12 22:16:53 2017 +0100

    x86: AVX2 plane_copy_deinterleave_rgb
    
    Around 15% faster than SSSE3.

commit da71b556730c8eb6c12a0d6950a221a4e4a99ca6
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Jan 12 21:36:28 2017 +0100

    x86: Faster plane_copy_deinterleave_rgb_sse2
    
    50% faster than the previous SSE2 function.

commit 3c7bf52c5b0a849458a45b5628ed1cc4b898da5f
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jan 15 14:52:29 2017 +0100

    x86util: Reduce code size of high bit-depth AVX LOAD_DIFF
    
    AVX supports unaligned memory operands which makes the SATD code a bit denser.

commit c7a2e327bebd2b863c2620b6962fa18ab681e5dd
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jan 1 19:10:10 2017 +0100

    Bump dates to 2017

commit 97eaef2ab82a46d13ea5e00270712d6475fbe42b
Author: Alexandra Hájková <alexandra@khirnov.net>
Date:   Sat Jan 21 12:34:49 2017 +0000

    ppc: Fix the pre-VSX vec_vsx_st() fallback macro
    
    It would previously only work correctly with 8-bit data types.
    
    Fixes compilation with --disable-vsx.

commit 2ebe09a4f583d108c6ec1caf70b2a7a289a8820d
Author: Alexandra Hájková <alexandra@khirnov.net>
Date:   Wed Jan 18 09:13:39 2017 +0000

    Fix plane_copy_deinterleave_v210 on big-endian

commit 79288d90471e246584d19054bdb5381982114126
Author: Alexandra Hájková <alexandra@khirnov.net>
Date:   Wed Dec 21 13:13:43 2016 +0000

    ppc: Avoid instantiating unused plane_copy functions
    
    Those functions are currently only used in 8-bit mode and results in
    warnings in other bit depths.

commit 2ebdb90bd32c3d1618b1c5b360bff750b82b1d0b
Author: Martin Storsjö <martin@martin.st>
Date:   Tue Dec 27 00:22:48 2016 +0200

    arm: Load mb_y properly in mbtree_propagate_list_internal_neon
    
    The previous version, attempting to load two stack parameters at once,
    only would have worked if they were interpreted and loaded as 32 bit
    elements, not when loading them as 16 bit elements.

commit b97ae0644f16bad2e2c9c9181264a946769a0aa0
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Oct 31 14:39:52 2016 +0300

    analyse: Fix lambda table values

commit b2b39dae0bd891c8d150b4f4c3a2a24d8d6c1431
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat Nov 26 15:30:58 2016 +0300

    Cosmetics
    
    Also make x264_weighted_reference_duplicate() static.

commit 9c82d2b65534e477c972b811a4dd5004d0dd262e
Author: Alexandra Hájková <alexandra@khirnov.net>
Date:   Mon Nov 28 14:04:10 2016 +0000

    ppc: AltiVec store_interleave_chroma

commit ea1fee272b20e1bcff2a862ea9a29e151c9136a9
Author: Alexandra Hájková <alexandra@khirnov.net>
Date:   Mon Nov 28 10:51:54 2016 +0000

    ppc: AltiVec plane_copy_interleave

commit 42348a8e664b091203a05d3e15555b5085afcac1
Author: Alexandra Hájková <alexandra@khirnov.net>
Date:   Sat Nov 26 20:03:34 2016 +0000

    ppc: AltiVec plane_copy_swap

commit 2610019af8bfb8e71f813cd2188b9eccbc287c59
Author: Alexandra Hájková <alexandra@khirnov.net>
Date:   Wed Nov 23 20:53:51 2016 +0100

    ppc: AltiVec zigzag_interleave_8x8_cavlc

commit 25e4e06fe8151f627a953fbd2bd39302436bf689
Author: Alexandra Hájková <alexandra@khirnov.net>
Date:   Wed Nov 23 20:53:50 2016 +0100

    ppc: AltiVec zigzag_scan_8x8_frame

commit 99863c665a6d4ec58b7fcc4a8a791e9c8f35a86e
Author: Alexandra Hájková <alexandra@khirnov.net>
Date:   Mon Nov 14 15:06:06 2016 +0100

    ppc: AltiVec sub8x8_dct_dc

commit 42cb0a6813714b5380e23871a155e3820846d991
Author: Alexandra Hájková <alexandra@khirnov.net>
Date:   Mon Nov 14 15:06:05 2016 +0100

    ppc: AltiVec add8x8_idct_dc

commit 983acc911543453449a65bd02bbdff4c8cfe8e6a
Author: Martin Storsjö <martin@martin.st>
Date:   Wed Nov 16 10:57:31 2016 +0200

    checkasm: aarch64: Add filler args to make sure all parameters are passed on the stack
    
    This, combined with clobbering the stack space prior to the call,
    increases the chances of finding cases where 32 bit parameters
    are erroneously treated as 64 bit.

commit 8ada354c9b5d72356c34c9ae3f787a6df4d61506
Author: Martin Storsjö <martin@martin.st>
Date:   Wed Nov 16 10:57:30 2016 +0200

    checkasm: aarch64: Clobber the stack before calling functions

commit 62d604ac6dddbf553c1ff2432d899b61cc50d95a
Author: Alexandra Hájková <alexandra@khirnov.net>
Date:   Tue Nov 1 23:16:17 2016 +0100

    ppc: Use vec_vsx_ld instead of VEC_LOAD/STORE macros
    
    Remove VEC_LOAD*, some of VEC_STORE* macros, some PREP* macros and
    VEC_DIFF_H_OFFSET macro.
    
    Make sure the functions do not use deprected primitives.

commit 16142d8ee2a974060ecbad0f495b5a5c6516a75e
Author: Luca Barbato <lu_zero@gentoo.org>
Date:   Tue Nov 1 23:16:16 2016 +0100

    ppc: Provide fallbacks for older architectures

commit 2b741f81e51f92d053d87a49f59ff1026553a0f6
Author: Luca Barbato <lu_zero@gentoo.org>
Date:   Tue Nov 1 23:16:14 2016 +0100

    ppc: Add VSX support to configure

commit 1f7518182e3204cb14e87baffb0150a848167ddc
Author: Luca Barbato <lu_zero@gentoo.org>
Date:   Tue Nov 1 23:16:13 2016 +0100

    ppc: Manually unroll the horizontal prediction loop
    
    Doubles the speedup from the function (from being slower to be over
    twice as fast than C).

commit 0706ddb1df88d716cf73decba4d82b953011760c
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Oct 8 17:20:18 2016 +0200

    x86inc: Avoid using eax/rax for storing the stack pointer
    
    When allocating stack space with an alignment requirement that is larger
    than the current stack alignment we need to store a copy of the original
    stack pointer in order to be able to restore it later.
    
    If we chose to use another register for this purpose we should not pick
    eax/rax since it can be overwritten as a return value.

commit 4d5c8b01a48f72f9c40651e92c39294326a0863f
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Dec 1 16:05:16 2016 +0100

    Show the correct settings for --preset slow in --fullhelp
    
    The slow preset was recently adjusted but we forgot to update the
    corresponding --fullhelp message to reflect the change.

commit c996ed202e2d17d1d8ae42c42d0707e51c29bb93
Author: Martin Storsjö <martin@martin.st>
Date:   Mon Nov 14 23:54:51 2016 +0200

    checkasm: arm/aarch64: Fix the amount of space reserved for stack parameters
    
    Even if MAX_ARGS - 2 (for arm) or MAX_ARGS - 6 (for aarch64) parameters
    are passed on the stack to checkasm_checked_call, we actually only
    need to store MAX_ARGS - 4 (for arm) or MAX_ARGS - 8 (for aarch64)
    parameters on the stack when calling the tested function.

commit cd15b354a887943d525e6fd8096ad4b75692d2b2
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Mon Nov 14 23:54:50 2016 +0200

    checkasm: arm: preserve the stack alignment in x264_checkasm_checked_call
    
    The stack used by x264_checkasm_checked_call_neon was a multiple of 4
    when the checked function is called. AAPCS requires a double word (8 byte)
    aligned stack public interfaces. Since both calls are public interfaces
    the stack is misaligned when the checked is called.
    
    This can cause issues if code called within this (which includes
    the C implementations) relies on the stack alignment.

commit 834e1b11e174f2694a4c81b4922c0c5f8778796a
Author: Martin Storsjö <martin@martin.st>
Date:   Wed Nov 16 10:56:14 2016 +0200

    arm: Don't use vcmp.f64 for testing for an all-zeros register
    
    On iOS, vcmp.f64 can behave as if the register was zero, if the
    register (interpreted as a f64), was a denormal number.
    
    The vcmp.f64 (and other VFP instructions) will trap to the kernel
    (which is supposed to implement the FP operation, which it apparently
    doesn't do properly on iOS) if the value is a denormal. If this happens,
    the whole comparison ends up way more costly.

commit a91e95fca2222ac0731e987a07f4b11c670f4556
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Wed Nov 16 10:49:14 2016 +0200

    aarch64: Clear the upper half of int parameters in x264_plane_copy_core_neon

commit 1eab3b402e1d7729da295024fa7eec8b09e30c20
Author: Luca Barbato <lu_zero@gentoo.org>
Date:   Tue Nov 1 23:16:18 2016 +0100

    ppc: Fix hadamard for little-endian
    
    Extending to 16-bit works with flipped bytes.

commit 75918e1849e1286885bfcfb0c348de885a702fb3
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Sep 22 00:17:48 2016 +0300

    Correctly signal max_dec_frame_buffering with --keyint 1
    
    According to E.2.1 it is inferred to be equal to 0 only if profile_idc is equal
    to 44, 86, 100, 110, 122, or 244 and constraint_set3_flag is equal to 1.

commit 72d53ab2ac7af24597a824e868f2ef363a22f5d4
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Sep 17 21:41:52 2016 +0200

    x86: Faster pixel_ssim_4x4x2_core

commit 8c07263ad9218bdc3e0f5b84d578968513885df7
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Sep 17 21:14:35 2016 +0200

    x86: Deduplicate a constant in hpel_filter_c

commit 9521b278adb92081f052c1b7bfc4b95651d88b07
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Sep 17 14:45:08 2016 +0200

    x86: Faster pixel_ssd_nv12
    
    Also drop the MMX2 version to simplify things.

commit 75d0f9cc8770bc4f36785062116757d24eb44604
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Sep 11 15:32:54 2016 +0200

    x86: SSE zigzag_scan_4x4_field
    
    Replaces the MMX2 version, one cycle faster.
    
    Also change the checkasm test to use the correct alignment macro.

commit 0ce77f9eb71051c9a6121ec12c2abaac99ee628a
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Sep 7 19:27:31 2016 +0200

    x86: AVX2 mbtree_propagate_list
    
    SIMD part is around 25% faster than AVX on Haswell, around 7%
    faster when including the runtime of the scalar C wrapper.

commit 0c36239a4826f6e5a3cb873aca1814e389a46e29
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Sep 7 19:26:42 2016 +0200

    x86: Move predict_16x16_dc_left calculations to asm
    
    1-2 cycles faster and avoids some code duplication to decrease code size.
    
    Also drop the MMX2 implementation in favor of SSE2 to simplify things.

commit 0cc8afd31212de013b26b10f58c608c9adcff2fc
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Aug 18 19:00:48 2016 +0300

    avs: support for AviSynth+ high bit-depth pixel formats

commit dc0fe73636d34baeb3a64918b52db64d2a9e83bb
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Fri Aug 26 20:26:56 2016 +0300

    aarch64: implement x264_plane_copy_swap_neon
    
    plane_copy_swap_c: 27054
    plane_copy_swap_neon: 4152

commit eaf2fc20c8579714a48523b7ab8c05373708a25f
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Aug 18 22:14:22 2016 +0300

    Various cosmetics of semicolon use

commit aae177c55141460f442de0572c4a434bf2ae20bc
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Jul 28 21:58:40 2016 +0200

    cli: Prefetch yuv/y4m input frames on Windows 8 and newer
    
    Use PrefetchVirtualMemory() (if available) on memory-mapped input frames.
    
    Significantly improves performance when the source file is not already
    present in the OS page cache by asking the OS to bring in those pages from
    disk using large, concurrent I/O requests.
    
    Most beneficial on fast encoding settings. Up to 40% faster overall with
    --preset ultrafast, and up to 20% faster overall with --preset veryfast.
    
    This API was introduced in Windows 8, so call it conditionally. On older
    Windows systems the previous behavior remains unchanged.

commit 4e5adb87070c82b937c03e0cc030eae3578c251d
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Jul 28 19:34:04 2016 +0200

    Adjust --preset slow
    
     * Swap --me umh for --trellis 2. They have a similar effect on performance
       but the latter gives slightly better results in most cases.
     * Change --b-adapt from 2 to 1. Negligible difference in quality since the
       b-adapt 1 improvements, but it's significantly faster.
    
    Also remove a redundant assignment from veryfast (--me hex is set by default).

commit 1e4fb55a283ba90fef346033027af851f2a04468
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Jul 28 19:33:57 2016 +0200

    ratecontrol_new: Simplify an expression in HRD timescale calculation
    
    Also gets rid of a false positive static analyser integer division warning.

commit 17378b2028146fa54a1b2b90da62554935d9dcc2
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Jul 28 19:33:44 2016 +0200

    gcc: Enable __sync_fetch_and_add() on x86-64
    
    It was previously only enabled on 32-bit x86 for no reason, so 64-bit
    systems had to use a mutex instead of a simple `lock xadd` instruction.
    
    Note that this code is only used in some very specific configurations
    involving sliced threads.

commit 86b71982e131eaa70125f8d0e725fcade9c4c677
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Sep 20 18:48:22 2016 +0300

    mips: Fix high bit-depth compilation

commit 1ea3c682ca12c7f13ea6f82b42bdc40afcfda87f
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Sep 17 15:53:59 2016 +0200

    checkasm: Fix compilation on Windows with --disable-thread

commit 5caef139cf7d6b41a95ee9568625d36d1ae1c107
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Fri Aug 26 20:26:55 2016 +0300

    arm/aarch64: use plane_copy wrapper macros
    
    Move the macros to common/mc.h to share them across all architectures.
    Fixes possible buffer overreads if the width of the user supplied frames
    is not a multiple of 16.
    
    Reported-by: Kirill Batuzov <batuzovk@ispras.ru>

commit 3f5ed56d4105f68c01b86f94f41bb9bbefa3433b
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Apr 3 17:28:33 2016 +0200

    configure: Support specifying a custom pkg-config

commit 7c9c687d8062f72b3ec300de8997bdae8277a741
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed Jun 8 22:46:17 2016 +0300

    Add support for new VUI parameters
    
    Support the new color primaries, transfer characteristics, and matrix
    coefficients defined in the 2016-02 edition of the H.264 specification.

commit 92515e8ff73491ef8a44c85e0bee265ba5791070
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Apr 24 14:10:22 2016 +0200

    configure: Add link-time optimization support
    
    Enabled by using the --enable-lto configuration option.
    
    May give a slight performance improvement in some cases, but it can
    also reduce performance in other cases (largely compiler-dependant)
    so don't enable it by default. It also makes compilation (and linking
    in particular) a fair bit slower.
    
    Note that some older versions of GNU binutils will incorrectly warn
    about "memset used with constant zero length parameter" when linking
    using LTO. This is due to a bug in binutils and can safely be ignored.

commit b6267e0ff770545de88dfb5d3f176ea73f453730
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Apr 24 13:32:43 2016 +0200

    configure: Fix clang detection with versioned binaries
    
    Correctly detect clang binaries that has the version number appended
    as a suffix to the file name, e.g. `clang38`.

commit 14a58532fea2c5f9e7b93c918476d842091c4268
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Sun Apr 24 14:38:56 2016 +0200

    arm: Add asm for mbtree fixed point conversion
    
    7-8 times faster on a cortex-a53 vs. gcc-5.3.
    
    mbtree_fix8_pack_c: 44114
    mbtree_fix8_pack_neon: 5805
    mbtree_fix8_unpack_c: 38924
    mbtree_fix8_unpack_neon: 4870

commit b6f189eb4c5646483f7901293944695167e71ed9
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Sun Apr 24 14:38:55 2016 +0200

    aarch64: Add asm for mbtree fixed point conversion
    
    pack is ~7 times faster and unpack is ~9 times faster on a cortex-a53
    compared to gcc-5.3.
    
    mbtree_fix8_pack_c: 41534
    mbtree_fix8_pack_neon: 5766
    mbtree_fix8_unpack_c: 44102
    mbtree_fix8_unpack_neon: 4868

commit a5e06b9a435852f0125de4ecb198ad47340483fa
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun May 22 22:33:58 2016 +0300

    Fix p4x4 analyse for 4:4:4 encoding with chroma ME

commit 07221290db0a94bda1f6ece3fdf3c02675c8adce
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun May 22 22:18:34 2016 +0300

    Fix 4:4:4 encoding with CQM

commit 23ebc1f763936b7fcfc81e21530e1b65dbc503b9
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun May 22 19:36:05 2016 +0300

    Fix p4x4 RDO with CAVLC

commit 740a8c556bd9b68e899d6991f3f987a443aa14aa
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat Apr 23 23:10:03 2016 +0300

    Apply zone options a little bit earlier
    
    This way things like SAR changes will have full effect from the start frame.

commit 928bd9d5def4f0ca5071ea176a11b816a01e6495
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat Apr 23 22:45:44 2016 +0300

    Fix corruption when using encoder_reconfig() with some parameters
    
    Changing parameters that affects SPS, like --ref for example, wasn't
    behaving correctly previously.
    
    Probably a regression in r2373.

commit 3b70645597bea052d2398005bc723212aeea6875
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed Apr 13 21:54:25 2016 +0300

    Clean up header includes

commit 2102de2584e03fce4abac49eb37d5d7a0803380f
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Apr 13 17:53:49 2016 +0200

    Eliminate some compiler warnings on BSD
    
    Include <strings.h> in addition to <string.h>. According to the POSIX
    specification the prototypes for strcasecmp() and strncasecmp() are
    declared in <strings.h>. On some systems they are also declared in
    <string.h> for compatibility reasons but we shouldn't rely on that.
    
    Define _POSIX_C_SOURCE only when it's required to do so. Some BSD
    variants doesn't declare certain function prototypes otherwise.

commit 64f4e24909924fceeea6e154d71b7dfbf586c7ea
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 12 21:33:54 2016 +0200

    osx: Add -D_DARWIN_C_SOURCE to CFLAGS
    
    OSX doesn't like _POSIX_C_SOURCE being defined when _DARWIN_C_SOURCE isn't.

commit 00597d74c6223f3694e2c6614ef0574d7fca6b22
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Apr 12 20:33:42 2016 +0300

    Remove an unused parameter from x264_slicetype_frame_cost()
    
    The b_intra_penalty parameter is no longer used anywhere after the
    improvements to the --b-adapt 1 algorithm.

commit aa26e880bc2cd04cc81c776051d5e21d03fc975a
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Apr 10 20:17:32 2016 +0300

    Improve the --b-adapt 1 algorithm
    
    Roughly the same speed as before but with significantly better results,
    comparable to --b-adapt 2.

commit 24f25b6afd21488a93bd86098f98dfaf229fc149
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Apr 3 15:49:26 2016 +0200

    analyse: i_sub_partition write combining

commit 1507cfe80ecf5f8e240a35e9e9dc5a92bd25e792
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Mar 15 20:16:45 2016 +0100

    x86: Use one less register in mbtree_propagate_cost_avx2
    
    Avoids the need to save and restore xmm6 on 64-bit Windows.

commit c82c7374938f4342971adf8b2495c3a1bbe621c4
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Mar 4 17:53:08 2016 +0100

    x86: Add asm for mbtree fixed point conversion
    
    The QP offsets of each macroblock are stored as floats internally and
    converted to big-endian Q8.8 fixed point numbers when written to the 2-pass
    stats file, and converted back to floats when read from the stats file.
    
    Add SSSE3 and AVX2 implementations for conversions in both directions.
    
    About 8x faster than C on Haswell.

commit be677efc6313ade5eddf722fdf097cce56df1344
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Apr 7 13:09:03 2016 +0300

    x86inc: Enable AVX emulation in additional cases
    
    Allows emulation to work when dst is equal to src2 as long as the
    instruction is commutative, e.g. `addps m0, m1, m0`.

commit b5661d322866df647e6084061a471eceac214c28
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Apr 7 12:48:29 2016 +0300

    x86inc: Improve handling of %ifid with multi-token parameters
    
    The yasm/nasm preprocessor only checks the first token, which means that
    parameters such as `dword [rax]` are treated as identifiers, which is
    generally not what we want.

commit 283663d4c13088f4811c78b75318bda59d696b2d
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Mar 28 18:35:38 2016 +0300

    x86inc: Fix AVX emulation of some instructions

commit 54fd697668d0a04246ad0b0e9955a6583b2bb8b6
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Mar 4 17:51:41 2016 +0100

    x86inc: Fix AVX emulation of scalar float instructions
    
    Those instructions are not commutative since they only change the first
    element in the vector and leave the rest unmodified.

commit eeb9b66ddb0f27d8baaa8efa9597613e61140836
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Feb 27 20:34:39 2016 +0100

    x86: dct2x4dc asm
    
    Only used in 4:2:2. MMX2 version implemented for 8-bit, SSE2 and AVX
    versions implemented for high bit-depth.
    
    2.5x faster on 32-bit and 1.6x faster on 64-bit compared to C on Ivy Bridge.

commit 23d1d8e89be2d99f5c6924a6055fc80d69429503
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Feb 20 20:31:22 2016 +0100

    x86: SSE2/AVX idct_dequant_2x4_(dc|dconly)
    
    Only used in 4:2:2. Both 8-bit and high bit-depth implemented.
    
    Approximate performance improvement compared to C on Ivy Bridge:
    
                             x86-32  x86-64
    idct_dequant_2x4_dc      2.1x    1.7x
    idct_dequant_2x4_dconly  2.7x    2.0x
    
    Helps more on 32-bit due to the C versions being register starved.

commit dbbf1dd2836a21b65178442c1fb7a00ea089d7ec
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Feb 20 16:53:35 2016 +0100

    checkasm: Fix idct_dequant_2x4_(dc|dconly) tests
    
    They used the wrong qp values and the dconly test had the wrong name. This
    was undetected before because there wasn't any assembly implementations.

commit 0db0ac3a05b80eee7994fab08cbce2d07e8b1586
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Feb 7 14:55:26 2016 +0100

    checkasm: Disable Windows Error Reporting
    
    When developing new assembly code it's expected that checkasm may crash,
    and the error reporting dialog popup can be somewhat annoying.

commit deae1b1001d134f5babc4fad3208bd951a454951
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Feb 6 18:49:46 2016 +0100

    windows: Flag debug builds in the resource file

commit 0082b717199bafb4abbb6638e7c30d50deaf2c1b
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Feb 4 20:06:57 2016 +0100

    cli: Refactor filter option parsing
    
    The old code contained a whole bunch of memory leaks, unchecked mallocs,
    sections of dead code, etc. and was generally overly complex.
    
    Also consolidate some memory allocations into a single one.

commit dfe394cadc8a39752de5b3f4a0be222c1b9290f2
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jan 31 21:50:52 2016 +0100

    ffms: Various improvements
    
     * Drop the MinGW Unicode workarounds. Those were required at the time
       Windows Unicode support was added to x264 but the underlying problem
       has since been fixed in FFMS.
    
     * Use FFMS_IndexBelongsToFile() as an additional sanity check when reading
       an index file to ensure that it belongs to the current source video.
    
     * Upgrade to the new API to prevent deprecation warnings when compiling.
    
     * Fix a resource leak that would occur if FFMS_GetFirstTrackOfType() or
       FFMS_CreateVideoSource() failed.
    
     * Minor string handling adjustments related to progress reporting.
    
    This increases the FFMS version requirement from 2.16.2 to 2.21.0.

commit 215afdbd8ecc924f2028f79851458076683e97ad
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Apr 11 16:59:46 2016 +0200

    msvc: Add snprintf/vsnprintf replacements
    
    MSVC pre-VS2015 has broken snprintf/vsnprintf implementations which are
    incompatible with C99 and may lead to buffer overflows.

commit 5be32efc244d96aa56be462664b5c56d7318e86d
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jan 31 20:21:01 2016 +0100

    configure: Define feature test macros for --std=gnu99
    
    Makes the printf() family functions on MinGW use the correct C99 POSIX
    versions instead of the broken pre-VS2015 Microsoft ones.
    
    Also allows us to get rid of some _GNU_SOURCE and _ISOC99_SOURCE defines.

commit c01bf42117b811a0469f9f6c374f4a0daa98716d
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Jan 28 18:37:37 2016 +0100

    mingw: Enable high-entropy ASLR on 64-bit Windows
    
    To fully utilize HEASLR the image base address must also be set above
    4 GiB. For consistency use the same address as MSVC uses by default.
    
    This requires binutils 2.25 which isn't available on all common
    distributions, so only enable it after checking that it's supported.

commit dd6b7b974e0057da726f71e10c24d057a339605b
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jan 24 01:48:18 2016 +0100

    msvs: WinRT support
    
    To compile x264 for WinRT the following additional steps has to be performed.
    
     * Ensure that the necessary SDK is installed.
    
     * Set the correct environment variables in the VS command prompt as shown at
       https://trac.ffmpeg.org/wiki/CompilationGuide/WinRT
    
     * Add one of the following to --extra-cflags depending on the target OS:
       "-DWINAPI_FAMILY=WINAPI_FAMILY_PC_APP -D_WIN32_WINNT=0x0A00" (Windows 10)
       "-DWINAPI_FAMILY=WINAPI_FAMILY_PC_APP -D_WIN32_WINNT=0x0603" (Windows 8.1)

commit 7650a1367003e24f4f1b831682c012b5ba3e6c69
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jan 24 23:58:40 2016 +0100

    configure: Disable CLI libraries when CLI is disabled

commit 1ce062abb47ac59621b402cb26a1f14c91bb52bc
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Feb 5 18:46:13 2016 +0100

    matroska: mk_close: Check fseek() return value

commit de7af9185e172122cd9b800845e1988a52ad7cc3
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Feb 5 18:46:02 2016 +0100

    parse_qpfile: Check ftell() and fseek() return values

commit fd2c324731c2199e502ded9eff723d29c6eafe0b
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Apr 10 20:13:59 2016 +0300

    Use the correct default B-ref placement with B-pyramid
    
    Cost analyse functions expects the placement of the B-ref in a sequence of
    an even number of B-frames to be located towards the beginning while the
    actual placement was towards the end.
    
    Change the placement to be consistent with the analyse expectations, e.g.
    PbbBbP -> PbBbbP.

commit e6a3f2989dd9eba3434c21fa94a6d9a5d1c7a9fe
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Feb 5 18:45:47 2016 +0100

    parse_zones: Fix memory leak

commit f86756985d42ac4a14866534c588061ede860b7b
Author: Alexey Samsonov <vonosmas@gmail.com>
Date:   Mon Jan 25 16:05:25 2016 -0800

    Fix float-cast-overflow in x264_ratecontrol_end function
    
    According to the C standard, it is undefined behavior to cast a negative
    floating point number to an unsigned integer. Float-cast-overflow in
    general is known to produce different results on different architectures.
    
    Building x264 code with Clang and -fsanitize=float-cast-overflow
    (http://clang.llvm.org/docs/UndefinedBehaviorSanitizer.html#availablle-checks)
    and running it on some real-life examples occasionally produces errors
    of the form:
    
    encoder/ratecontrol.c:1892: runtime error: value -5011.14 is outside the
    range of representable values of type 'unsigned short'
    
    Fix these errors by explicitly coding the de-facto x86 behavior: casting
    float to uint16_t through int16_t.

commit a01e33913655f983df7a4d64b0a4178abb1eb618
Author: Sebastian Dröge <sebastian@centricular.com>
Date:   Sun Dec 20 23:49:35 2015 +0300

    Fix AVC-Intra padding for non-Annex B encoding

commit 1e4a24f305c006a95fec00131703d0e0ecae3a38
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Jan 11 21:39:22 2016 +0300

    ppc: Only perform AltiVec detection if compiled with AltiVec enabled

commit b5953629117adc2b8d0d0eed6eb323c00587b428
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Oct 13 15:30:16 2015 +0300

    2-pass: Take into account possible frame reordering

commit 20821a26ec510979e49fcfd6becc6ad7e2d8b388
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Oct 13 12:54:05 2015 +0300

    Revise the 2-pass algorithm

commit 065321c48d0d371c1735b3cc9d368b43e1b64aaa
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Jan 5 02:41:43 2016 +0300

    Revise the row VBV algorithm (part 2)
    
    Should fix rare cases of VBV emergency mode activation caused by too much trust
    to the row predictors.

commit d23d18655249944c1ca894b451e2c82c7a584c62
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Jan 1 12:44:31 2016 +0100

    Bump dates to 2016

commit 3d972062c8a37d1a19586e2351e889b0a70beb40
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Oct 26 19:54:20 2015 +0100

    cli: Use memory-mapped input frames for yuv and y4m
    
    Improves performance by avoiding extraneous memory copying.
    Most beneficial on fast settings.
    
    On average around 5-10% faster overall on ultrafast but the
    performance improvement can be even larger in some cases.

commit 38a5268dbec56adea750e05c4981f3bbb176e735
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Jan 7 01:59:24 2016 +0100

    y4m: Support extended frame headers when seeking
    
    Use the actual length of the frame header of the first frame instead of
    assuming a header without extensions when calculating the frame size.
    
    Also makes the frame counter more accurate with extended frame headers.

commit cc652c158c1fa65bfeafb6446b5be855850065d0
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Nov 3 17:55:08 2015 +0100

    configure: Simplify cygwin/mingw/msys code
    
    Avoids some code duplication.
    
    Also drop the -mno-cygwin check since that option was removed back in 2008.

commit 8b2d2a6d51abf51ad38dd8705d280448fbe63aaf
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Oct 26 18:52:46 2015 +0100

    y4m: Avoid some redundant strlen() calls

commit 24f7705f15cf6d59028a76a894d866b9fad85f39
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Oct 25 17:15:10 2015 +0100

    Simplify threadpool_wait

commit 30ba5dc22fd0ae359e144847f2636574f659627d
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Oct 16 19:05:34 2015 +0200

    windows: Use native threads by default
    
    --disable-win32thread can be passed as an argument to configure to compile
    with pthreads, which was the old default behavior.

commit 1637239a64f3ec9a491b91202bd37097f15a253d
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Oct 11 22:32:11 2015 +0200

    x86: Avoid some bypass delays and false dependencies
    
    A bypass delay of 1-3 clock cycles may occur on some CPUs when transitioning
    between int and float domains, so try to avoid that if possible.

commit 7688814a7ec994f8e5984d199b465ccc068b98af
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Oct 11 22:32:03 2015 +0200

    x86: Enable high bit-depth x264_coeff_last64_avx2_lzcnt
    
    The function existed but was never enabled.

commit 366fa85885053c7b836a4272a4fbec1852103979
Author: Geza Lore <gezalore@gmail.com>
Date:   Mon Oct 12 13:13:42 2015 +0100

    x86inc: Add debug symbols indicating sizes of compiled functions
    
    Some debuggers/profilers use this metadata to determine which function a
    given instruction is in; without it they get can confused by local labels
    (if you haven't stripped those). On the other hand, some tools are still
    confused even with this metadata. e.g. this fixes `gdb`, but not `perf`.
    
    Currently only implemented for ELF.

commit 70c3ba42e610b4182edda4fdeb10b37a2a70eb8f
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Oct 16 21:28:49 2015 +0200

    x86inc: Avoid creating unnecessary local labels
    
    The REP_RET workaround is only needed on old AMD cpus, and the labels clutter
    up the symbol table and confuse debugging/profiling tools, so use EQU to
    create SHN_ABS symbols instead of creating local labels. Furthermore, skip
    the workaround completely in functions that definitely won't run on such cpus.
    
    This patch doesn't modify any emitted instructions, and doesn't actually affect
    x264 at all. It's only for other projects that use x86inc.asm without an
    appropriate `strip` command in their buildsystem.
    
    Note that EQU is just creating a local label when using nasm instead of yasm.
    This is probably a bug, but at least it doesn't break anything.

commit 5c3d473a966e4b013759097fb98cd4a9cb5a34f5
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Oct 15 17:42:49 2015 +0200

    x86inc: Simplify AUTO_REP_RET
    
    cpuflags is never undefined any more, it's set to 0 instead.
    
    Also fix an incorrect comment.

commit 28d68f090c0103704f5f6a86fcf362251774cd78
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Oct 12 21:55:11 2015 +0200

    x86inc: Use more consistent indentation

commit 963b99efaaf1f0628b155e52b8a7c102cd1d37ff
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Oct 12 20:15:18 2015 +0200

    x86inc: Preserve arguments when allocating stack space
    
    When allocating stack space with a larger alignment than the known stack
    alignment a temporary register is used for storing the stack pointer.
    Ensure that this isn't one of the registers used for passing arguments.

commit 6e5033417a53fa66d002665618a1350d7417725e
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jan 17 00:25:47 2016 +0100

    x86inc: Improve FMA instruction handling
    
     * Correctly handle FMA instructions with memory operands.
     * Print a warning if FMA instructions are used without the correct cpuflag.
     * Simplify the instantiation code.
     * Clarify documentation.
    
    Only the last operand in FMA3 instructions can be a memory operand. When
    converting FMA4 instructions to FMA3 instructions we can utilize the fact
    that multiply is a commutative operation and reorder operands if necessary
    to ensure that a memory operand is used only as the last operand.

commit 93cba743c78959ad97812dbaf894903c608912d0
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Oct 11 22:31:53 2015 +0200

    x86inc: Be more verbose in assertion failures

commit 8017b33454397d59b3285ec6d2ad35b6d0deb58a
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Sep 30 23:17:00 2015 +0200

    x86inc: Make cpuflag() and notcpuflag() return 0 or 1
    
    Makes it possible to use them in arithmetic expressions.

commit 5c6570495f8f1c716b294aee1430d8766a4beb9c
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Oct 30 16:55:49 2015 +0100

    encoder_open: Fix memory leak
    
    Furthermore, the x264_analyse_prepare_costs() and x264_analyse_init_costs()
    functions were only used in x264_encoder_open(), so move that entire section
    of code to analyse.c as well to simplify things.

commit 424534537a249dcf913e02560303f6afca423489
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Wed Nov 18 11:08:22 2015 +0100

    arm: do not fill mc_weight*_neon tabs for HIGH_BIT_DEPTH
    
    The asm is only for 8-bit and function prototypes reflect that. Avoids
    numerous warnings with --bit-depth=9/10.

commit df51d8efa8ce9afcedda64acc69c1dba2648716d
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Oct 13 23:50:11 2015 +0200

    arm: Eliminate text relocations in asm
    
    Android 6 does not link shared libraries with text relocations.
    
    Make the movrel macro position independent and add movrelx for indirect
    loads of external symbols.
    
    Move the function pointer table for the aligned memcpy variants to the
    data.rel.ro section on Linux/Android.

commit a2fe237af1b68f2bd53d64ed3faed62429d3ee5a
Author: Martin Storsjö <martin@martin.st>
Date:   Thu Oct 15 11:50:33 2015 +0300

    arm: Don't assume alignment in mbtree_propagate_list_internal where it isn't provided

commit 9f422c0cd9c0abcd6a7abb10b51f8be883c39b2b
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Oct 13 23:50:12 2015 +0200

    arm: Fix checkasm register clobber check on iOS
    
    r9 is a volatile register in the iOS ABI and will therefore not be
    preserved by compiled functions like the luma motion compensation.
    
    Add the symbol prefix to the puts() call and use blx since a switch
    between arm and thumb mode might be required.

commit 75992107adcc8317ba2888e3957a7d56f16b5cd4
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Oct 1 01:02:16 2015 +0300

    ppc: Add detection of AltiVec support for FreeBSD
    
    Patch from FreeBSD ports.

commit 479d0c1fe73833ba65e0a10f6f5cf18df6def719
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Sep 28 21:07:55 2015 +0300

    Don't assume 16-byte stack alignment by default on x86-32
    
    Some compilers depending on target OS uses 4-byte stack alignment by default.
    Explicitly check known good compilers and specific options for stack alignment.

commit fad44d59b3adeb29b9c92fde0b80116cde79020e
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Sep 22 21:33:07 2015 +0300

    Fix a few static analyzer performance hints

commit de24c8c189364013e62d58d1e8f2fef878eb62bf
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Sep 22 20:19:23 2015 +0300

    Revise the row VBV algorithm

commit 001d30598c75d9bbc3aa80f67f9bdac17692437d
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Sep 22 19:26:25 2015 +0300

    Fix high bit depth lookahead cost compensation algorithm
    
    Now high bit depth VBV should act more like 8-bit depth one.

commit 91368390db9179226b5b4ed718a5788b754f9302
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Sep 22 19:05:52 2015 +0300

    Correctly update the intra row predictor in B-frames
    
    It was previously used but never updated from it's initialization value.

commit e0d722f85f8599e324be2bebef9430155b25c329
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Sep 22 18:58:24 2015 +0300

    Change the predictors update algorithm
    
    Keep predictor offsets more stable. This should fix VBV misprediction in frames
    with a large difference in complexity between the top and bottom parts.

commit 6f04b146875c45e6f7845a7bb5fb7fdf8e7534f1
Author: Martin Storsjö <martin@martin.st>
Date:   Thu Sep 3 09:30:44 2015 +0300

    arm: Implement x264_mbtree_propagate_{cost, list}_neon
    
    The cost function could be simplified to avoid having to clobber
    q4/q5, but this requires reordering instructions which increase
    the total runtime.
    
    checkasm timing       Cortex-A7      A8      A9
    mbtree_propagate_cost_c      63702   155835  62829
    mbtree_propagate_cost_neon   17199   10454   11106
    
    mbtree_propagate_list_c      104203  108949  84532
    mbtree_propagate_list_neon   82035   78348   60410

commit 3e25eab0b7172e3c0b067b8b6d641ce148d03db9
Author: Martin Storsjö <martin@martin.st>
Date:   Thu Sep 3 09:30:43 2015 +0300

    x86: Share the mbtree_propagate_list macro with aarch64
    
    This avoids having to duplicate the same code for all architectures
    that implement only the internal part of this function in assembler.

commit 654901dfca73a21e2bb2366dda79eb413e9bfb66
Author: Martin Storsjö <martin@martin.st>
Date:   Wed Sep 2 22:39:51 2015 +0300

    arm: Implement luma intra deblocking
    
    checkasm timing       Cortex-A7      A8     A9
    deblock_luma_intra[0]_c      5988    4653   4316
    deblock_luma_intra[0]_neon   3103    2170   2128
    deblock_luma_intra[1]_c      7119    5905   5347
    deblock_luma_intra[1]_neon   2068    1381   1412
    
    This includes extra optimizations by Janne Grunau.
    
    Timings from a separate build, on Exynos 5422:
    
                          Cortex-A7     A15
    deblock_luma_intra[0]_c      6627   3300
    deblock_luma_intra[0]_neon   3059   1128
    deblock_luma_intra[1]_c      7314   4128
    deblock_luma_intra[1]_neon   2038   720

commit e2696a60a3e58d92e88e149b63c0b06a066eea9e
Author: Martin Storsjö <martin@martin.st>
Date:   Mon Aug 31 22:40:31 2015 +0300

    arm: Implement some neon 8x16c intra predict functions
    
    checkasm timing       Cortex-A7      A8     A9
    intra_predict_8x16c_dct_c    862     540    590
    intra_predict_8x16c_dct_neon 608     511    657
    intra_predict_8x16c_h_c      972     707    719
    intra_predict_8x16c_h_neon   722     656    672
    intra_predict_8x16c_p_c      10183   9819   8655
    intra_predict_8x16c_p_neon   2622    1972   1983

commit 5db8b6b93aa91079ab785b9b49413625430536fd
Author: Martin Storsjö <martin@martin.st>
Date:   Fri Aug 28 00:15:01 2015 +0300

    arm: Implement x264_plane_copy_neon
    
    checkasm timing       Cortex-A7      A8     A9
    plane_copy_c                 13124   10925  9106
    plane_copy_neon              7349    5103   8945

commit 35d32d09e163bb0f2ce60a8e13f9f22125445346
Author: Martin Storsjö <martin@martin.st>
Date:   Fri Aug 28 09:40:24 2015 +0300

    checkasm: arm: Check register clobbering
    
    Cast the function pointer to a different type signature, to
    be able to use uint64_t as return type (instead of intptr_t) for
    those calls that require it.
    
    Use two separate functions, depending on whether neon is available.

commit 9cbdb635a4bd78e6767e735a062c0d9a5766b849
Author: Martin Storsjö <martin@martin.st>
Date:   Fri Aug 14 00:00:57 2015 +0300

    checkasm: Try different widths for ssd_nv12
    
    To test all codepaths in the aarch64 neon implementation, one at
    the very least needs to test with width 8, 16, 24 and 32.

commit 39af8c72e618a544baa06ae427fb2b440861abcd
Author: Jerome Duval <jerome.duval@gmail.com>
Date:   Fri Jun 13 19:56:27 2014 +0000

    Haiku support
    
    Add Haiku as supported platform in configure.
    Haiku has no nice() function, use the platform specific substitute instead.

commit 59683a97b50b34c6282457a959bb6b3e9e7f8c0d
Author: Martin Storsjö <martin@martin.st>
Date:   Tue Aug 25 14:38:20 2015 +0300

    checkasm: aarch64: Check register clobbering
    
    Disable this on iOS, since it has got a slightly different ABI
    for vararg parameters.

commit 5c13589be828b524100c787057d6bef77898c657
Author: Martin Storsjö <martin@martin.st>
Date:   Tue Aug 25 23:36:45 2015 +0300

    arm: Implement x284_decimate_score15/16/64_neon
    
    checkasm timing       Cortex-A7      A8     A9
    decimate_score15_c           764     736    535
    decimate_score15_neon        487     494    453
    decimate_score16_c           782     727    553
    decimate_score16_neon        487     494    521
    decimate_score64_c           2361    2597   2011
    decimate_score64_neon        1017    802    785

commit 3902ae02a0edede5d6c44cb3ee9e24e618c66e6a
Author: Martin Storsjö <martin@martin.st>
Date:   Tue Aug 25 23:36:44 2015 +0300

    arm: Implement chroma intra deblock
    
    checkasm timing              Cortex-A7      A8     A9
    deblock_chroma_420_intra_mbaff_c    1469    1276   1181
    deblock_chroma_420_intra_mbaff_neon 981     717    644
    deblock_chroma_intra[1]_c           2954    2402   2321
    deblock_chroma_intra[1]_neon        947     581    575
    deblock_h_chroma_420_intra_c        2859    2509   2264
    deblock_h_chroma_420_intra_neon     1480    1119   1028
    deblock_h_chroma_422_intra_c        6211    5030   4792
    deblock_h_chroma_422_intra_neon     2894    1990   2077

commit e8b95e92792d9353277995043757430cf3dc3bf7
Author: Martin Storsjö <martin@martin.st>
Date:   Tue Aug 25 14:38:17 2015 +0300

    arm: Implement x264_pixel_sa8d_satd_16x16_neon
    
    This requires spilling some registers to the stack,
    contray to the aarch64 version.
    
    checkasm timing        Cortex-A7      A8     A9
    sa8d_satd_16x16_neon          12936   6365   7492
    sa8d_satd_16x16_separate_neon 14841   6605   8324

commit 6bbaa2758d53d0d6d645142d7d818c960d137a0e
Author: Martin Storsjö <martin@martin.st>
Date:   Tue Aug 25 14:38:16 2015 +0300

    arm: Implement x264_deblock_h_chroma_mbaff_neon
    
    checkasm timing        Cortex-A7      A8     A9
    deblock_chroma_420_mbaff_c    1944    1706   1526
    deblock_chroma_420_mbaff_neon 1210    873    865

commit 3c66591e859045ef79a7131b991a5f20c80ffbb4
Author: Martin Storsjö <martin@martin.st>
Date:   Tue Aug 25 14:38:15 2015 +0300

    arm: Implement x264_deblock_h_chroma_422_neon
    
    checkasm timing       Cortex-A7      A8     A9
    deblock_h_chroma_422_c       6953    6269   5145
    deblock_h_chroma_422_neon    3905    2569   2551

commit 5265b927b0f2e043dd39cbbbf3909da0862d60e6
Author: Martin Storsjö <martin@martin.st>
Date:   Tue Aug 25 14:38:14 2015 +0300

    arm: Implement integral_init4/8h/v_neon
    
    checkasm timing       Cortex-A7      A8     A9
    integral_init4h_c            10466   8590   6161
    integral_init4h_neon         3021    1494   1800
    integral_init4v_c            16250   13590  13628
    integral_init4v_neon         3473    2073   3291
    integral_init8h_c            10100   8275   5705
    integral_init8h_neon         4403    2344   2751
    integral_init8v_c            6403    4632   4999
    integral_init8v_neon         1184    783    1306

commit b08403b5593307b919bfe5bfbd743da825326a4c
Author: Martin Storsjö <martin@martin.st>
Date:   Tue Aug 25 14:38:13 2015 +0300

    arm: Implement x264_denoise_dct_neon
    
    checkasm timing       Cortex-A7      A8     A9
    denoise_dct_c                6604    5510   5858
    denoise_dct_neon             1774    1139   1614

commit ceee976bde76a5f4126bfd9d8454f0e601e67204
Author: Martin Storsjö <martin@martin.st>
Date:   Tue Aug 25 14:38:12 2015 +0300

    arm: Add x264_nal_escape_neon
    
    checkasm timing      Cortex-A7      A8      A9
    nal_escape_c                852758  879566  655497
    nal_escape_neon             376831  450678  371673

commit 8feb733ed1dcb1cc94df3b0e6c98009832ea85cc
Author: Martin Storsjö <martin@martin.st>
Date:   Tue Aug 25 14:38:11 2015 +0300

    arm: Add neon versions of vsad, asd8 and ssd_nv12_core
    
    These are straight translations of the aarch64 versions.
    
    checkasm timing      Cortex-A7      A8      A9
    vsad_c                      16234   10984   9850
    vsad_neon                   2132    1020    789
    
    asd8_c                      5859    3561    3543
    asd8_neon                   1407    1279    1250
    
    ssd_nv12_c                  608096  591072  426285
    ssd_nv12_neon               72752   33549   41347

commit 42b3b398664349d23b2122ac940417165424542d
Author: Martin Storsjö <martin@martin.st>
Date:   Tue Aug 25 14:38:10 2015 +0300

    checkasm: Check the right output range for integral_initXh
    
    These functions write their output into sum+stride, while we previously
    only checked [0..stride-8] within the sum array.
    
    This catches the previously broken aarch64 version of these functions.
    
    Also check up until stride-4 elements for init4h.

commit 3d86abab097fa26d116112f188458269c6a0415f
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Thu Aug 20 13:55:54 2015 +0200

    aarch64: Skip deblocking in 264_deblock_h_chroma_422_neon
    
    If the parameters (alpha, beta, tc0[]) indicated that the deblocking
    should have been skipped, every 2nd chrome line would have deblocked
    anyway.
    
    deblock_h_chroma_422_neon: 2259 (before)
    deblock_h_chroma_422_neon: 2192 (after)

commit aec81efd3fe43008551916aa6073eb0732a58210
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Mon Aug 17 16:39:20 2015 +0200

    aarch64: Optimize various intra_predict asm functions
    
    Make them at least as fast as the compiled C version (tested on
    cortex-a53 vs. gcc 4.9.2).
    
                            C     NEON (before)   NEON (after)
    intra_predict_4x4_dc:   260   335             260
    intra_predict_4x4_dct:  210   265             200
    intra_predict_8x8c_dc:  497   548             493
    intra_predict_8x8c_v:   232   309             179 (arm64)
    intra_predict_8x16c_dc: 795   830             790

commit b16268ac0826d78455d0d704ea0fc8b1edc6b6bf
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Aug 18 10:25:10 2015 +0200

    aarch64: Faster intra_predict_4x4_h
    
    Use multiplication with 0x01010101 for splats.
    
    On a cortex-a53:
                         gcc 4.9.2   llvm 3.6   neon (before)   neon (after)
    intra_predict_4x4_h: 162         147        160/155         139/135

commit f2a6be92e5e42e8ef1daf74f63dbdbc4819d2070
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Aug 18 10:25:09 2015 +0200

    aarch64: Fix coeff_level_run* macros with LLVM's assembler
    
    LLVM's integrated assembler does not treat symbols as integer constants.

commit 592e92e9a8e47c3f0d0017c8158df5a4830e0bbd
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Aug 18 10:25:08 2015 +0200

    aarch64: Remove commas LLVM's assembler complains about

commit 6efb57ada652fd015ec4cacffd09282632bb975b
Author: Martin Storsjö <martin@martin.st>
Date:   Thu Aug 13 23:59:31 2015 +0300

    arm: Implement x264_sub8x16_dct_dc_neon
    
    checkasm timing      Cortex-A7      A8     A9
    sub8x16_dct_dc_c            6386    3901   4080
    sub8x16_dct_dc_neon         1491    698    917

commit 89439b2c604c81e13eb3da9e692d2cdae5a18b53
Author: Martin Storsjö <martin@martin.st>
Date:   Thu Aug 13 23:59:28 2015 +0300

    arm: Optimize x264_deblock_h_chroma_neon
    
    Shuffle both chroma components together as a 16 bit unit, and
    don't write the unchanged columns (like in x264_deblock_h_luma_neon
    and in the aarch64 version of the function).
    
    This causes a minor slowdown for x264_deblock_v_chroma_neon, but
    it is negligible compared to the speedup.
    
    checkasm timing      Cortex-A7    A8    A9
    deblock_chroma[1]_c         4817  4057  3601
    deblock_chroma[1]_neon      1249  716   817   (before)
    deblock_chroma[1]_neon      1249  766   845   (after)
    
    deblock_h_chroma_420_c      3699  3275  2830
    deblock_h_chroma_420_neon   2068  1414  1400  (before)
    deblock_h_chroma_420_neon   1838  1355  1291  (after)

commit ff71457d71c5c11ed825d848677cab09c7639012
Author: Martin Storsjö <martin@martin.st>
Date:   Thu Aug 13 23:59:27 2015 +0300

    aarch64: Remove leftover commented out code

commit ef6034812162fc8b51bfd5e87387f405d1cc30cb
Author: Martin Storsjö <martin@martin.st>
Date:   Thu Aug 13 23:59:26 2015 +0300

    aarch64: Simplify the decimate_score functions
    
    After doing a left shift by the number of bits returned by clz,
    only bits set to zero can be shifted out, so if the register
    was nonzero to start with (which is checked), it can't become
    zero here.

commit d2b04a26b26d02c41ffb05cf1a605dafe9e6fa59
Author: Martin Storsjö <martin@martin.st>
Date:   Thu Aug 13 23:59:25 2015 +0300

    arm: Use aligned loads in x264_coeff_last15_neon
    
    After subtracting 2, the pointer will be aligned.
    
    checkasm timing      Cortex-A7    A8    A9
    coeff_last15_c              423   375   230
    coeff_last15_neon           350   420   404  (before)
    coeff_last15_neon           350   400   394  (after)

commit 3f89a6bbee061cb0361770cf5b8495448515a011
Author: Martin Storsjö <martin@martin.st>
Date:   Thu Aug 13 23:59:24 2015 +0300

    arm: Simplify x264_predict_8x8c_p_neon
    
    This gets rid of a few unnecessary (and confusing) steps in
    calculating the increment to i00.
    
    checkasm timing      Cortex-A7    A8    A9
    intra_predict_8x8c_p_c      5525  4732  4755
    intra_predict_8x8c_p_neon   1719  1140  1262  (before)
    intra_predict_8x8c_p_neon   1663  1142  1255  (after)

commit a0cd7d38acb6c31973228ab207e18344920e0aa3
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Tue Sep 15 15:40:14 2015 +0200

    lavf: Use the prefixed name for pixel format enum

commit 63555e696a997ff795798d3357d770f8ab373cd9
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Thu Sep 3 00:21:58 2015 +0200

    aarch64: fix x264_mbtree_propagate_cost_neon
    
    The branch conditon caused the loop to execute one time more than
    intended. Detected by a memory corruption on arm with the 1 to 1 port of
    the function.

commit 5c4728d8dd82ba46901824470db1609ae0f2521d
Author: Martin Storsjö <martin@martin.st>
Date:   Thu Aug 13 23:59:22 2015 +0300

    aarch64: Fix integral_init4/8h_neon
    
    The stride is the number of uint16_t elements and thus needs
    to be shifted.
    
    This issue had slipped unnoticed since checkasm didn't actually
    verify the output of these functions.

commit 67076513267907b5601828ae6864cc063c8c7548
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Aug 27 19:53:00 2015 +0200

    x86: Fix integral_init4/8h_avx2
    
    The AVX2 implementation was using the wrong offsets. It went undetected due to
    the checkasm test being incorrect.

commit e86f3a1993234e8f26050c243aa253651200fa6b
Author: Mark Webster <mark.webster@gmail.com>
Date:   Wed Aug 5 04:28:17 2015 +0100

    Simplify inclusion of x264.h in C++ projects
    
    Name all structs to support forward declarations.
    Add a conditional extern "C" wrapper in x264.h itself instead of having to
    specify it in every location where it's included.

commit 401941cc7099b322864600b62104940542497e7a
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Aug 16 21:59:26 2015 +0200

    checkasm: Properly save rdx/edx in checkasm_call() on x86
    
    If the return value doesn't fit in a single register rdx/edx can in some
    cases be used in addition to rax/eax.
    
    Doesn't affect any of the existing checkasm tests but it's more correct
    behavior and it might be useful in the future.

commit 3dff8af3033a9e81d7966c5749fd361ce421467a
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Aug 11 17:19:35 2015 +0200

    x86: Enable SSE2 by default on x86-32
    
    It makes more sense to tune the defaults to benefit the vast majority of users.
    
    Anyone still using a Pentium III for video encoding is of course free to
    explicitly set different flags when compiling.

commit 51d8aa09b777dc2969deaa954d5f6af9836c02ba
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Aug 10 22:30:21 2015 +0200

    msvs/icl: Improve default CFLAGS
    
    Use -fp:fast as a substitute for -ffast-math.
    Increase warning level from -W0 to -W1 (the default setting).
    Disable -GS (stack cookies) on MSVS. It's disabled by default on ICL.

commit 7edaf4b966aaee098ff301436f8d2b33a6fe5983
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Aug 12 22:23:31 2015 +0200

    Use a relative $SRCPATH for out-of-tree builds
    
    Fixes out-of-tree MSVS builds on Cygwin.

commit e7b4b863dc2555ed835569c400d3a30f7ddc15ff
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Aug 8 22:26:38 2015 +0200

    cygwin: Enable MSVS support
    
    `cl -showIncludes` creates absolute Windows paths for some files, attempt
    to convert those to Unix paths.
    
    Use relative paths for dependencies located in or below the working directory
    in order to mimic the behavior of gcc and to make the paths more readable.
    
    Make the dependency generation script a bit more robust in general.

commit 817a4414b98e8a511c626932e7d433388bc96507
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Aug 8 18:34:21 2015 +0200

    cltostr.sh: Minor fixes

commit 1a3d963441eaad25972763423d60158f597c5f65
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Aug 8 12:21:54 2015 +0200

    Simplify version.sh
    
    Also remove some non-POSIX syntax and improve robustness.
    
    As a bonus the script now runs about 2-3 times faster.
    
    `git rev-list --count` could be used to simplify things even further,
    but that functionality was added in git 1.7.2 so keep `wc -l` for now
    to maintain compatibility with older git versions.

commit f7f6af76ef22e812ef330e2839488e83dd553836
Author: 장영훈 <mieabby@gmail.com>
Date:   Fri Aug 7 14:43:24 2015 +0900

    msvs: Fix cl detection in non-English environments

commit e1a55bbbff2b4460ceb843f163e349fed7d32969
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Aug 3 21:05:11 2015 +0200

    x86inc: Sync minor changes from ffmpeg/libav

commit 36f537b141da076032fd11f1745bb62d466dd7bf
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Jul 29 19:30:52 2015 +0200

    matroska: Add comments for the remaining element names

commit f04062e6380cbe10453dab33a3575c373e63ff9b
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Jul 29 19:30:41 2015 +0200

    Silence various static analyzer warnings
    
    Those are false positives, but it doesn't hurt to get rid of them.

commit b1cbf7ebe4a192bbc25cc910cb2910a34992f807
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jul 26 23:13:29 2015 +0200

    mingw: Enable the tsaware linker flag
    
    Avoids an irrelevant compatibility layer in Terminal Services environments.
    
    https://msdn.microsoft.com/en-us/library/cc834995.aspx

commit 8a1ff031ecd4b423fc373540b9b68cdf97602bbf
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jul 26 23:13:26 2015 +0200

    msvs: Don't redefine snprintf for VS2015
    
    Visual Studio 2015 has a proper snprintf implementation.

commit aa9d22927c0264c08c11c9e72294fc651a155b3e
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jul 26 23:13:19 2015 +0200

    msvs: Prefer link.exe from the same directory as cl.exe
    
    /usr/bin/link from coreutils may be located before the MSVS linker in $PATH
    which causes linking to fail due to using the wrong binary.

commit ca8bd68063d74227d917f34fd50942265f9a106c
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Jul 27 00:10:00 2015 +0200

    frame_dump: check fseek() return value

commit 53b3b747e22f53204f6efb5106ab4a5a8eb57626
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Jul 27 00:08:38 2015 +0200

    x264_vfprintf: use va_copy
    
    It's undefined behavior to use the same va_list twice.
    
    This most likely didn't cause any issues in practice since the string would
    have to be larger than 4 KiB to trigger the fallback path.
    
    Use workaround for ICL as it doesn't define va_copy even for C99.

commit 59e7ded846a832125cb533aadff9895487771ea7
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Jul 27 00:08:31 2015 +0200

    param_parse: Fix framerate rounding issues

commit 73ae2d11d472d0eb3b7c218dc1659db32f649b14
Author: Marcin Juszkiewicz <mjuszkiewicz@redhat.com>
Date:   Mon Jun 1 11:24:45 2015 +0200

    aarch64: Remove broken CFLAGS in configure
    
    GCC doesn't have an "-arch" switch, but works when that entire line is removed.

commit cc002bd545b008b1cdc7c6d7cc0c616ba125d4d5
Author: Rong Yan <rongyan236@foxmail.com>
Date:   Mon Jul 20 03:34:20 2015 -0500

    ppc: Add little-endian PowerPC support

commit 145f3a6275802a649b8dedb49bb0e054caf31717
Author: Rishikesh More <rishikesh.more@imgtec.com>
Date:   Thu Jun 18 17:48:46 2015 +0530

    mips: MSA quant optimizations
    
    Signed-off-by: Rishikesh More <rishikesh.more@imgtec.com>

commit 16395d2b6f827b076612eb5b70711b79621da67e
Author: Rishikesh More <rishikesh.more@imgtec.com>
Date:   Thu Jun 18 17:48:45 2015 +0530

    mips: MSA predict optimizations
    
    Signed-off-by: Rishikesh More <rishikesh.more@imgtec.com>

commit 204e1a60237e0b3168ccbdb2905c9af8188b90ee
Author: Rishikesh More <rishikesh.more@imgtec.com>
Date:   Thu Jun 18 17:48:44 2015 +0530

    mips: MSA pixel optimizations
    
    Signed-off-by: Rishikesh More <rishikesh.more@imgtec.com>

commit 3ce6430eb11839c69d606c59c0f8c31ce0b6dd17
Author: Rishikesh More <rishikesh.more@imgtec.com>
Date:   Thu Jun 18 17:48:43 2015 +0530

    mips: MSA deblock optimizations
    
    Signed-off-by: Rishikesh More <rishikesh.more@imgtec.com>

commit 57618eead025eaf654226add94689d6d2999ccf6
Author: Rishikesh More <rishikesh.more@imgtec.com>
Date:   Thu Jun 18 17:48:42 2015 +0530

    mips: MSA dct optimizations
    
    Signed-off-by: Rishikesh More <rishikesh.more@imgtec.com>

commit 4ebb23aaf4f46b7a04aa8aefa3c08e7b6493de4c
Author: Rishikesh More <rishikesh.more@imgtec.com>
Date:   Thu Jun 18 17:48:40 2015 +0530

    mips: MSA mc optimizations
    
    Signed-off-by: Rishikesh More <rishikesh.more@imgtec.com>

commit cd19444d3f9915a5a33a95e308bc8021d7e62afe
Author: Rishikesh More <rishikesh.more@imgtec.com>
Date:   Thu Jun 18 17:48:38 2015 +0530

    mips: Common MSA macros
    
    Add macros for load/store, slide, shift, transpose and basic arithmetic
    operations required by subsequent patches.
    
    Signed-off-by: Rishikesh More <rishikesh.more@imgtec.com>

commit 72b82bd98a99b1d75322b70a74365547382ce062
Author: Rishikesh More <rishikesh.more@imgtec.com>
Date:   Tue May 12 19:38:09 2015 +0530

    mips: Add MSA support to checkasm
    
    Signed-off-by: Rishikesh More <rishikesh.more@imgtec.com>

commit ce0757d9d2778e349a7c2f6445b6aa75d8765c30
Author: Kaustubh Raste <kaustubh.raste@imgtec.com>
Date:   Fri Apr 17 17:38:58 2015 +0530

    mips: Initial MSA support
    
    MSA is the MIPS SIMD Architecture.
    
    Add X264_CPU_MSA define.
    Update configure to detect MIPS platform and set flags.
    CPU-specific gcc options are expected through --extra-cflags.
    
    Sample command line for mips32r5:
        ./configure --host=mipsel-linux-gnu --cross-prefix=<TOOLCHAIN>/mips-mti-linux-gnu-
        --extra-cflags="-EL -mips32r5 -msched-weight -mload-store-pairs"
    
    Signed-off-by: Kaustubh Raste <kaustubh.raste@imgtec.com>

commit 9140ee1fb39bd4a4ccace28091398e8a96704f07
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Jul 17 00:22:29 2015 +0300

    Limit autodetection of threads number according to the source height

commit aeaed2d07b5b43437bb640e1f987d42a6fab03b9
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Jul 16 19:04:59 2015 +0300

    Fine-tune of frame's size predictors at ratecontrol start
    
    This is attempt to improve VBV at start of video with a lot of threads which
    delay feedback for predictors.

commit aa275158641e94203003157947d43ff4cc685068
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Jul 16 16:15:56 2015 +0300

    Use forced frame types in slicetype analysis
    
    This should improve MBTree and VBV when a lot of forced frame types are used.

commit a83edfa053f60ad0c8a164f31e7492a680eef361
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Dec 1 22:05:42 2014 +0100

    x86: SSSE3 and AVX2 implementations of plane_copy_swap
    
    For NV21 input.

commit 627f891c571cacb51deb5e211b23c309b14a6587
Author: Yu Xiaolei <dreifachstein@gmail.com>
Date:   Fri Jun 6 16:05:27 2014 +0800

    NV21 input support
    
    Eliminates an extra copy when encoding Android camera preview images.
    
    Checkasm test by Janne Grunau.
    ARM assembly with improvements from Janne Grunau.

commit 6ee94dc898dc029553e308f1e76891ccefb3f0a7
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Jun 23 17:00:47 2015 +0200

    deblock: Write combining

commit 08a9c51919f4edbd6e484155e5521a92a0800651
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Jun 23 14:59:59 2015 +0200

    Get rid of some tabs and trailing whitespaces

commit b568a256b9bc6c500d7b1ffe4b9c3311ee5ff337
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat May 23 19:44:16 2015 +0200

    x86: Experimental nasm support
    
    Enables the use of nasm as an alternative to yasm.
    
    Note that nasm cannot assemble x264 with PIC enabled since it currently doesn't
    support [symbol-$$] addressing which is used extensively by x264's PIC code.
    This includes all 64-bit Windows and 64-bit OS X builds, even non-shared.
    
    For the above reason nasm is currently intentionally not auto-detected, instead
    the assembler must be explicitly specified using "AS=nasm ./configure".
    
    Also drop -O2 from ASFLAGS since it's simply ignored anyway.

commit d14e38c059c9a2aecc82477b99d56ef74eb731ec
Author: Timothy Gu <timothygu99@gmail.com>
Date:   Tue May 26 19:12:42 2015 +0200

    x86inc: Prevent warnings when using `struc` and `endstruc`
    
    struc and endstruc attempts to revert to the previous section state set by
    the SECTION macro.
    
    Use the primitive [SECTION] directive instead of the SECTION macro for the
    .note.GNU-stack section to prevent it from being emitted again during endstruc.

commit 353b1f888c34081e94727a1ffa0e4920e2cfe8a9
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed May 27 21:38:14 2015 +0200

    x86inc: Drop SECTION_TEXT macro
    
    The .text section is already 16-byte aligned by default on all supported
    platforms so `SECTION_TEXT` isn't any different from `SECTION .text`.

commit b615f82e45c88b7915c5571ad09fa65a0b6130d7
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat May 23 13:38:05 2015 +0200

    x86inc: Disable vpbroadcastq workaround in newer yasm versions
    
    The bug was fixed in 1.3.0, so only perform the workaround in earlier versions.

commit 8f834d6ccc054d8c32d84310664dc07abac553ec
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun May 24 22:57:00 2015 +0200

    Prefer Unicode versions of Windows API calls
    
    Just for consistency, doesn't affect behavior.

commit 3f8c8eb1758d0fa890538eba6f5e699c93dc1304
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun May 24 23:21:20 2015 +0200

    Get rid of fPIC warnings when compiling a shared library on Windows
    
    PIC is always enabled when compiling for Windows so gcc complains when using
    -fPIC since it doesn't do anything.

commit 0c21480fa2fdee345a3049e2169624dc6fc2acfc
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Jul 25 22:42:59 2015 +0200

    matroska: Write the correct DocTypeVersion when using frame-packing
    
    The StereoMode element is only valid with DocTypeVersion 3 or higher.

commit 791d265281af1d022a72ba9e003a987e97da5c0d
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat Jul 25 00:21:52 2015 +0300

    dump_yuv: Fix file handle leak

commit d6aa586b2f83eeb776744c2e97a8ce9e1181c59b
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat Jul 25 00:20:47 2015 +0300

    mp4: Fix file handle leak

commit 942e4e4530d0909c2b580be88acd18d1e5fa4fa8
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Jun 24 00:40:45 2015 +0200

    flv: Check fseek() and fwrite() return values

commit 250d5b0e13045f6a1ebfeb379933b5c5daa9cf41
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Jun 24 00:22:56 2015 +0200

    flv: Fix memory and file handle leaks

commit 3533520655ef095ef009af9b6b27a20b45fd13ee
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Jun 24 01:23:35 2015 +0200

    avs: Fix file handle leak

commit df152a77e1b17065aecb40c9a2a28d5953887ac9
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Jun 23 13:38:02 2015 +0200

    matroska: Fix memory leak

commit 6d5249977f5d62f6e167a062bdd94d8546eca1f7
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Jun 23 13:24:29 2015 +0200

    rdo: Fix potential CAVLC overflow issues

commit 936e8da1a4f9d0431b181d0877bb1602d4de9441
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Jun 23 22:08:35 2015 +0200

    slurp_file: Various minor bug fixes
    
     * Fix unsigned <= 0 check.
     * Add additional size sanity check on 32-bit systems.
     * Don't read uninitialized data if fread() fails.

commit d302526d5b97818f588b86f408f910924790242e
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Jun 23 22:47:53 2015 +0200

    param_parse: Check strdup() return value

commit 94e476d80b9635508907893c97e8f8d9f0bc9ddf
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Jun 23 15:38:16 2015 +0200

    param_parse: Fix memory leak

commit 45856b9787eab95434d66b4bc2e18819483f0e43
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Jun 19 16:01:12 2015 +0300

    Add FreeBSD's stdint.h header guard to allowed list
    
    Patch written by Koop Mast <kwm@FreeBSD.org>

commit 35cf1a2cbf253e43cab7747eb903a3b844bd42c1
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri May 22 19:23:33 2015 +0200

    x86: Prevent overread of src in plane_copy_interleave
    
    Could only occur in 4:2:2 with height == 1.
    
    Also enable asm for inputs with different U/V strides as long as the strides
    have identical signs.

commit 003414a4b3724f0972e4507dfd1432dd442d2228
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed May 20 23:10:20 2015 +0300

    checkasm: Fix incorrect memcmp size for ARM architecture

commit e08fdc81018489217f4bafe7321a3baf372fac1f
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Apr 26 20:51:05 2015 +0300

    Fix possible use of uninitialized MVs in lookahead analysis for B-frames

commit 0b0210857ef13214f12861dec672006455a556d6
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Apr 21 23:08:19 2015 +0300

    Catch incorrect usage of libx264 API for delayed frames flushing

commit 3a6bd39a650b47572743c2d2ea2fd7c214053fb2
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat Mar 7 23:00:09 2015 +0300

    Fix detection of system libx264 configuration

commit 121396c71b4907ca82301d1a529795d98daab5f8
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Feb 23 14:23:18 2015 +0300

    Cosmetic changes

commit 8e71b432e5dbe835fa4516064f6841a03c79b183
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed Dec 31 02:15:05 2014 +0300

    Update configure for auto detection of system libx264 configuration

commit 0f84192e88d6adc4512f6f320a50a09b4608634c
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Feb 3 14:51:28 2015 +0300

    Add tile format frame packing value
    
    Defined in 2014-02 edition.

commit f08b1c6b8e186ff5a931e9a80e8923e42efff0e4
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Feb 3 13:39:14 2015 +0300

    Stricter validation of crop-rect values

commit 196cb9ab52af9370fc66a474ffc4a52a75dc5eb4
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Tue Jan 20 16:15:56 2015 +0000

    Add mono frame packing value
    
    Defined in 2013-04 edition.

commit c8a773ebfca148ef04f5a60d42cbd7336af0baf6
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Tue Jan 20 15:57:41 2015 +0000

    Validate frame packing value instead of clipping

commit a95584945dd9ce3acc66c6cd8f6796bc4404d40d
Author: Christophe Gisquet <christophe.gisquet@gmail.com>
Date:   Tue Feb 3 20:40:41 2015 +0100

    x86inc: Correctly warn on use of SSE2 instructions in SSE functions
    
    SSE2 instructions that are XMM-implementations of pre-existing MMX/MMX2
    instructions did not issue warnings when used in SSE functions. Handle
    it by also checking the register type when such instructions are used.

commit 23d4434de9ab5ef32ebb03401d971b8579a65fc6
Author: Christophe Gisquet <christophe.gisquet@gmail.com>
Date:   Tue Feb 3 18:02:30 2015 +0100

    x86inc: Fix instantiation of YMM registers

commit 4c75f3d729aaf3bcb00edf789c71f09495374bdf
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Tue Jan 20 16:28:54 2015 +0000

    matroska: Correctly write display width and height in stereo mode
    
    According to the specifications, when stereo mode is set, these values
    represent the single view size.

commit c3ba2a8c595b1bb36da55b82f7f4046471349d0e
Author: Kieran Kunhya <kierank@ob-encoder.com>
Date:   Tue Jan 20 09:38:00 2015 -0600

    Use POC type 0 for AVC-Intra
    
    Based on a patch from Capella Systems

commit b77cc09b9252d70f78726f2472391b63948d9895
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat Jan 3 15:46:19 2015 +0300

    Fix ARCH variable name conflict with BSD ports (bsd.port.mk) read-only variable

commit 6e769846626f9185b59f3967e8b4ebe11497d878
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat Dec 27 20:35:39 2014 +0300

    Fix negative percentages in final stats output
    
    They were caused by integer overflow when encoding long UHD video.

commit d7ccd89f1bea53c8c524f8e6eb963d57defb6813
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat Jan 3 23:35:23 2015 +0300

    Bump dates to 2015

commit 40bb56814e56ed342040bdbf30258aab39ee9e89
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Dec 15 18:49:23 2014 +0300

    x86: Update intel compiler cpu dispatcher override for new versions of ICC/ICL

commit d72a85b549acd981a8dae3dc5b71920ab2aeea4f
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Sep 6 21:53:29 2011 +0400

    New AQ mode: auto-variance AQ with bias to dark scenes
    
    Also known as --aq-mode 3 or auto-variance AQ modification.

commit f4a455a43df3088bae5208dcc98b8f6214fdce7d
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed Aug 29 03:02:27 2012 +0400

    Improve HRD conformance

commit fa3549b5f2478f39cbcbd14d2e956e59f70d18eb
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Nov 28 23:24:56 2014 +0100

    x86: SSE and AVX implementations of plane_copy
    
    Also remove the MMX2 implementation and fix src overread for height == 1.

commit 8797e0f8d416aadb91d359f144e4e7855071870a
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Sep 29 23:26:19 2014 +0400

    Update to the latest version of gas-preprocessor.pl from http://git.libav.org/?p=gas-preprocessor.git
    
    Contributions by Janne Grunau, Martin Storsjo, Mans Rullgard, David Conrad, Martin Aumuller and others

commit 59b9c252cfa6242c7fa6424a463e51913996fe6a
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Wed Nov 19 00:33:55 2014 +0100

    aarch64: cabac_encode_{decision,bypass,terminal}_asm
    
    benchmarks on a Nexus 9 (nvidia denver):
    101.3 cycles in x264_cabac_encode_decision_c,   67105369 runs, 3495 skips
     97.3 cycles in x264_cabac_encode_decision_asm, 67105493 runs, 3371 skips
    132.8 cycles in x264_cabac_encode_terminal_c,    1046950 runs, 1626 skips
    116.1 cycles in x264_cabac_encode_terminal_asm,  1048424 runs, 152 skips
     92.4 cycles in x264_cabac_encode_bypass_c,     16776192 runs, 1024 skips
     89.6 cycles in x264_cabac_encode_bypass_asm,   16776453 runs, 763 skips
    
    Cycle counts are not as stable as one would like. The dynamic code
    optimisation seems to produce different results for small chnages in a
    binary. Repeated runs with the same binary produce stable results
    though (ignoring the first run).

commit a6ec424939a4d3a59e4ec1e3999cb37e4314408e
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Thu Nov 6 09:20:17 2014 +0100

    checkasm: add cycle counter read for aarch64
    
    Needs kernel support since user space access to the cycle counter is not
    allowed on all available AArch64 systems (Android 5 and iOS).

commit fa7e9d3d082327ceeacfaf85da6cde4c50fb4e5b
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Wed Nov 5 11:35:13 2014 +0100

    aarch64: nal_escape_neon
    
    3-4 times faster.

commit f13573e490d9f18bbcb10409fb09ec25e477035e
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Fri Oct 31 14:49:04 2014 +0100

    aarch64: {plane_copy,memcpy_aligned,memzero_aligned}_neon
    
    2-3 times faster than C.

commit 8d655b63b4f7bc021ad038ea64b7c4de9d0ef74b
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Wed Oct 29 18:17:48 2014 +0100

    aarch64: x264_mbtree_propagate_{cost,list}_neon
    
    x264_mbtree_propagate_cost_neon is ~7 times faster.
    x264_mbtree_propagate_list_neon is 33% faster.

commit 4d400a6ec67f17ae3b17876b0318b956b6d5c856
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Oct 21 15:18:49 2014 +0200

    aarch64: x264_denoise_dct_neon
    
    3.5 times faster.

commit 4e8ac132cc2feff5786d12c90fd62cf97979bae1
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Mon Oct 20 13:12:14 2014 +0200

    aarch64: x264_coeff_level_run{4,8,15,16}
    
    All functions ~33% faster.

commit dd7666742d5a1a7af076fb388c6adf1b10dcdb3e
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Oct 14 19:20:52 2014 +0200

    aarch64: NEON asm for intra luma deblocking
    
    deblock_luma_intra[0]_neon is 2 times fastes,
    deblock_luma_intra[1]_neon is ~4 times faster.

commit 0122fd230cbf7351845dd354d5ee883d741222ef
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Mon Oct 13 17:29:22 2014 +0200

    aarch64: x264_deblock_h_chroma_422_neon
    
    deblock_h_chroma_422 2.5 times faster

commit 44cb1dcdbdaafeddd98d2ebe3d02408bc380713e
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Mon Oct 13 12:43:50 2014 +0200

    aarch64: x264_deblock_h_chroma_mbaff_neon
    
    deblock_chroma_420_mbaff_neon  2 times faster

commit f2e439d113ae86a0a1ef8215d4d4111892aed3f7
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Fri Oct 10 10:29:15 2014 +0200

    aarch64: NEON asm for intra chroma deblocking
    
    deblock_h_chroma_420_intra, deblock_h_chroma_422_intra and
    x264_deblock_h_chroma_intra_mbaff_neon are ~3 times faster.
    deblock_chroma_intra[1] is ~4 times faster than C.

commit ce6c94c0bef3350e9546302aae5909404b056fdb
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Sep 2 10:27:22 2014 +0200

    aarch64: add myself as author to aarch64/mc.h

commit be7e5fa6eee2731abdb1b41bc2a4c1a29e672747
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Thu Aug 14 14:22:50 2014 +0100

    aarch64: NEON asm for integral init
    
    integral_init4h_neon and integral_init8h_neon are 3-4 times faster than
    C. integral_init8v_neon is 6 times faster and integral_init4v_neon is 10
    times faster.

commit eb1d35725e542968c4a6480c157db40570477a95
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Wed Aug 13 13:30:53 2014 +0100

    aarch64: NEON asm for 8x16c intra prediction
    
    Between 10% and 40% faster than C.

commit 40d5db342b7f5198db9826a51f31e454bd208596
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Aug 12 17:26:10 2014 +0200

    aarch64: NEON asm for decimate_score
    
    decimate_score15 and 16 are 60% faster, decimate_score64 is 4 times
    faster than C.

commit 45e1ebf88a1c3bf37e1326ce621a9b735d155885
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Fri Aug 8 11:19:35 2014 +0100

    aarch64: implement x264_sub8x16_dct_dc_neon
    
    4 times faster than C.

commit 90f0b5c1c881f345c9da15bc482055f2a92f8ceb
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Thu Aug 7 19:46:07 2014 +0200

    aarch64: implement x264_pixel_asd8_neon
    
    7 times faster than C.

commit f8f8d13d5978b13fc831e041e52aa617550bbdf3
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Thu Aug 7 16:49:12 2014 +0200

    aarch64: NEON asm for 4x16 sad, satd and ssd
    
    pixel_sad_4x16_neon: 33% faster than C
    pixel_satd_4x16_neon: 5 times faster
    pixel_ssd_4x16_neon:  4 times faster

commit 35b91f2410dcf4fc5191dd85ccda7a42eb01eae8
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Wed Jul 30 15:48:25 2014 +0100

    aarch64: implement x264_pixel_ssd_nv12_core_neon
    
    13 times faster than C.

commit 99a1ca1f1a62d51e47d1ac2c92ee9c3bf3b5712b
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Jul 29 18:26:11 2014 +0100

    aarch64: implement x264_pixel_vsad_neon
    
    35 times faster than C.

commit 6c1632493e5afac8be1e1693377dab27f4704a1d
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Jul 29 11:06:24 2014 +0100

    aarch64: NEON asm for missing x264_zigzag_* functions
    
    zigzag_scan_4x4_field_neon, zigzag_sub_4x4_field_neon,
    zigzag_sub_4x4ac_field_neon, zigzag_sub_4x4_frame_neon,
    igzag_sub_4x4ac_frame_neon more than 2 times faster
    
    zigzag_scan_8x8_frame_neon, zigzag_scan_8x8_field_neon,
    zigzag_sub_8x8_field_neon, zigzag_sub_8x8_frame_neon 4-5 times faster
    
    zigzag_interleave_8x8_cavlc_neon 6 times faster

commit d040d28514db7d1fbd5c3f06c37a77de14b15e5b
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Fri Jul 25 11:53:17 2014 +0100

    aarch64: implement x264_pixel_sa8d_satd_16x16_neon
    
    ~20% faster than calling pixel_sa8d_16x16 and pixel_satd_16x16
    separately.

commit 91a01d4ca95ee1c621578e118b86d767eab96b3b
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Thu Aug 14 23:13:27 2014 +0200

    aarch64: optimize x264_predict_8x8c_dc_left_neon
    
    25% faster than the previous version.

commit 8ae4e1cfa3d16451ccf285228d309f6f4940a747
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Aug 2 18:26:18 2014 +0200

    x86: Make AVX2 also imply FMA3
    
    All CPUs with AVX2 supports FMA3 (but not the other way around).

commit 06882793b260824bc578d0530f64e7f30f2a9f39
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Nov 13 22:52:00 2014 +0300

    Simplify libx264 API usage example

commit 6a301b6ee0ae8c78fb704e1cd86f4e861070f641
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Nov 21 23:47:20 2014 +0100

    AvxSynth: Remove a bunch of unused cruft

commit 30140b34b879605cf70cab0634a4a8faef5b6e60
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed Dec 3 22:36:12 2014 +0300

    Fix bugs/typos in motion compensation and cache_load
    
    Didn't affect output due to the incorrect values either not being used in the
    code path or producing equal results compared to the correct values.
    
    Also deduplicate hpel_ref arrays.

commit a46820e00ad3c86b80f5830ed92553de474b7d5c
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Nov 30 23:39:28 2014 +0300

    checkasm: Fix undefined behavior warnings

commit 4e97ca566fdf6cd36281e26ee68f64993f4751a1
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Nov 29 18:47:52 2014 +0100

    checkasm: Fix V210 reporting
    
    It would previously report FAILED if any of the earlier plane_copy tests failed.

commit 24e4fed388fcb34c33df7c87e7d6758b9ebed40c
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Oct 12 21:01:53 2014 +0400

    Safety check against malicious high bit-depth input which could cause crash

commit 9bec6fed6d1b95f9921f22ba21e7398eff50b75e
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Oct 12 20:45:40 2014 +0400

    libx264 API usage example

commit 329fe5f6498be7ab337d98ac22c17d379335c854
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Oct 17 21:35:42 2014 +0200

    x86: AVX2 high bit-depth var_16x16
    
    40->27 cycles on Haswell.

commit 4576cfd8c391b27748d6f97f5b621cec4ed8047c
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Oct 8 22:25:35 2014 +0200

    checkasm: Serialize read_time() calls on x86
    
    Improves the accuracy of benchmarks, especially in short functions.
    
    To quote the Intel 64 and IA-32 Architectures Software Developer's Manual:
    "The RDTSC instruction is not a serializing instruction. It does not necessarily
    wait until all previous instructions have been executed before reading the counter.
    Similarly, subsequent instructions may begin execution before the read operation
    is performed. If software requires RDTSC to be executed only after all previous
    instructions have completed locally, it can either use RDTSCP (if the processor
    supports that instruction) or execute the sequence LFENCE;RDTSC."
    
    RDTSCP would accomplish the same task, but it's only available since Nehalem.
    
    This change makes SSE2 a requirement to run checkasm.

commit b85a74a22f79c8722674c4cfd7cddf5f54c8421d
Author: Vittorio Giovara <vittorio.giovara@gmail.com>
Date:   Mon Sep 29 18:51:30 2014 +0100

    Support case-independent string options

commit 20f116b29e93574e9607d1abf2960f32b5730e52
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat Sep 6 20:44:49 2014 +0400

    Shut up gcc -Wuninitialized warnings

commit 3df1d248dd8a4b0d0dffd149effe2bde38de49aa
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Sep 5 19:43:52 2014 +0400

    Shut up clang -Wuninitialized warning

commit 01204b60367f4959e8393652dd30f0cfba2d2c80
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Sep 5 19:30:47 2014 +0400

    Fix few clang -Wunused-* warnings

commit 9df377f87702c82a2202d34919c07e32c60b40ae
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Aug 28 20:13:13 2014 +0400

    Fix inappropriate instruction use

commit 73b8686fc22c9247d90963983d406cd7b9131068
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Aug 28 18:38:53 2014 +0400

    x264asm: warn when inappropriate instruction used in function with specified cpuflags

commit 204a9bd0a1bc507cbd69a77f3318afcb56ede65d
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Sep 2 01:48:00 2014 +0400

    Fix VBV with true VFR streams

commit b36d44c68cddff00c5b6de1e6cb6a86c1af2cbfc
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Sep 1 22:45:00 2014 +0400

    Fix VBV

commit dd79a61e0e354a432907f2d1f7137b27a12dfce7
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed Jul 30 03:03:32 2014 +0400

    Update to the current lavf API and fix memory leak when using --seek

commit 91727d729a4a33a3f21188f838077040740cb353
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Aug 5 01:42:55 2014 +0200

    x86inc: Make INIT_CPUFLAGS support an arbitrary number of cpuflags
    
    Previously there was a limit of two cpuflags.

commit d4317786b8428b00978459f6de3db219f0f6f8e6
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Aug 5 01:42:51 2014 +0200

    x86: Minor pixel_ssim_end4 improvements
    
    Reduce the number of vector registers used from 7 to 5.
    Eliminate some moves in the AVX implementation.
    Avoid bypass delays for transitioning between int and float domains.

commit 98100b88b475227f375d9bcbaea0bac57008accc
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Aug 5 01:42:47 2014 +0200

    x86: Faster quant_4x4x4
    
    Also drop the MMX version instead of doing a bunch of ifdeffery to support it after this change.

commit 56fcb444c4c118ff67cf12838d2b2801d7b43407
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Aug 10 22:46:12 2014 +0400

    configure: improve cc_check for clang and ICL to not ignore unknown options

commit ecb04d08af654a7cfd5b9aa6261bd789de20613a
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Aug 5 01:42:44 2014 +0200

    checkasm: Only call x264_cpu_detect() once

commit 1343db872b1d7d43dc7fb431a8207efb5ca31e2e
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Fri Jul 18 14:49:10 2014 +0100

    aarch64: deblocking NEON asm
    
    Deblock chroma/luma are based on libav's h264 aarch64 NEON deblocking
    filter which was ported by me from the existing ARM NEON asm. No
    additional persons to ask for a relicense.

commit 3c1fa5d9b2ea62f05473080313c543b7e795b307
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Fri Jul 18 09:29:35 2014 +0100

    aarch64: intra predition NEON asm
    
    Ported from the ARM NEON asm.

commit 556b0e7928d14818454e0c33032754f6323f02e9
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Thu Jul 17 15:58:44 2014 +0100

    aarch64: motion compensation NEON asm
    
    Ported from the ARM NEON asm.

commit 6cda439867fcd9e884a10502845fb79fc7ffed69
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Wed Jul 16 10:03:52 2014 +0100

    aarch64: transform and zigzag NEON asm
    
    Ported from the ARM NEON asm.

commit db5c504aa06550f8e916157d1dcc657818e84d62
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Jul 15 12:57:03 2014 +0100

    aarch64: quantization and level-run NEON asm
    
    Ported from the ARM NEON asm.

commit f4a82a54885f3dad7106a6855eaef50ea085b27e
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Wed Mar 19 13:48:21 2014 +0100

    aarch64: pixel metrics NEON asm
    
    Ported from the ARM NEON asm.

commit 3e57554ee4db6ade7a2dccaac92cb8116f3a43d6
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Fri Jul 18 17:44:57 2014 +0200

    aarch64: add utility functions for asm

commit efaf0b88f7c703533ee8857a6a5039cf64bce3a0
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Wed Mar 19 13:45:17 2014 +0100

    aarch64: add armv8 and neon cpu flags and test them

commit 943128a527d1b98a63017d58cd1fcf53aaffcb6e
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Mar 18 22:10:24 2014 +0100

    aarch64: initial build support

commit ee427b69868d506182f4e22bffdc45e913f255af
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Jul 22 19:28:27 2014 +0200

    checkasm: test zigzag_sub_8x8_{frame,field}

commit 69740fd362ee1c0a2e80d6f4e2724d731a3c951c
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Sun Jul 20 18:29:01 2014 +0200

    arm: use long multiplication in mc_weight_w*_neon
    
    9-19% faster on a cortex-a9.

commit 0a05b3f9aa8c524a67119ec5eb6bcc24eb8f2f3b
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Sun Jul 20 18:24:57 2014 +0200

    arm: do not use aligned stores in mc_weight_w4_*neon
    
    mc_weight_w4_*neon is also used for width 2 which does not guarantee
    4-byte aligned destination. Fixes crashes caused by random memory
    corruption.

commit c2df1fc65c98e213c444134d5dbbb79d439af4db
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Wed Apr 2 16:31:28 2014 +0200

    checkasm: add memory clobber to read_time inline asm
    
    The memory acts as compiler barrier preventing aggressive reordering
    of read_time calls. gcc 4.8 reorders some of initial read_time calls
    after the second when targeting arm.

commit d72760401cb0602b8bf86037988e66cdc810681c
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Sun Jul 20 13:32:10 2014 +0200

    arm: check if the assembler supports the '.func' directive
    
    The integrated assembler in llvm trunk (to be released as 3.5) is
    otherwise capable enough to assemble the arm asm correctly.

commit 9463ec0004f1bddc49c05ed8e38430a4ce1738fb
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Sun Jul 20 13:40:28 2014 +0200

    arm/ppc: use $CC as default assembler

commit feec4a478bfdfb4426268b2ee79bac473b97488c
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Sun Jul 20 13:34:27 2014 +0200

    arm: move instructions after '.rept' to separate line
    
    The gas manual states "Repeat the sequence of lines between the .rept
    directive and the next .endr directive ...". GNU as seems to support
    instructions on the same line as .rept anyway but the integrated
    assembler in llvm trunk (to be released 3.5 in August 2014) does not.

commit 6e8971021d2a12505cb2ad9ea677dfc8af676919
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Sun Jul 20 13:08:17 2014 +0200

    arm: set .arch/.fpu from asm.S

commit 716ee56d0b35e512e8e0ae1a3e71f26e65e86be3
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Sun Jul 20 12:55:53 2014 +0200

    arm: do not append CFLAGS to ASFLAGS

commit 021c0dc6c95c1bc239c9db78a80dd85fc856a4dd
Author: Tristan Matthews <le.businessman@gmail.com>
Date:   Thu Jul 17 00:03:50 2014 -0400

    filters: fix sizeof mismatch

commit 95beb822e61a8d84dba9743f4b20b4c303f26798
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Jul 31 16:17:32 2014 +0400

    Fix memory leak when using select_every filter

commit ea0ca51e94323318b95bd8b27b7f9438cdcf4d9e
Author: Tsukasa OMOTO <henry0312@gmail.com>
Date:   Sun Jul 20 22:17:11 2014 +0900

    Fix cltostr.sh on OS X

commit 08d36b3fc975d049aa3786ca34fb0b2f2ba0007c
Author: Fiona Glaser <fiona@x264.com>
Date:   Wed Jul 9 12:21:33 2014 -0700

    Check pf_log is set in validate_parameters
    
    Help remind people to call x264_param_default in case they didn't read the
    documentation.

commit 9e93d18b7fe7668f8277b5f117d7e39be24c6070
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed Jul 9 17:17:04 2014 +0400

    Check malloc during frame dumping

commit 8a85db879d57537f91a9908be3585512981c08b8
Author: Yusuke Nakamura <muken.the.vfrmaniac@gmail.com>
Date:   Thu Jun 19 05:21:29 2014 +0900

    mp4_lsmash: Use new I/O API instead of deprecated one.

commit f112c0e1cae71eb5b98b4f86f635f235cc7b81cb
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Jun 8 22:19:46 2014 +0400

    Remove meaningless use of abs()

commit 6fbbb5b0c05a1d95cbd6efa7f01808ea87a39dc9
Author: Steven Walters <kemuri9@gmail.com>
Date:   Sat May 31 10:31:16 2014 -0400

    MSVS 2013 Update 2 support
    
    The first MSVS compiler C99 compliant enough to build x264.
    Use `CC=cl ./configure` to compile with it.

commit f53af048ed94551734265cf8f9dbe12d211a77fc
Author: Diego Biurrun <diego@biurrun.de>
Date:   Tue Apr 15 22:54:08 2014 +0200

    configure: Add -Wno-maybe-uninitialized to CFLAGS
    
    The warnings generated by -Wmaybe-uninitialized are mostly spurious.

commit cbd8d7b6db1f29929d1ad347e15afe7828ad7055
Author: Diego Biurrun <diego@biurrun.de>
Date:   Wed May 7 13:20:43 2014 +0200

    build: Replace cltostr.pl by a shell script
    
    This avoids a dependency on Perl to build OpenCL support.

commit d8b6ce7f703d3c9d83dbd4e8ef44cfabc7e2f78e
Author: Diego Biurrun <diego@biurrun.de>
Date:   Tue Apr 15 23:02:39 2014 +0200

    build: Simplify phony target declaration with wildcards
    
    Also add etags to list of phony targets.

commit 2bd932fdf053faace84028a66d8ba9e17d526456
Author: Diego Biurrun <diego@biurrun.de>
Date:   Wed May 7 12:47:37 2014 +0200

    configure: Drop workaround for obsolete gcc 4.2 on ARM

commit 31311f254971e1da51d817cb580fc4fe1f4d5f20
Author: Diego Biurrun <diego@biurrun.de>
Date:   Wed May 7 21:43:15 2014 +0200

    build: Add dependencies on x86inc.asm/x86util.asm for all .asm files
    
    This is a little bit overzealous, but errs on the side of caution.
    Generating full dependency information is also possible, but slightly
    slows down the build as YASM cannot do it as a sideeffect of compilation.

commit 016831ec7b3a4a7062908243dbde62d7d89b334e
Author: Diego Biurrun <diego@biurrun.de>
Date:   Sun Apr 27 21:09:54 2014 +0200

    Delete all SPARC optimizations
    
    SPARC has been obsolete for a long time and makes little sense as a
    H.264 encoding platform.
    
    Also update authors file.

commit c7c8eb15923d1888bb87e7642a66b417fab61e76
Author: Diego Biurrun <diego@biurrun.de>
Date:   Wed May 7 12:46:42 2014 +0200

    configure: Don't check for libavcore
    
    libavcore was a never-released bad idea with a short lifespan.

commit dd5b5d3959e35c122c7709a9823a26b589c950da
Author: Diego Biurrun <diego@biurrun.de>
Date:   Sun Apr 27 23:19:04 2014 +0200

    build: Set all ASFLAGS from within configure
    
    This is how all other toolchain flags are handled.

commit c15f20bd772487d863f01a2813a3ab45b1f11a6b
Author: Diego Biurrun <diego@biurrun.de>
Date:   Sun Apr 27 23:23:49 2014 +0200

    opencl: Check return value of fread()
    
    common/opencl.c:138:10: warning: ignoring return value of 'fread', declared with attribute warn_unused_result [-Wunused-result]

commit af8e768e2bd3b4398bca033998f83b0eb8874914
Author: Fiona Glaser <fiona@x264.com>
Date:   Sat Jul 19 20:34:22 2014 -0700

    Disable i8x8 in lossless
    
    x264's implementation was slightly incorrect due to a vague spec, so some
    decoders decoded video incorrectly.
    
    Minimal impact on compression.

commit 450cf7ae2592ee0cb474bcefedf90c9911605e26
Author: Thomas Mundt <loudmax@yahoo.de>
Date:   Fri Jun 27 11:12:06 2014 -0700

    AVC-Intra: fix compatibility with Avid Transfermanager

commit 6eb483e4ca23f34a6a8fe09f3f2e9c9f192fd76b
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Jul 8 21:15:32 2014 +0200

    x86: Fix SIGILL in high bit-depth intra_sad_x3_4x4_sse2
    
    An SSE3 instruction was used in an SSE2 function.

commit 5e58ce7a8b39ab66c7d6420b85a8e09dd08dfaaf
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed Jul 9 17:01:54 2014 +0400

    Fix incorrect row predictor addressing
    
    Somehow managed to not cause things to explode, but was clearly incorrect.
    Might improve VBV in some cases to have this working right.

commit 3fda920e6f1e4a8f76680c001962542866408114
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat Jun 21 23:52:39 2014 +0400

    Fix b-pyramid MMCO remove for frame-packing==5

commit 92fdb43dd47fbc3368d9d9c7ad940fbe03657bd3
Author: Tal Aloni <tal.aloni.il@gmail.com>
Date:   Tue Jun 17 15:10:56 2014 -0700

    Fix frame-packing==5 with some decoders
    
    The spec mandates that frame-packing==5 requires the SEI on every frame that
    begins a view sequence (i.e. the input frames L0-R0-L1-R1 have 4 view sequences,
    but if reordered by the encoder to L0-L1-R0-R1 there are now 2 view sequences).
    For simplicity, we write the SEI on every frame.
    
    This fixes frame-packing==5 3D playback on some decoders (PlayStation 3, Sony
    W8 series, possibly others).

commit 13d6dfd83af98e472a9e9a8b6abf5c971707a893
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu May 22 13:27:00 2014 +0400

    Fix pixel_ssim_end4 asm function for x86_64 systems

commit a5831aa256b3161f898d2577d2eb8daa838d88d2
Author: James Almer <jamrial@gmail.com>
Date:   Wed Apr 9 03:33:06 2014 -0300

    x86: XOP pixel_sad_{x3, x4} high bit-depth

commit 0d989a4ff3298f9e495be452880b5f9bfb441e93
Author: James Almer <jamrial@gmail.com>
Date:   Wed Apr 9 03:33:05 2014 -0300

    x86: XOP pixel_ssd_nv12_core

commit 9b77dffab04e3ea242598454282b40800e720353
Author: James Almer <jamrial@gmail.com>
Date:   Wed Apr 9 03:33:04 2014 -0300

    x86util: XOP optimized HADDD

commit 1e517399f76b12fe2e73892970fe3aac01a178f8
Author: James Almer <jamrial@gmail.com>
Date:   Wed Apr 9 03:33:03 2014 -0300

    x86: add missing initialization for high bit-depth sa8d_satd

commit aa00925abd6f9ab4e20216ae5a5ad79b67756162
Author: James Almer <jamrial@gmail.com>
Date:   Sat Apr 5 23:46:31 2014 -0300

    x86: add missing initializations for high bit-depth variance

commit fadc4045f91ca78c046f301cba6065732b5d27ea
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Apr 1 22:11:45 2014 +0200

    arm: use the weight_fn_t typedef for mc weight function arrays

commit 644c396be97c1e6ace144f8be04afab19fb238af
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Apr 1 22:11:44 2014 +0200

    arm: correct x264_mc_chroma_neon function declaration

commit b2e9ca30f1e9ac25df1f592db04ff0d91faf42d4
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Apr 1 22:11:43 2014 +0200

    arm: do not export every asm function
    
    Based on Libav's libavutil/arm/asm.S. Also prevents having the same
    label twice for every function on systems not defining EXTERN_ASM.
    Clang's integrated assembler does not like it.

commit ceb1484da34b7492f539b535a930652690372fe5
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Tue Apr 1 22:11:42 2014 +0200

    arm: move all .macro/.endm to column 0

commit 24ab0e75db887c2b1a412d00878810ed6501061e
Author: William Grant <wgrant@ubuntu.com>
Date:   Sun Mar 23 09:21:52 2014 -0700

    aarch64: require PIC in shared mode

commit 435722c9c1870cd54fdb89be39250d492aecb598
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Sun Mar 16 17:21:58 2014 +0100

    arm: x264_coeff_last8_arm
    
    checkasm --bench on a coretex-a9:
    coeff_last8_c: 173
    coeff_last8_armv6: 151
    
    60 instead of 73 cycles in ~130k runs on the same cpu while encoding.

commit 2e96c571b8c324304b3d4fbb7914143518349213
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Sat Mar 15 20:09:18 2014 +0100

    arm: x264_store_interleave_chroma_neon
    
    store_interleave_chroma_c: 4036
    store_interleave_chroma_neon: 1043

commit 1576e51e52148ad1e1d8b5e76562f9eae8d47e6e
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Sat Mar 15 19:55:50 2014 +0100

    arm: x264_plane_copy_interleave_neon
    
    plane_copy_interleave_c: 40285
    plane_copy_interleave_neon: 10137

commit 0016dec27080e53c794d7f919bd6df6b890d0128
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Sat Mar 15 19:21:12 2014 +0100

    arm: x264_plane_copy_deinterleave_rgb_neon
    
    plane_copy_deinterleave_rgb_c: 31543
    plane_copy_deinterleave_rgb_neon: 8312

commit 5e0ca9aa4eab5e2cb4b124774c3ecebbc6f1ae35
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Sat Mar 15 18:22:49 2014 +0100

    arm: load_deinterleave_chroma_f{dec,enc}_neon
    
    load_deinterleave_chroma_fdec_c: 4055
    load_deinterleave_chroma_fdec_neon: 995
    load_deinterleave_chroma_fenc_c: 4071
    load_deinterleave_chroma_fenc_neon: 992

commit c9a5ae0d219b6a28adebdb83faf89f291611f57b
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Sat Mar 15 17:22:08 2014 +0100

    arm: x264_plane_copy_deinterleave_neon
    
    plane_copy_deinterleave_c: 42988
    plane_copy_deinterleave_neon: 10184

commit c570be3ea9f24942c362e1c2402ec7fccbb5c330
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Sat Mar 15 13:29:41 2014 +0100

    arm: implement deblock_strength_neon
    
    Based on deblock_strength_avx.
    
    checkasm --bench on a cortex-a9:
    deblock_strength_c: 14611
    deblock_strength_neon: 1848

commit 2794ba5bb0007e0edf32d5325ca82cbf654f79b0
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Sat Mar 15 10:51:11 2014 +0100

    arm: add missing macro instantiation for x264_pixel_avg_4x16_neon
    
    checkasm --bench on a cortex-a9:
    avg_4x16_c: 8910
    avg_4x16_neon: 2091

commit d6002ebace8194d17ee0ba607ff82c4f9075dd2d
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Thu Mar 13 01:02:13 2014 +0100

    arm: implement x264_predict_4x4_v_armv6
    
    Alone probably not worth it but allows use of predict_4x4_dc|h_armv6
    in intra_sad|satd_x3_4x4_neon.

commit d7e689680023e327de7e052e01e7faee30135799
Author: Roland Stigge <stigge@antcom.de>
Date:   Sun Mar 23 09:29:37 2014 -0700

    ppc: fix build on certain PowerPC variants without Altivec

commit 863ea2a224cf7380c7a6ea9ae531e16b621cc0b7
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Apr 22 00:58:24 2014 +0400

    Only add strip option '-s' for linker flags
    
    Fixes some build warnings with clang.

commit 4102614df9a11d66b506fb435132ddd0f88c6f94
Author: Tsukasa OMOTO <henry0312@gmail.com>
Date:   Sat Mar 15 16:53:53 2014 +0900

    configure: remove an unnecessary option from CFLAGS on OS X
    
    Fixes Clang 3.4 compilation on OS X.

commit b3fb718404d6cce9c82987ea2909cda5072d040c
Author: Fiona Glaser <fiona@x264.com>
Date:   Sun Feb 23 10:36:55 2014 -0800

    Macroblock tree overhaul/optimization
    
    Move the second core part of macroblock tree into an assembly function;
    SIMD-optimize roughly half of it (for x86). Roughly ~25-65% faster mbtree,
    depending on content.
    
    Slightly change how mbtree handles the tradeoff between range and precision
    for propagation.
    
    Overall a slight (but mostly negligible) effect on SSIM and ~2% faster.

commit 00a00ccab316de3d50da6a82ba4af44dcb4655ec
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Thu Mar 13 00:05:48 2014 +0100

    arm: use available neon functions for intra_sa8d/sad/satd_x3
    
    4% faster on main/medium, 15% faster on baseline/superfast on a cortex-a9.

commit ac8f2e8a4cf21b2026957509bea8865ff7879fb4
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Wed Mar 12 14:35:31 2014 +0100

    arm: implement x264_pixel_var2_8x16_neon
    
    checkasm --bench on a cortex-a9:
    var2_8x16_c: 5677
    var2_8x16_neon: 1421

commit 66836125beabdaff561da89ea1e18e566f5d202a
Author: Janne Grunau <janne-x264@jannau.net>
Date:   Wed Mar 12 13:16:00 2014 +0100

    arm: implement x264_pixel_var_8x16_neon
    
    checkasm --bench on a cortex-a9:
    var_8x16_c: 4306
    var_8x16_neon: 791

commit a90ea34cf264d6b7733c5ffbe6d46882c306b50f
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Feb 23 15:33:48 2014 +0100

    x86: SSE2 and SSSE3 plane_copy_deinterleave_rgb
    
    About 5.6x faster than C on Haswell.

commit f032147ca69401165495a36cf7aba5b8c95ecb3b
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Feb 16 21:24:54 2014 +0100

    x86: Minor mbtree_propagate_cost improvements
    
    Reduce the number of registers used from 7 to 6.
    Reduce the number of vector registers used by the AVX2 implementation from 8 to 7.
    Multiply fps_factor by 1/256 once per frame instead of once per macroblock row.
    Use mova instead of movu for dst since it's guaranteed to be aligned.
    Some cosmetics.

commit 7c860f075ccd14fb7891d5fc6c9eab1a37ea555d
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Feb 9 23:58:04 2014 +0100

    x86inc: Support arbitrary stack alignments
    
    If the stack is known to be at least 32-byte aligned we can safely store ymm
    registers on the stack without doing manual alignment.
    
    Change ALLOC_STACK to always align the stack before allocating stack space for
    consistency. Previously alignment would occur either before or after allocating
    stack space depending on whether manual alignment was required or not.

commit 039fab9203179f9e790abfd54ae5b2254ef803e7
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Feb 14 15:53:58 2014 +0400

    x86inc: warn if XOP integer FMA instruction emulation is impossible
    
    Emulation requires a temporary register if arguments 1 and 4 are the same; this
    doesn't obey the semantics of the original instruction, so we can't emulate
    that in x86inc.
    
    ffmpeg has an x86util emulation for that case; I'll add it if x264's asm ever
    needs it.
    
    Also add pmacsdql emulation.

commit 974f2e78e0cb25e06fedbcfef70f80938f22988b
Author: Loren Merritt <pengvado@akuvian.org>
Date:   Sat Mar 1 02:57:56 2014 +0000

    x86inc: free up variable name "n" in global namespace

commit 8596dd36df38d33d402e848035b1bd31edc2c389
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Jan 22 19:09:12 2014 +0100

    x86: Pass -Worphan-labels to yasm
    
    Makes it easier to detect typos.

commit 0bb3b2edb866dd852bb1f5faed88df4bdcf0c16f
Author: Steve Lhomme <robux@videolan.org>
Date:   Sun Feb 16 13:15:09 2014 +0100

    Write 3D metadata when outputting Matroska
    
    For when --frame-packing is set.

commit f35e3fc26b99e1b3c943c131100fdfa4733fc932
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Feb 23 16:56:03 2014 +0400

    Don't set chroma_loc_info_present_flag for non-4:2:0
    
    The H.264 spec says it shouldn't be set in these cases.

commit b7a50c16414631c8ff5e417da51b190c8999027e
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon Mar 10 08:42:50 2014 -0700

    x264.h: fix documentation
    
    The full details of the return values of encoder_encode and encoder_headers
    were mistakenly removed a while ago; re-add them.

commit de01d8821b59b85a01c8a89e544e0fed6488b958
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Feb 23 15:52:57 2014 +0400

    Fix pointer cast warning for 64-bit builds

commit 8b821ec19ba9425c120b8986a57ca7c6b9f088ed
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Mar 10 16:48:02 2014 +0400

    mbaff: fix mb_field_decoding_flag tracking and simplify allow skip check
    
    Fixes an issue with too many forced non-skips in mbaff+cavlc, as well as
    non-deterministic output with mbaff+cavlc+sliced-threads.

commit 850c8c5d6139df82e969d2174eebba69b479aa16
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Mar 10 03:22:57 2014 +0400

    Fix memory overwrite in x264_deblock_h_chroma_mbaff_sse2
    
    Fixes possible corruption with MBAFF+sliced threads.

commit 19dddbcff73541ae15f8e57383ff1c6aa907d99d
Author: Fiona Glaser <fiona@x264.com>
Date:   Sun Mar 2 10:09:01 2014 -0800

    Fix corruption with CAVLC overflow handling in MBAFF+main profile
    
    Probably a regression in r2178.

commit 48dbfa28201950f7e07e96a7d62b2951dd2dbe03
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Mar 10 21:17:19 2014 +0400

    Fix checkasm --bench output when nop_cycles is too large

commit ee8d5e4b51da99e576b5aea3008e70d1c7ed2372
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed Jan 22 12:54:49 2014 +0400

    Really fix quantization factor allocation
    
    Actually allocate less (instead of just initialize less) and fix comments.

commit 0d668be8d7525992c1c163c97551ee897e43c177
Author: Yu Xiaolei <dreifachstein@gmail.com>
Date:   Sun Feb 23 04:12:51 2014 -0800

    Fix build with Android NDK
    
    Android NDK does not expose sched_getaffinity.

commit 42d25196d423626c12794db3f66322c7a3f4375e
Author: Loren Merritt <pengvado@akuvian.org>
Date:   Thu Jan 16 13:34:46 2014 -0800

    x86inc: speed up compilation with yasm
    
    Work around yasm's inefficiency with handling large numbers of variables
    in the global scope.

commit dd6a303498d1f55c73037ed925a6ece8e28a95bc
Author: Kieran Kunhya <kieran@kunhya.com>
Date:   Fri Jan 10 23:27:33 2014 +0000

    Add support for AVC-Intra Class 200

commit 41227fa2531d9263e481b80237d2d9ef6f5a450f
Author: James Weaver <james.barrett@bbc.co.uk>
Date:   Tue Jan 7 10:31:58 2014 +0000

    v210 input support
    
    Assembly based on code by Henrik Gramner and Loren Merritt.

commit e2a9662751180b7dd2fe538913282ee800445445
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Jan 21 13:39:33 2014 -0800

    Fix quantization factor allocation
    
    We don't need to wastefully allocate quant tables above QP_MAX_SPEC; they're
    never used.

commit 8be6600d10a74ca241dbb27e096883ceed7b4082
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Jan 8 01:06:56 2014 +0100

    Avoid some unneccesary memory loads in macroblock_encode

commit 807aeaaae7351e4c2c536463e69dacaac218bccb
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jan 5 15:25:05 2014 +0100

    Bump dates to 2014
    
    Also update AUTHORS file and my e-mail address in the headers of various files.

commit 02697d57d987f8d51a5c3ced5e5b81d7137012ee
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Jan 6 00:18:31 2014 +0100

    Remove tools/xyuv.c
    
    It's an old stand-alone application that isn't relevant to x264.

commit 7664014b2b490d81a66f2a13138182dfaaf4be06
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Nov 7 02:37:23 2013 +0400

    Use 8x16c wrappers with x86 asm functions for 4:2:2 with high bit depth

commit 6bc63417e10e135d8cd881495c71be72d322e1d3
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Dec 20 22:44:28 2013 +0100

    CLI: Avoid redundant 16-bit upconversions in piped raw input
    
    It's not possible to seek in pipes, so if we want to skip frames we have to read and
    discard unused ones. It's pointless to do bit-depth upconversions in those frames.

commit 008c56ec467736bc5d3130ff890c618d28aa7511
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Jan 3 20:06:06 2014 +0400

    Fix input support from named pipes in Windows

commit 91481419e3acc4bb601600cf32e46e7f93ae02ab
Author: Steve Clark <sclark@vgocom.com>
Date:   Wed Nov 20 21:40:23 2013 +0400

    Fix ARM asm compilation with Apple assembler

commit a2f5d600bf866899db92e2dae40eb9fe46d44ade
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed Nov 13 19:24:48 2013 +0400

    Fix uninitialized variable
    
    Caused if the timebase is not specified in stats file. Found by Clang.

commit 95d196ef2edde109cfb32f4baa9b0adc67e842e1
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Oct 27 19:27:23 2013 +0400

    Remove --visualize option.
    
    It probably wasn't used or maintained for last few years.

commit 09c7010e3d13e66a241c0529b36ae3f7e1664ff4
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Oct 15 12:32:25 2013 +0400

    Add L-SMASH support as preferable alternative for MP4-muxing

commit c9f2bceb1f37aeaf6b7ed730f0fd210ef8725cab
Author: Kieran Kunhya <kieran@kunhya.com>
Date:   Sat Sep 21 19:16:12 2013 +0100

    Add AVC-Intra 1080p50/60 Class 100 parameters
    
    Also add some compatibility fixes.

commit c084f6c029f016cf2024a2fc511825e82fb95865
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon Sep 9 12:37:59 2013 -0700

    Add --filler option
    
    Allows generation of hard-CBR streams without using NAL HRD.
    Useful if you want to be able to reconfigure the bitrate (which you can't do
    with NAL HRD on).

commit 350b214c5abe7e82618ac46a14f23b7ab543045e
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Oct 27 15:22:51 2013 +0400

    Make x264_encoder_reconfig more threadsafe
    
    Do the reconfig when the next frame's encode begins.
    Fixes some rare crashes with frame-threading and encoder_reconfig.

commit 77cc44feea75106fae6d3113f6babbbe8cffba87
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Oct 24 17:19:00 2013 -0700

    chroma-me: take shortcut in BI analysis
    
    ~100 cycles faster with subme>=9

commit 7634f8c6047e9e12036778a8dc8d4cd4b06eebcb
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Oct 24 14:44:43 2013 -0700

    CRF-max: don't warn if VBV underflow occurs
    
    Only warn if underflow occurs for reasons other than CRF-max, as CRF-max
    implies that VBV underflow is desired by the user.

commit 4b68633dc375fc372f160a3ae669a32e519b285a
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Oct 18 22:43:36 2013 +0200

    x86inc: Make ym# behave the same way as xm#
    
    This makes more sense for future implementations of templates with zmm registers.

commit b54422a858809f39c00fac46207bfa8ad16cdb28
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Oct 18 22:21:38 2013 +0200

    Use calloc instead of malloc + memset

commit 8b58a4ce52047b00f5892a9cdd92f9695a50a933
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Oct 10 16:54:12 2013 +0200

    Replace gf_malloc with regular malloc in mp4 muxer
    
    It was used as a workaround for a bug that only existed in the GPAC repository
    for a few weeks back in 2010. There's no reason to keep it anymore.

commit 05f04384a10cb673abea7749cd319971c0017769
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Oct 8 23:20:40 2013 +0400

    Update to current libav/ffmpeg API

commit b7b6029f0e121b87fd96595b15d0c40fcd1b3bf1
Author: Rafaël Carré <funman@videolan.org>
Date:   Fri Oct 25 07:12:24 2013 -0700

    version.sh: change to use /bin/sh

commit c3c73f13bb9ee60ccf40f85dbc11c91efac9d1e2
Author: Sean McGovern <gseanmcg@gmail.com>
Date:   Wed Sep 4 14:15:00 2013 -0700

    configure: don't generate a git version number if .git isn't present

commit 12f9d499905199427a0196743c2cde56642d6d99
Author: Martin Storsjo <martin@martin.st>
Date:   Tue Sep 3 14:56:18 2013 -0700

    configure: include dependency libs in the Libs pkg-config
    
    If only a static library is built, the user of the library that just
    tries to link to the lib using the flags provided by pkg-config
    might not know that only a static lib exists and that he'd have to
    pass --static to pkg-config to get the internal dependencies to
    be able to link the library.
    
    For a shared build, the internal dependencies are kept in Libs.private
    as before.
    
    This matches how libav's pkg-config files are generated.

commit 03450be799dea03a83dad4dc833ef8ddd7f36b62
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Oct 18 00:38:06 2013 +0400

    Fix compilation in case of HAVE_LOG2F check fails spuriously

commit 266fdfcd4809afb018e45ab959d4a56a42712c88
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat Oct 12 12:01:57 2013 +0400

    Fix compilation of shared library for Windows with original MinGW toolchain

commit 50a0c33b9b5fa57d0a129b7441a6af55f7a08005
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Oct 8 23:32:37 2013 +0400

    Fix possible crashes in resize and crop filters with high bitdepth input

commit 5b272b22d8f7511a4abece5a23ad25282bedaea8
Author: Tim Mooney <Tim.Mooney@ndsu.edu>
Date:   Tue Sep 3 13:43:50 2013 -0700

    Fix INSTALL in configure for Solaris systems

commit 2fd292391a4d41b9fc65ee652b4663fdd9f8107e
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed Aug 28 00:50:31 2013 +0200

    Workaround for FFMS indexing bug
    
    If FFMS_ReadIndex is used with an empty index file it gets stuck in an infinite loop instead of returning NULL
    like it's supposed to do on failure. Explicitly check if the file is empty before calling it as a workaround.

commit 5bcff2a62c050376ca54c5e5040d0529c89eb9f2
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Aug 26 21:20:31 2013 +0400

    Fix masked access violation in KERNEL32
    
    Caused crashes under gdb in Windows and might cause other unknown problems.

commit 098b686e6397d5bb6b3a5c03cd918aa88216909f
Author: Hiroki Taniura <boiled.sugar@gmail.com>
Date:   Sun Aug 25 01:18:57 2013 +0900

    Fix GPAC support on Windows

commit fa3cac516cb71b8ece09cedbfd0ce631ca8a2a4c
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Aug 11 19:50:42 2013 +0200

    Windows Unicode support
    
    Windows, unlike most other operating systems, uses UTF-16 for Unicode strings while x264 is designed for UTF-8.
    
    This patch does the following in order to handle things like Unicode filenames:
    * Keep strings internally as UTF-8.
    * Retrieve the CLI command line as UTF-16 and convert it to UTF-8.
    * Always use Unicode versions of Windows API functions and convert strings to UTF-16 when calling them.
    * Attempt to use legacy 8.3 short filenames for external libraries without Unicode support.

commit 9b94896b3735052cabb52d081de3b50020a077cb
Author: Kieran Kunhya <kierank@ob-encoder.com>
Date:   Sat Jul 20 18:47:59 2013 +0100

    AVC-Intra support
    
    This format has been reverse engineered and x264's output has almost exactly
    the same bitstream as Panasonic cameras and encoders produce. It therefore does
    not comply with SMPTE RP2027 since Panasonic themselves do not comply with
    their own specification. It has been tested in Avid, Premiere, Edius and
    Quantel.
    
    Parts of this patch were written by Fiona Glaser and some reverse
    engineering was done by Joseph Artsimovich.

commit fa1e2b746d95575b5c5b8e49fcfcad3ded9a5420
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon Jul 8 12:06:42 2013 -0700

    Transparent hugepage support
    
    Combine frame and mb data mallocs into a single large malloc.
    Additionally, on Linux systems with hugepage support, ask for hugepages on
    large mallocs.
    
    This gives a small performance improvement (~0.2-0.9%) on systems without
    hugepage support, as well as a small memory footprint reduction.
    
    On recent Linux kernels with hugepage support enabled (set to madvise or
    always), it improves performance up to 4% at the cost of about 7-12% more
    memory usage on typical settings..
    
    It may help even more on Haswell and other recent CPUs with improved 2MB page
    support in hardware.

commit e33aac9aba5c6b9c867b92f14c7722152680a61a
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Jul 5 21:15:54 2013 +0200

    x86: SSSE3 implementation of pixel_sad_x3 and pixel_sad_x4

commit 4becc3e9e031c4207698846369aac2bef1480d15
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Jul 5 21:15:49 2013 +0200

    x86: Faster AVX2 pixel_sad_x3 and pixel_sad_x4

commit 401edc3ab08f95777d495b38030e2108d7d3f0b4
Author: Diogo Franco <diogomfranco@gmail.com>
Date:   Tue Jul 23 22:17:44 2013 -0300

    configure: Support cygwin64

commit adc99d17d8c1fbc164fae8319b40d7c45f30314e
Author: Derek Buitenhuis <derek.buitenhuis@gmail.com>
Date:   Fri Aug 9 13:39:27 2013 -0400

    x86inc: Check for __OUTPUT_FORMAT__ having a value of "x64"
    
    This is also a valid value for WIN64.

commit 1430b04988c3bb344e104c974ed3aa825035c0ec
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Jul 23 14:11:50 2013 -0700

    Fix cases in which intra refresh allowed prediction from disallowed pixels

commit a6c396f0fe01f453de115ba0d8c4aa26138aa6b4
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed Aug 7 01:56:34 2013 +0400

    Fix a few minor bugs found with a static analyzer

commit 2d66c7c2471801aa946517226739e9150f6c1948
Author: Fiona Glaser <fiona@x264.com>
Date:   Fri Jul 12 16:07:35 2013 -0700

    Fix AVX2 detection bug with "limit CPUID" enabled in BIOS

commit ff41804efd4caec120fc9e1b90ad226035f75aaa
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri Jul 5 21:15:43 2013 +0200

    x86: Remove X264_CPU_SSE_MISALIGN functions
    
    Prevents a crash if the misaligned exception mask bit is cleared for some reason.
    
    Misaligned SSE functions are only used on AMD Phenom CPUs and the benefit is miniscule.
    They also require modifying the MXCSR control register and by removing those functions
    we can get rid of that complexity altogether.
    
    VEX-encoded instructions also supports unaligned memory operands. I tried adding AVX
    implementations of all removed functions but there were no performance improvements on
    Ivy Bridge. pixel_sad_x3 and pixel_sad_x4 had significant code size reductions though
    so I kept them and added some minor cosmetics fixes and tweaks.

commit 01087fdbf2042095cb36458fd5c5efab3f4b3a37
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Jun 20 15:51:39 2013 -0700

    Tweak i16x16-delta-quant-avoidance code
    
    Don't omit the delta quant if it'd raise the quantizer to do so; this fixes
    a rare flickering issue caused by deblocking.

commit bfa2f0c44cec2e41fbd7566edb55e405f6c5a49d
Author: Fiona Glaser <fiona@x264.com>
Date:   Sun Jun 9 09:06:27 2013 -0700

    x86: faster AVX2 iDCT, AVX deblock_luma_h, deblock_luma_h_intra

commit 397f60e7f23e2c6ec2cb9b168ebb75cc42983dd7
Author: Lucien <astrataro@gmail.com>
Date:   Mon Jun 17 18:28:09 2013 +0000

    Add new color primaries, transfer characteristics, matrix coefficients

commit fa215fc9d77d131595e8b1eda0fc4e9da62c1f94
Author: Fiona Glaser <fiona@x264.com>
Date:   Fri May 31 17:01:29 2013 -0700

    Add "--stitchable" option for segmented encoding
    
    Stops x264 from attempting to optimize global stream headers, ensuring that
    different segments of a video will have identical headers when used with
    identical encoding settings.

commit 9143d5ad966a3864597009ba1f1befe87328ec61
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Jun 27 08:29:06 2013 -0700

    Interface: if vbv-maxrate < bitrate, set bitrate = vbv-maxrate
    
    This probably makes more sense to the user than setting vbv-maxrate = bitrate,
    as before.

commit 83d35c7bc4332e4dd27ba7b8baf96f8743c52a8b
Author: Anton Mitrofanov <Bugmaster@narod.ru>
Date:   Tue May 28 05:02:42 2013 -0700

    OpenCL cosmetics

commit ffc3ad4945da69f3caa2b40e4eed715a9a8d9526
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Jun 18 00:16:33 2013 +0400

    Fix possible crash when writing very large filler NALUs
    
    Bitstream-reallocation function didn't handle the case of filler.

commit 25ef3f5fdbfca0f9a5ff8a97b8475e7f8b4c9202
Author: Loren Merritt <pengvado@akuvian.org>
Date:   Mon Jun 17 11:27:09 2013 -0700

    Fix build with PIC on some systems

commit c41b629d4831cde47a8c0cde435041cc3b996d85
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jun 2 18:41:17 2013 +0200

    Fix potential misaligment crash in AVX2 denoise_dct

commit e32d9c21339cbb021d6c9ad5897bfde09dcdb63a
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue May 28 01:48:15 2013 +0400

    Fix building with compilers without inline asm support
    
    Also fix crash in high bit depth builds compiled with unaligned stack.

commit 3b8e924639ac67a4beb0ebe9b9663de03cdce84d
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed May 22 22:43:59 2013 +0400

    Fix compilation with OpenCL on MacOS X
    
    Also fix crash in the case of OpenCL error during encoding.

commit 3aa9a67b6d62bcf11ee69397647230700a32044b
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon May 6 22:51:11 2013 +0400

    OpenCL support improvement/refactoring
    
    Autoload the OpenCL library so that it's not required to run an openCL-enabled
    build of x264.
    
    Update X264_BUILD, which should have been changed with the first patch.

commit 0b2c3d35c168011e73300da5fdc690e00a8238e0
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu May 16 13:51:37 2013 -0700

    x86: shave a few instructions off AVX deblock

commit e7cb328580c3e1bd7604a64f40abf3e03c474771
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue May 14 18:57:40 2013 +0200

    x86: AVX2 dequant_4x4_dc

commit edf31ed3577f35e7ed3934dd74be474f9d22384a
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue May 14 18:53:12 2013 +0200

    x86: AVX2 high bit-depth dequant

commit bc88d1bb331ee061c38bea80f7a54a76797c31d0
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu May 9 17:20:05 2013 -0700

    x86-64: 64-bit variant of AVX2 hpel_filter
    
    ~5% faster than 32-bit.

commit 89f067b7cacecf413569e84c6c973c23f67b1ad3
Author: Henrik Gramner <henrik@gramner.com>
Date:   Mon May 6 18:41:24 2013 +0200

    x86: AVX2 high bit-depth denoise_dct
    
    28->15 cycles
    
    Also reorder instructions to use fewer registers, 3 cycles faster on Ivy Bridge with 64-bit Windows.

commit 481e4cdb52989e4b514a2f4345870a19c5c0ae92
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat May 4 18:48:58 2013 +0200

    x86: AVX2 high bit-depth quant
    
    quant_4x4: 13->6 cycles
    quant_4x4_dc: 14->8 cycles
    quant_8x8: 47->24 cycles
    quant_4x4x4: 48->25 cycles

commit 02aa1368da5c222c8833724abccddd8f02630fc6
Author: Fiona Glaser <fiona@x264.com>
Date:   Wed May 1 14:32:11 2013 -0700

    x86: AVX2 add16x16_idct_dc
    
    27 -> 19 cycles

commit 0c00c2c7882de130184e02cf1861599aedb425e8
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon Apr 29 16:16:54 2013 -0700

    x86: faster AVX2 quant_4x4x4
    
    10->9 cycles

commit af6647e0e7d647c660003f65b78b4f1a0b186ec2
Author: Fiona Glaser <fiona@x264.com>
Date:   Sat Apr 27 21:03:32 2013 -0700

    x86: AVX2 intra_sad_x3_8x8c
    
    30->22 cycles

commit f114746df6ce6a1bcacf46c62b696cc309ab4527
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Apr 28 11:11:03 2013 +0200

    x86: AVX2 high bit-depth intra_sad_x3_8x8
    
    43->24 cycles

commit 8e4f045f815a59ca3d6398ff4ddae7af44766dc8
Author: Fiona Glaser <fiona@x264.com>
Date:   Wed Apr 24 14:22:15 2013 -0700

    x86: AVX2 deblock strength
    
    30->18 cycles

commit 594dd84cb85e616f4e260f7fdef6ce5a34360ac7
Author: Henrik Gramner <henrik@gramner.com>
Date:   Wed May 1 17:42:48 2013 +0200

    x86: Faster high bit-depth intra_sad_x3_4x4
    
    20->16 cycles on Ivy Bridge

commit a8384178bd917576469da040923976cb531be38c
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Apr 30 17:36:46 2013 -0700

    x86: faster SSSE3 hpel
    
    ~7% faster using the pmulhrsw trick from mc_chroma.

commit 1f5a32c2459ed6f42d9c150d008e3471d61af3ee
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon Apr 29 14:22:23 2013 -0700

    x86-64: faster SSSE3 trellis
    
    ~2% faster trellis.

commit 7cbb27f0ce5ea3e756c628ac606f65d7de57f285
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu May 2 17:10:26 2013 -0700

    x86: 32-byte align the stack if possible
    
    Avoids the need for manual 32 byte array alignment on compilers that support
    -mpreferred-stack-boundary.

commit 30c91f62906ce08b5d227002b38ebd64f1291fae
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat May 11 23:39:09 2013 +0200

    x86inc: Utilize the shadow space on 64-bit Windows
    
    Store XMM6 and XMM7 in the shadow space in functions that clobbers them.
    This way we don't have to adjust the stack pointer as often,
    reducing the number of instructions as well as code size.

commit 33c352673900bd1b362bb2fe0284e999fccd633d
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri May 3 23:06:10 2013 +0200

    x86: Don't use explicitly aligned versions of SAD on AVX CPUs
    
    On modern CPUs movdqu isn't slower than movdqa when used on aligned data and using the same code in both cases saves cache.
    
    This was already done for the high bit-depth AVX2 implementation but the aligned version still exists as dead code so remove that.

commit 16d037211f1dd032288e25ab74d93a569fd93d6c
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri May 3 20:18:03 2013 +0200

    x86: Add missing initializations for high bit-depth sad_aligned

commit 25e219ad2565e52a6962eb1e16cf19f3482e655b
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon May 13 16:52:18 2013 -0700

    x86: add Jaguar CPU detection

commit c1e37099627b1dc2f15b295aa4c2eedd431a6dba
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue May 7 17:21:03 2013 +0200

    x86inc: Remove .rodata kludges
    
    The Mach-O bug was fixed in yasm 0.8.0 and we don't support versions that old.
    
    a.out was superseded by ELF on sane systems a few decades ago.

commit 5444e95a5c9ee866625b1122a19dbae6bf044008
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat May 4 16:21:32 2013 +0200

    checkasm: Use 64-bit cycle counters
    
    Prevents overflows that can occur in some cases.

commit 0e000e7a763c9bb5c14257bad365144025013fc9
Author: Henrik Gramner <henrik@gramner.com>
Date:   Fri May 10 13:55:32 2013 +0200

    checkasm: Fix stack alignment bug

commit 3ba0fb847b1a14f9db5f3dabe209eee2d4edc91d
Author: Fiona Glaser <fiona@x264.com>
Date:   Wed May 8 10:48:41 2013 -0700

    Fix invalid memcpy in sliced-threads
    
    Likely didn't actually break in practice, but memcpy with src==dst
    is incorrect.

commit 7f3606572957b63f1169bc793ed55bccdb549d56
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon Apr 29 12:14:01 2013 -0700

    Fix two bugs in slice-min-mbs and slices-max
    
    Slices-max broke slice-max-size when slice-max wasn't used.
    Slice-min-mbs broke in rare cases near the end of a threadslice.

commit 67d6f602018d0fc1cb05cd6240e4fe1c2646169f
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Apr 4 18:00:23 2013 -0700

    x86: SSSE3 LUT-based faster coeff_level_run
    
    ~2x faster coeff_level_run.
    Faster CAVLC encoding: {1%,2%,7%} overall with {superfast,medium,slower}.
    Uses the same pshufb LUT abuse trick as in the previous ads_mvs patch.

commit c17d12f83381913650d84004815c20a1f7092144
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon Mar 25 14:03:37 2013 -0700

    x86-64: BMI2 cabac_residual functions

commit 40316f836d42cb5aee8de5ae6b4a5e417d8446f8
Author: Fiona Glaser <fiona@x264.com>
Date:   Wed Mar 20 15:08:35 2013 -0700

    x86: SSSE3 ads_mvs
    
    ~55% faster ads in benchasm, ~15-30% in real encoding.
    ~4% faster "placebo" preset overall.

commit 03396f82bd1a709aa83d15de0affd0c4c5bd621d
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 16 23:27:53 2013 +0200

    x86: AVX2 pixel_ssd_nv12_core

commit dc05aebbc51b64b6cf3cfa95a1fbb20f6ffe94c6
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 16 23:27:50 2013 +0200

    x86: AVX2 high bit-depth pixel_ssd

commit f49c2eba352a9087301dfc3c3de902ab083bd9e9
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 16 23:27:46 2013 +0200

    x86: AVX2 high bit-depth pixel_sad_x3/pixel_sad_x4
    
    Also reduce the number of xmm registers used by sse2/ssse3 pixel_sad_x3.

commit 0e69048d4f9664f1293c5eed0604522c67adaff5
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 16 23:27:43 2013 +0200

    x86: AVX2 high bit-depth vsad

commit 9f885c112d6566388d472da68ada0301ce330311
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 16 23:27:39 2013 +0200

    x86: AVX2 high bit-depth pixel_sad
    
    Also use loops instead of duplicating code; reduces code size by ~10kB with
    negligible effect on performance.

commit 295f83af2afa93073d7810ab96b1d8d889a53ed2
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 16 23:27:35 2013 +0200

    x86: AVX2 high_bit_depth pixel_avg2, get_ref, mc_copy_w16, mc_luma
    
    Also reduce the number of xmm registers used by mc_copy_* to avoid
    saving and restoring xmm6 and xmm7 on 64-bit Windows.

commit e7a46b6536ab3ea4806f585b771b6cbb261031d1
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 16 23:27:32 2013 +0200

    x86: AVX2 nal_escape
    
    Also rewrite the entire function to be faster and drop the AVX version which is no longer useful.

commit 547a6573af56afe8d551201245775c6ba179e781
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 16 23:27:29 2013 +0200

    x86: AVX memzero_aligned

commit 0f776f63daf47eac9b69ef77aaf7c9c16213cba9
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 16 23:27:25 2013 +0200

    x86: AVX2 predict_16x16_dc

commit 97ad171ae33c51f48e6214abdf7c978e4dd5d2d1
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 16 23:27:22 2013 +0200

    x86: AVX2 predict_8x8c_p/predict_8x16c_p

commit 8ecdeb2709b4b7095237330e68e9a76ea8060a2f
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 16 23:27:18 2013 +0200

    x86: AVX2 predict_16x16_p
    
    Also fix the AVX implementation to correctly use the SSSE3 inline asm
    instead of SSE2.

commit f3d521da8163bb9a381284ef0b5c949b8a5c9f9c
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 16 23:27:14 2013 +0200

    x86: AVX high bit-depth predict_16x16_v
    
    Also restructure some code to reduce code size of various functions,
    especially in high bit-depth.

commit fa40b44f339501917e7a7c003ab826bf3e7b6a10
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 16 23:27:08 2013 +0200

    x86: AVX2 high bit-depth predict_4x4_h

commit 7908dc632330b6028ab7dae42834e2098e628b24
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 16 23:27:04 2013 +0200

    x86: AVX2 high bit-depth predict_16x16_h

commit 51708c3e193438439aaeaf31c377b070ca403e0e
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 16 23:27:00 2013 +0200

    x86: AVX2 high bit-depth predict_8x8c_h/predict_8x16c_h

commit 184c50554ae95aa60edd3fa309ca8013e00a8648
Author: Henrik Gramner <henrik@gramner.com>
Date:   Tue Apr 16 23:26:47 2013 +0200

    x86util: Support ymm registers in HADD macros

commit 0ea5be852e97d8cfdf04e384a8a78210f87c2dc0
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Feb 26 16:26:34 2013 -0800

    x86: more AVX2 framework, AVX2 functions, plus some existing asm tweaks
    
    AVX2 functions:
    mc_chroma
    intra_sad_x3_16x16
    last64
    ads
    hpel
    dct4
    idct4
    sub16x16_dct8
    quant_4x4x4
    quant_4x4
    quant_4x4_dc
    quant_8x8
    SAD_X3/X4
    SATD
    var
    var2
    SSD
    zigzag interleave
    weightp
    weightb
    intra_sad_8x8_x9
    decimate
    integral
    hadamard_ac
    sa8d_satd
    sa8d
    lowres_init
    denoise

commit 19e1a2bbf2d1aaa15ea2d2c118b0236ff64b4bd1
Author: Loren Merritt <pengvado@akuvian.org>
Date:   Mon Feb 25 21:16:45 2013 +0000

    x86inc: create xm# and ym#, analagous to m#
    
    For when we want to mix simd sizes within one function.

commit 3a8dfb2bc62be21215b6f7d47c53c5a912878656
Author: Fiona Glaser <fiona@x264.com>
Date:   Fri Apr 5 16:08:35 2013 -0700

    x86inc: fix AVX emulation of cmp(p|s)(s|d)

commit a3f5c7326c0aa707ccbd5a938a0b65581888b549
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Feb 5 17:15:00 2013 -0800

    x86-64: cabac_block_residual assembly
    
    RDO: ~20% faster than C
    Bitstream: ~50% faster than C
    1-2% faster overall, highest on preset superfast/fast/medium.

commit f49a1b2ef6d95d8f0f186df0fc3bfe38414e264f
Author: Steve Borho <steve@borho.org>
Date:   Thu Feb 21 12:48:40 2013 -0600

    OpenCL lookahead
    
    OpenCL support is compiled in by default, but must be enabled at runtime by an
    --opencl command line flag. Compiling OpenCL support requires perl. To avoid
    the perl requirement use: configure --disable-opencl.
    
    When enabled, the lookahead thread is mostly off-loaded to an OpenCL capable GPU
    device.  Lowres intra cost prediction, lowres motion search (including subpel)
    and bidir cost predictions are all done on the GPU.  MB-tree and final slice
    decisions are still done by the CPU.  Presets which do not use a threaded
    lookahead will not use OpenCL at all (superfast, ultrafast).
    
    Because of data dependencies, the GPU must use an iterative motion search which
    performs more total work than the CPU would do, so this is not work efficient
    or power efficient. But if there are spare GPU cycles to spare, it can often
    speed up the encode. Output quality when OpenCL lookahead is enabled is often
    very slightly worse in quality than the CPU quality (because of the same data
    dependencies).
    
    x264 must compile its OpenCL kernels for your device before running them, and in
    order to avoid doing this every run it caches the compiled kernel binary in a
    file named x264_lookahead.clbin (--opencl-clbin FNAME to override).  The cache
    file will be ignored if the device, driver, or OpenCL source are changed.
    
    x264 will use the first GPU device which supports the required cl_image
    features required by its kernels. Most modern discrete GPUs and all AMD
    integrated GPUs will work.  Intel integrated GPUs (up to IvyBridge) do not
    support those necessary features. Use --opencl-device N to specify a number of
    capable GPUs to skip during device detection.
    
    Switchable graphics environments (e.g. AMD Enduro) are currently not supported,
    as some have bugs in their OpenCL drivers that cause output to be silently
    incorrect.
    
    Developed by MulticoreWare with support from AMD and Telestream.

commit 2d0c47a50622ec59ade303cf150c21b8910a2bce
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon Mar 4 15:19:47 2013 -0800

    weightp: improve scale/offset search, chroma
    
    Rescale the scale factor if the offset clips. This makes weightp more effective
    in fades to/from white (and an other situation that requires big offsets).
    
    Search more than 1 scale factor and more than 1 offset, depending on --subme.
    
    Try to find the optimal chroma denominator instead of hardcoding it.
    
    Overall improvement: a few percent in fade-heavy clips, such as a sample from
    Avatar: TLA.

commit 732e4f7e8b9ab6d214cbcf059445b4712709faa4
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Feb 19 13:48:44 2013 -0800

    Add slices-max feature
    
    The H.264 spec technically has limits on the number of slices per frame. x264
    normally ignores this, since most use-cases that require large numbers of
    slices prefer it to. However, certain decoders may break with extremely large
    numbers of slices, as can occur with some slice-max-size/mbs settings.
    
    When set, x264 will refuse to create any slices beyond the maximum number,
    even if slice-max-size/mbs requires otherwise.

commit fdfffa3058cb590765dbb34afa5706755dcb5319
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Feb 14 17:22:02 2013 -0800

    Add slice-min-mbs feature
    
    Works in conjunction with slice-max-mbs and/or slice-max-size to avoid overly
    small slices.
    Useful with certain decoders that barf on extremely small slices.
    
    If slice-min-mbs would be violated as a result of slice-max-size, x264 will
    exceed slice-max-size and print a warning.

commit 8a3a41de9e5f54cb6e7b5c69486e50471a5c022d
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Mar 26 18:56:21 2013 +0400

    Disable mbtree asm with cpu-independent option
    
    Results vary between versions because of different rounding results.

commit bf52bab4e5607d7f3d98b3999a13cb8149aeef1c
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Mar 26 18:30:00 2013 +0400

    Show "avs: no" --disable-avs option instead of empty string

commit e74287e93b0ee7afb384624f60dc440b736fec6b
Author: Tim Walker <tdskywalker@gmail.com>
Date:   Tue Mar 19 23:42:43 2013 +0100

    lavf input: don't use deprecated AVStream fields
    
    Fixes building against newer libavcodecs from the Libav project.

commit aa73459b710f4c08b654d69573c22fd2fc2a99f8
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Mar 26 19:54:36 2013 +0400

    Fix y4m input with C420paldv colorspace

commit 42c500af62fbe09e7a55ecd47fc72331fbe4ae02
Author: Fiona Glaser <fiona@x264.com>
Date:   Sat Mar 2 01:22:29 2013 -0800

    x86: correctly check stack alignment for Atom hadamard_ac
    
    Regression in r2265 (only affected compilers with broken stack alignment,
    like ICL on win32).

commit bed18d0e4545e7528bf585a1a3c7fbc05ddbafa4
Author: Loren Merritt <pengvado@akuvian.org>
Date:   Mon Feb 25 21:23:55 2013 +0000

    x86inc: fix some corner cases of SWAP
    
    SWAP with >=3 named (rather than numbered) args
    PERMUTE followed by SWAP with 2 named args
    used to produce the wrong permutation

commit 3cdaca1ac2f6022b1affcd24eff397a03b59fce3
Author: Fiona Glaser <fiona@x264.com>
Date:   Wed Feb 27 13:30:22 2013 -0800

    Fix array overreads that caused miscompilation in gcc 4.8

commit 37033444036210ddab75c3ec5b9b5c2a5abb9d52
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Feb 28 13:32:37 2013 -0800

    Fix undefined behavior in x264_ratecontrol_mb

commit cb4547aefb624105b622368aad62c947f89cc4b1
Author: Stefan Groenroos <stefan.gronroos@gmail.com>
Date:   Fri Mar 1 22:35:34 2013 +0200

    ARM: Fix bug in x264_quant_4x4x4_neon
    
    Regression in r2273.

commit 3a8baa0ec68c50db3194ed778d0e744d6311cda3
Author: Stefan Groenroos <stefan.gronroos@gmail.com>
Date:   Mon Feb 25 23:43:09 2013 +0200

    ARM: update NEON mc_chroma to work with NV12 and re-enable it
    
    Up to 10-15% faster overall.

commit 215f2beeadb2ade3a318b397f25b8a6ad3a761d1
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Feb 14 15:00:48 2013 -0800

    CABAC/CAVLC: use the new bit-iterating macro here too

commit 993c81e94eebaacddbbfcec665831d07d89490b7
Author: Fiona Glaser <fiona@x264.com>
Date:   Fri Feb 8 15:34:38 2013 -0800

    quant_4x4x4: quant one 8x8 block at a time
    
    This reduces overhead and lets us use less branchy code for zigzag, dequant,
    decimate, and so on.
    Reorganize and optimize a lot of macroblock_encode using this new function.
    ~1-2% faster overall.
    
    Includes NEON and x86 versions of the new function.
    Using larger merged functions like this will also make wider SIMD, like
    AVX2, more effective.

commit 5ee1d03a8b86915d98b165d067dce377df3a87ba
Author: Stephen Hutchinson <qyot27@gmail.com>
Date:   Tue Feb 12 21:55:43 2013 -0500

    Add AvxSynth support to the AviSynth input module.
    
    Uses dlopen to load AvxSynth on Linux and OS X.
    
    Allows the use of --demuxer avs for AvxSynth, though the only source filter it
    can currently use is FFMS2.
    
    Add a local copy of avxsynth_c.h and its dependent headers in extras/ so that
    users don't need to actually have AvxSynth development headers installed to
    enable support for it (mirroring the AviSynth behavior).
    
    Based on a patch by 0x09 (tab@lavabit.com)

commit 7b1301e946218cfe6e072fea03702754ee0cc8a6
Author: Fiona Glaser <fiona@x264.com>
Date:   Fri Feb 8 00:13:15 2013 -0800

    Eliminate some branchiness in ME/analysis
    
    Faster, fewer branch mispredictions.

commit 7de9a9aa4bc06843dd7d8afe6bc42c02e27b6b73
Author: Fiona Glaser <fiona@x264.com>
Date:   Wed Feb 6 16:55:39 2013 -0800

    Fix some store forwarding stalls
    There's quite a few others, but most of them don't help to fix or there's no
    easy way to avoid them.

commit 68a6268bae989c55a02b7e86b169bd1a02793a95
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Feb 5 01:23:23 2013 -0800

    x86: faster AVX satd/sa8d/sa8d_satd/hadamard_ac
    
    Use Conroe-style movddup in AVX transforms; both Sandy Bridge and Bulldozer
    do movddup in the load unit, so it's totally free this way.
    
    On Sandy Bridge:
    ~6% faster sa8d_satd
    ~5% faster hadamard_ac
    ~9% faster 32-bit satd
    ~2% faster sa8d

commit 5d60b9c9ad794a666d0cfe0dd9d66d5b9f58e033
Author: Fiona Glaser <fiona@x264.com>
Date:   Sat Feb 2 12:37:08 2013 -0800

    x86: detect Bobcat, improve Atom optimizations, reorganize flags
    
    The Bobcat has a 64-bit SIMD unit reminiscent of the Athlon 64; detect this
    and apply the appropriate flags.
    
    It also has an extremely slow palignr instruction; create a flag for this to
    avoid massive penalties on palignr-heavy functions.
    
    Improve Atom function selection and document exactly what the SLOW_ATOM flag
    covers.
    
    Add Atom-optimized SATD/SA8D/hadamard_ac functions: simply combine the ssse3
    optimizations with the sse2 algorithm to avoid pmaddubsw, which is slow on
    Atom along with other SIMD multiplies.
    
    Drop TBM detection; it'll probably never be useful for x264.
    
    Invert FastShuffle to SlowShuffle; it only ever applied to one CPU (Conroe).
    
    Detect CMOV, to fail more gracefully when run on a chip with MMX2 but no CMOV.

commit 75d927053ef5546eb011ff5a5ac19152dd4e3c63
Author: Oskar Arvidsson <oskar@irock.se>
Date:   Sat Jan 19 01:47:09 2013 +0100

    x86: combined SA8D/SATD dsp function
    
    Speedup is most apparent for 8-bit (~30%), but gives some improvements
    for 10-bit too (~12%).
    64-bit only for now.

commit 790c648d939240808659228f57a22633fc59d6d8
Author: Oskar Arvidsson <oskar@irock.se>
Date:   Tue Jan 29 23:44:32 2013 +0100

    x86: port SSE2+ SATD functions to high bit depth
    
    Makes SATD 20-50% faster across all partition sizes but 4x4.

commit 93bf1248f7409958818b281e3e6ecca75ddb8d86
Author: Oskar Arvidsson <oskar@irock.se>
Date:   Wed Feb 6 02:07:53 2013 +0100

    x86: faster high bit depth ssd
    
    About 15% faster on average.

commit 6371c3a527a337c7521912990c89d0474288e105
Author: Fiona Glaser <fiona@x264.com>
Date:   Fri Jan 18 22:55:46 2013 -0800

    x86: optimize and clean up predictor checking
    Branchlessly handle elimination of candidates in MMX roundclip asm.
    Add a new asm function, similar to roundclip, except without the round part.
    Optimize and organize the C code, and make both subme>=3 and subme<3 consistent.
    Add lots of explanatory comments and try to make things a little more understandable.
    ~5-10% faster with subme>=3, ~15-20% faster with subme<3.

commit 004640653ded52f447ffdb71a45b334dc8e6f3d1
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Jan 22 12:31:55 2013 -0800

    Fix two bugs in predictor checking
    pmv wasn't checked properly in some cases, as well as zero vector.
    Output-changing portion of the following patch.

commit d2a9d25429b6843874865a37a5b4f6b401d89abc
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Jan 10 13:15:52 2013 -0800

    Improve lookahead-threads auto selection
    Smarter decision to improve fast-first-pass performance in 2-pass encodes.
    Dramatically improves CPU utilization on multi-core systems.
    
    Tested on a quad-core Ivy Bridge (12 threads, 1080p):
    Fast first pass:
    veryfast:     ~7% faster
    faster:      ~11% faster
    fast/medium: ~15% faster
    slow/slower: ~42% faster
    veryslow:    ~55% faster
    CRF/1-pass:
    veryfast:     ~9% faster
    (all others remained the same)

commit 5a764328bdeba650d99fc8db47275708cce79521
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jan 27 23:01:59 2013 +0100

    x86: Use SSE instead of SSE2 for copying data
    
    Reduces code size because movaps/movups is one byte shorter than movdqa/movdqu.
    Also merge MMX and SSE versions of memcpy_aligned into a single macro.

commit c3983b811f42ae5e4bc4f9c1c919f8e548fc76e3
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jan 13 18:27:08 2013 +0100

    64-bit cabac optimizations
    
    ~4% faster PIC
    
    WIN64:
    ~3% faster and 16 byte shorter cabac_encode_bypass
    ~8% faster cabac_encode_terminal
    Benchmarked on Ivy Bridge
    
    UNIX64:
    One instruction less in cabac_encode_bypass

commit f6e0d28ae1bccbda43d95200162f7035661fe1e4
Author: Mike Gorchak <mike.gorchak.qnx@gmail.com>
Date:   Sat Feb 2 23:35:00 2013 -0800

    configure: add QNX support

commit 5e0fca86444840752eaedbdc5ebfe4ac0b3a0053
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sun Jan 20 19:35:06 2013 +0100

    Windows: Enable DEP and ASLR

commit 5ec5c78920914a88da415c57904fa01c99deeb7b
Author: Henrik Gramner <henrik@gramner.com>
Date:   Thu Jan 17 19:17:24 2013 +0100

    x86inc: Set ELF hidden visibility for global constants

commit fd2c4a06c3a4eb02fc1375de782bc5d36eb1d744
Author: Diego Biurrun <diego@biurrun.de>
Date:   Thu Jan 17 11:18:31 2013 +0100

    x86inc: Add cvisible macro for C functions with public prefix
    
    This allows defining externally visible library symbols.
    
    Signed-off-by: Diego Biurrun <diego@biurrun.de>

commit faf3dbe616c8339590409c9aa25777fa76c987a6
Author: Diego Biurrun <diego@biurrun.de>
Date:   Thu Jan 17 11:30:37 2013 -0800

    x86inc: rename program_name to private_prefix
    Synced from libav.
    The new name is more descriptive and will allow defining a separate public
    prefix for externally visible library symbols.

commit 32695340b0e93e3cc7edd1b5e7db064d94cd3701
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon Jan 14 05:35:30 2013 -0800

    x264.h: improve x264_encoder_reconfig documentation

commit 6a82e49370e46914ab479d57548508ccf29da6e5
Author: Henrik Gramner <henrik@gramner.com>
Date:   Sat Feb 16 19:36:50 2013 +0100

    Cosmetics: stricter definition of parameterless functions

commit b671762973a162705ceacf924a29999cdc6d35d2
Author: Neil <neilpiken@gmail.com>
Date:   Mon Jan 28 10:47:38 2013 +0800

    Update "Install and compile x264" in doc/regression_test.txt

commit 43ff8f1681c1cca997ca916508723abea85d0fa2
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Thu Jan 24 12:11:26 2013 +0400

    Fix possible non-determinism with mbtree + open-gop + sync-lookahead
    
    Code assumed keyframe analysis would only pull one frame off the list; this
    isn't true with open-gop.

commit c2c2a95708685156a643e920b497d48597e0267c
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Feb 25 19:28:19 2013 +0400

    x86: don't use the red zone on win64

commit 5743b19a8264415ab3ed443abd2fefd81a038d6a
Author: Fiona Glaser <fiona@x264.com>
Date:   Sun Feb 10 16:12:34 2013 -0800

    x86-64: fix trellis asm with interlacing
    
    Regression in r2145.
    Assembly assumed array was [2][64] when it was actually [2][63].
    Tiny (~0.1%) compression improvement.

commit 9475e6ac48af90e526611b5f11a2690fa077b0ba
Author: Ronald S. Bultje <rsbultje@gmail.com>
Date:   Wed Jan 30 09:48:14 2013 -0800

    x86-32: use simple nop codes for <= sse
    
    The "CentaurHauls family 6 model 9 stepping 8" family of CPUs (flags:
    fpu vme de pse tsc msr cx8 sep mtrr pge mov pat mmx fxsr sse up rng
    rng_en ace ace_en) SIGILLs on long nop codes.

commit 732b072ae236b57cabdbc3b31cd7b482d1f9f9ff
Author: Loren Merritt <pengvado@akuvian.org>
Date:   Tue Jan 8 21:30:57 2013 +0000

    Bump dates to 2013

commit f2b4f29c636d5e5c223650c5b22bd8089adfcab9
Author: Henrik Gramner <hengar-6@student.ltu.se>
Date:   Mon Dec 17 21:54:00 2012 +0100

    x86inc: Drop tzcnt workaround
    
    It is no longer needed now that we've bumped the version requirement of yasm to 1.2.0.

commit ccda1ba4d8d902945c68aa25ec20867055d1b079
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon Nov 12 10:28:53 2012 -0800

    AVX2/FMA3 version of mbtree_propagate
    First AVX2 function for testing.
    Bump yasm version to 1.2.0 for AVX2 support.

commit 8a9608bbbdf77ceb3ee537271549111468175a2b
Author: Henrik Gramner <hengar-6@student.ltu.se>
Date:   Tue Dec 11 16:05:34 2012 +0100

    x86inc: Use VEX-encoded instructions in AVX functions
    Automatically use VEX-encoding in AVX/AVX2/XOP/FMA3/FMA4 functions for all instructions that exists in a VEX-encoded version.
    This change makes it easier to extend existing code to use AVX2.
    Also add support for AVX emulation of a few instructions that were missing before.

commit 4cf272851a9d24aacdf664f27a87ebdbfb50e6c2
Author: Loren Merritt <pengvado@akuvian.org>
Date:   Sun Dec 2 15:56:30 2012 +0000

    x86inc: activate REP_RET automatically
    Now RET checks whether it immediately follows a branch, so the programmer dosen't have to keep track of that condition.
    REP_RET is still needed manually when it's a branch target, but that's much rarer.
    The implementation involves lots of spurious labels, but that's ok because we strip them.

commit b073e870d135ac27cd97d624330abf0f1fb1ed41
Author: Ronald S. Bultje <rsbultje@gmail.com>
Date:   Thu Dec 6 15:40:13 2012 -0800

    x86inc: support stack mem allocation and re-alignment in PROLOGUE
    Use this in 8-bit loopfilter functions so they can be used if
    there is no aligned stack (e.g. x86-32 MSVC or ICC 10.x).

commit 9d5ec55b34a4d4f2e044fbc67e2e12a59ea27d2a
Author: Henrik Gramner <hengar-6@student.ltu.se>
Date:   Mon Dec 17 22:15:02 2012 +0100

    Update config.guess and config.sub

commit 8eddd52b6d5d638709c5c8278c420eac68a8dde1
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Jan 8 13:29:49 2013 -0800

    Fix crash if the first frame is forced to a non-keyframe
    This is obviously bad user input, but x264 shouldn't crash if it happens.

commit 05c1646333f567aa3de5f7669693b15ee667825d
Author: Bernhard Rosenkränzer <bernhard.rosenkranzer@linaro.org>
Date:   Sun Dec 30 12:18:00 2012 -0800

    Fix build on ARM with binutils >= 2.23.51.0.6
    GAS doesn't seem to like spaces in vld1 anymore, so remove those.

commit 23829dd2b2c909855481f46cc884b3c25d92c2d7
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Nov 23 18:26:53 2012 +0400

    Fix pthread_join emulation on win32 and BeOS
    Doesn't actually affect x264, but it's more correct.

commit 042fdd3e6a0e271f62a108da2a1a244dee936045
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Nov 27 07:50:51 2012 -0800

    Fix typo in r2222
    Slightly wrong numbers in level table.

commit cd71765c0ba574bb573e75396ef3c6a5c4c00469
Author: Sergio Basto <sergio@serjux.com>
Date:   Thu Nov 22 18:02:50 2012 -0800

    configure: fix gpac detection with -Wp,-D_FORTIFY_SOURCE=2

commit 12458a23d1374836fecbed381dfe55513b5ba119
Author: Sean McGovern <gseanmcg@gmail.com>
Date:   Thu Nov 22 18:01:16 2012 -0800

    Solaris: use sysconf to get processor count
    Solaris responds correctly to the same value as Cygwin, so let's use that.

commit 0db80bee2765676c2e0e4be21afc2ace900a606c
Author: Anton Khirnov <anton@khirnov.net>
Date:   Tue Nov 13 21:01:24 2012 +0100

    lavf input: allocate AVFrame correctly
    Allocate AVFrames correctly with avcodec_alloc_frame().
    This caused crashes with newer libavcodecs that try to free frame extradata.

commit 144b79159ad20954a7faec1023451a630a65aea1
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Nov 11 03:44:02 2012 +0400

    Fix crash when using libx264.dll compiled with ICL for X86_64

commit bfed708c5358a2b4ef65923fb0683cefa9184e6f
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Nov 9 02:31:10 2012 +0400

    Fix possible issues with out-of-spec QP values
    Fixes a possible regression in r2228.

commit 1580a74e339c59cd856100076d8cf46f2d7247b0
Author: Fiona Glaser <fiona@x264.com>
Date:   Wed Sep 26 13:49:02 2012 -0700

    Attempt to optimize PPS pic_init_qp in 2-pass mode
    Small compression improvement; up to ~0.5% in extreme cases.
    Helps more with small slice sizes (tiny resolutions or slice-max-size).
    Note that this changes the 2-pass stats file format.

commit b304a7cad10a85d487fa09e7c33e81c6945186b2
Author: Fiona Glaser <fiona@x264.com>
Date:   Wed Sep 26 13:05:00 2012 -0700

    Improve slice header QP selection
    Use the first macroblock of each slice instead of the last of the previous.
    Lets us pick a reasonable initial QP for the first slice too.
    Slightly improved compression.

commit 0d5f6fbae9f6c4dbba25571a5d8c643b192606b1
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Oct 11 13:27:48 2012 -0700

    Update level dpb size calculation to match newer H.264 spec
    Doesn't actually change encoding behavior, but makes it more correct.
    Warning messages should now be accurate at higher bit depths and non-4:2:0.
    Technically, since it redefines x264_level_t, this is an API version increment.

commit cc61a4b4d0838b6d5f4cdaf88a0b6d06a12b6d3e
Author: Jan Ekström <jeebjp@gmail.com>
Date:   Sun Oct 7 21:12:05 2012 +0300

    Add support for the ffmpeg/vapoursynth high bit depth y4m extensions

commit 5d85879921481ef104766657deda4ef8ea4351ec
Author: Diego Biurrun <diego@biurrun.de>
Date:   Tue Nov 6 14:48:56 2012 +0100

    x86inc: Rename 3dnow2 to 3dnowext
    The name "3dnowext" is more common than "3dnow2". Doesn't affect x264.

commit 00cc16001b35a71ce2329e02bff6e316201cf700
Author: Diego Biurrun <diego@biurrun.de>
Date:   Wed Oct 31 12:23:54 2012 -0700

    x86inc: only define program_name if the macro is unset.
    This allows overriding the value from outside the file.
    This can be useful if x86inc.asm is used outside of x264.

commit 3f516c5238d0c536ea03c8e5334d231facf9f31b
Author: David Wolstencroft <d.wolstencroft@yahoo.com>
Date:   Mon Oct 29 09:07:39 2012 -0700

    Disable ARM NEON MRC CPU test for Apple devices
    The Apple A6 CPU doesn't support performance counters, so this test caused a crash.

commit ac2d7c08452186703424dcc6933524e95b652479
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Nov 6 12:03:20 2012 -0800

    Fix crash with no-scenecut + mbtree

commit 480bbc9067da7cce3400cf3988bf5fdfa4d9fa3f
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Oct 12 23:43:40 2012 +0400

    Fix reconfiguring to crf=0
    Lossless mode can't currently be enabled mid-stream.

commit 21ba91ae6c361e4ce49ee65e61cc582b1af648ba
Author: Derek Buitenhuis <derek.buitenhuis@gmail.com>
Date:   Mon Sep 17 11:09:20 2012 -0700

    Fix ALIGNED_ARRAY_EMU macros on ICL
    ICL's preprocessor doesn't handle it correctly.
    This fix is similar to libav's fix in 0db2d9.

commit 96577475981d979d151626aae61ef317dc54df67
Author: Jason Martens <cacepi@gmail.com>
Date:   Thu Sep 13 11:20:40 2012 -0700

    Fix use of deprecated av_close_input_file call

commit 02217bd2c31feda7aaca813f104c155fe09428b8
Author: Brad Smith <brad@comstyle.com>
Date:   Wed Sep 26 14:13:27 2012 -0700

    Fix pkg-config for dynamic vs static linking

commit e8e8b9a44ffa9b5f585582375515140ea22985d3
Author: Brad Smith <brad@comstyle.com>
Date:   Mon Sep 10 17:52:04 2012 -0700

    Set libm in the configure script if the OS has libm
    Prerequisite for another configure patch after this.
    Idea copied from libpthread.

commit 8980dd8afbfeeb6bcaa17b97aad0b3c24207665e
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Aug 16 13:40:32 2012 -0700

    Enhance mb_info: add mb_info_update
    This feature lets the callee know which decoded macroblocks have changed.

commit 033df0a8c719f991ab0e0bb0788bd4f08e8b91d7
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Aug 16 13:01:17 2012 -0700

    Fix mb_info_free with sliced threads
    x264 would free mb_info before it was completely done using it.

commit f93b7865a96248621af078363d5b59691cbcd8aa
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Aug 7 12:43:26 2012 -0700

    Enhance nalu_process
    Add the input frame opaque pointer to the arguments.
    This makes it easier to use with multiple simultaneous x264 encodes.

commit 05089a37bf55a4134d9ffd014fdae729804a4e7a
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon Aug 6 14:55:35 2012 -0700

    Improve mb_info constant mb optimization
    Allow fast skipping even if the pskip MV isn't zero.

commit cc5dcedc3b45d8e7390e2e914bb37f3fa92f6acd
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon Jul 30 12:58:34 2012 -0700

    Export the average effective CRF of each frame
    Useful to judge the resulting quality of a frame when VBV is enabled.

commit f8fd6412a94f5f4f0eb5f8a6c0fb2062daebfab8
Author: Brad Smith <brad@comstyle.com>
Date:   Mon Aug 20 23:58:19 2012 -0700

    Remove special-casing for OpenBSD pthread handling
    Previously it was policy to use -pthread, but OpenBSD now recommends -lpthread.
    its been libpthread anyway and policy has changed to stop using -pthread.

commit ed56837e3c56bfb880fac2e4e0025d81d6a7186b
Author: Ronald S. Bultje <rsbultje@gmail.com>
Date:   Thu Jul 26 18:01:49 2012 -0700

    x86inc: automatically insert vzeroupper for YMM functions
    Backported from libav.

commit cbb90707e443f0da2521bda1b98cab5705451b8f
Author: Kieran Kunhya <kieran@kunhya.com>
Date:   Tue Jul 24 08:47:45 2012 -0700

    Free user supplied data when deleting a frame
    This eliminates a memory leak when calling x264_encoder_close.

commit 3d03b6190c7af7b941fa746c3dff3b17e5115380
Author: Fiona Glaser <fiona@x264.com>
Date:   Wed Jul 18 08:33:41 2012 -0700

    Revert r2204
    People don't seem to like this so I'm just going to get rid of it.

commit 2ec694181f8ba3eb1c4153e6b955d399d6448c25
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Jul 10 14:10:44 2012 -0700

    Faster predictor checking with subme<3
    Fix a typo that made an early-skip less effective.
    Avoid a relatively unpredictable branch.
    Slightly changed output due to the typo-fix.
    ~50 cycles faster on Core i7.

commit d026397b0bf4c87e96b19c9fff7f43be6c4d9def
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon Jun 25 18:01:29 2012 -0700

    Try 8x8 transform analysis even when sub8x8 partitions are present
    Turn off the sub8x8 partitions, try it, and turn them back on if it didn't help.
    Small compression improvement with p4x4 on (~0.1-0.5%).
    Also update related comments.

commit dea5d7a54b5ba948ed71d74e0264a2191bcd9815
Author: Fiona Glaser <fiona@x264.com>
Date:   Fri Jun 8 18:19:59 2012 -0700

    Support changing resolutions between passes with macroblock-tree
    Implement a basic separable bilinear filter to rescale the quantizer offsets.
    Structure inspired by swscale, but floating-point instead of fixed-point.
    Not as optimized as it could be, but it's quite fast already.
    
    Example compression penalties on a 720p video game recording:
    First pass with 720p and second as 480p: ~-1.5% (vs. same res)
    First pass with 480p and second as 720p: ~-3% (vs. same res)

commit 498af9c559b8da986544e93f898df02fc9e224b3
Author: Alexander Prikhodko <komisar666@gmail.com>
Date:   Tue Jun 12 20:21:35 2012 +0300

    Print elapsed time in encoding progress indicator

commit bcd1a7070dc5224d591731dfdbabcbbaee0bb984
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat Jun 2 21:27:50 2012 +0400

    Cap ratecontrol predictor parameters
    Limits VBV mispredictions after long periods of relatively constant video.

commit 5754ea2db5223b458bd48f0130c13000e3dec15c
Author: Loren Merritt <pengvado@akuvian.org>
Date:   Tue Jul 3 14:38:04 2012 -0700

    x86inc: import patches from libav
    Allow manual invocation of WIN64_SPILL_XMM even under INIT_MMX
    SSE version of mova is movaps rather than movdqa.
    YMM version of movnta.
    Add mp size for named arguments.
    Fix DEFINE_ARGS when used outside of a cglobal.
    Define a few more cpuflags.
    3-argument wrappers for a few more instructions.

commit 5e3aaf1a49b173df916a384942c8089dd5bd8a22
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Jun 22 22:02:24 2012 +0400

    Fix crash with --fps 0
    Fix some integer overflows and check input parameters better.
    Also fix incorrect type specifiers for demuxer info printing.

commit df700eae5d5ce5732f80df9ce81e6d3fe99ef56a
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue May 8 15:42:56 2012 -0700

    Threaded lookahead
    
    Split each lookahead frame analysis call into multiple threads.  Has a small
    impact on quality, but does not seem to be consistently any worse.
    
    This helps alleviate bottlenecks with many cores and frame threads. In many
    case, this massively increases performance on many-core systems.  For example,
    over 100% faster 1080p encoding with --preset veryfast on a 12-core i7 system.
    Realtime 1080p30 at --preset slow should now be feasible on real systems.
    
    For sliced-threads, this patch should be faster regardless of settings (~10%).
    
    By default, lookahead threads are 1/6 of regular threads.  This isn't exacting,
    but it seems to work well for all presets on real systems.  With sliced-threads,
    it's the same as the number of encoding threads.

commit 7cfe43cc7fb5474a87f02da96ebb850cdf83d73b
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri May 4 17:18:12 2012 +0400

    Add support for RGB formats in bit-depth conversion filter

commit 44d2f0885cd95201b67ed54bab88e91f4ba1556e
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat May 12 13:57:49 2012 +0400

    Fix some bugs in mb_info code

commit 8e57a9a0b5bddfecea5e45345c8c50efb0bac10d
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Mar 29 14:14:07 2012 -0700

    Add mb_info API for signalling constant macroblocks
    Some use-cases of x264 involve encoding video with large constant areas of the frame.
    Sometimes, the caller knows which areas these are, and can tell x264.
    This API lets the caller do this and adds internal tracking of modifications to macroblocks to avoid problems.
    This is really only suitable without B-frames.
    An example use-case would be using x264 for VNC.

commit 4442eaceb4992098e1e4e30aa13e70bb35d2cae6
Author: Henrik Gramner <hengar-6@student.ltu.se>
Date:   Sat Apr 7 00:40:09 2012 +0200

    Faster chroma weight cost calculation
    
    New assembly function with SSE2, SSSE3 and XOP implementations for calculating absolute sum of differences.

commit e8952dffa3b09700e5b7c5e56edd196f0b80a248
Author: Lucien <astrataro@gmail.com>
Date:   Sat Mar 31 13:42:49 2012 +0100

    Add Level 5.2 support

commit 66acbbf6ce6b143cd164d251ceb160870e4ee720
Author: Henrik Gramner <hengar-6@student.ltu.se>
Date:   Thu Apr 12 19:14:43 2012 +0200

    Eradicate all mention of Extended Profile
    x264 never supported it and never will because nobody uses it.

commit b0f44f9e106afadaded17009079c2281cb18eb56
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Apr 3 21:46:52 2012 +0400

    Fix disabling of mbtree when using 2pass encoding and zones

commit ffea9f51f7f7e0a550c9326631a9c6f8c5c885be
Author: Alexander Prikhodko <komisar666@gmail.com>
Date:   Sat Mar 31 12:06:21 2012 +0300

    configure: force select -mXX gcc option for i386/x86-64
    Makes multilib compilation more convenient.

commit f4aefb3853819adf633c56062d1be77db90819b6
Author: Rafaël Carré <funman@videolan.org>
Date:   Sun Apr 15 21:20:14 2012 -0400

    Update config.guess and config.sub
    Adds support for a bunch of targets, including:
    aarch64 (armv8)
    arm-linux-androideabi

commit 62d7007d35c5f0829d96b6ecf459f21d27210ef3
Author: Alexander Prikhodko <komisar666@gmail.com>
Date:   Sat Mar 31 11:33:41 2012 +0300

    configure: correct use of RC variable and add --extra-rcflags

commit 70877e39a4abb4c24d1978a28202c9bf0dce8b47
Author: Steven Walters <kemuri9@gmail.com>
Date:   Wed Mar 28 21:15:04 2012 -0400

    ICL/MSVS: Fix shared library generation and usage
    MSVS requires exported variables to be declared with the DATA keyword, and requires that imported variables be declared with dllimport.
    This does not fix x264 cli being unable to use a shared library built by ICL however.

commit 52f7a149ef6c39eb0d7eec7884362ba31a4b05ba
Author: Kieran Kunhya <kierank@ob-encoder.com>
Date:   Tue Mar 27 17:38:56 2012 +0100

    Fix intra-refresh + hrd

commit fff12b1b7d8ce5cc9cfcfac09f089bae06cac6d5
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Mar 25 17:34:24 2012 +0400

    Fix frame input colorspace check

commit 065fec2704f3c8c6f3f3f5b0fad6870a078ba48c
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Mar 22 13:56:50 2012 -0700

    Fix comment in deblock.c
    The code does, in fact, handle CAVLC+8x8dct correctly already.

commit bca412764eb198433ca45abd097368e5154c7fbb
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Mar 13 14:37:26 2012 -0700

    Fix sliced-threads ratecontrol bug
    Was using qp instead of qscale; could cause NANs (not to mention less accurate results).

commit e046ba72a4230fdd6c7907ebf7ae235edb98faf2
Author: Anton Mitrofanov <Bugmaster@narod.ru>
Date:   Sun Mar 11 23:08:18 2012 -0700

    Fix clobbering of mutex/cvs
    Regression in r2183.
    Bizarrely seemed to work on many platforms, but crashed on win64 and may have been slower.
    Only affected sliced threads during encoding, but could cause crashes on x264 encoder close even without sliced threads.

commit a155572ed547a3627ef00ca70ab804ff452147cd
Author: Fiona Glaser <fiona@x264.com>
Date:   Fri Feb 24 13:34:39 2012 -0800

    Sliced-threads: do hpel and deblock after returning
    Lowers encoding latency around 14% in sliced threads mode with preset superfast.
    Additionally, even if there is no waiting time between frames, this improves parallelism, because hpel+deblock are done during the (singlethreaded) lookahead.
    For ease of debugging, dump-yuv forces all of the threads to wait and finish instead of setting b_full_recon.

commit 90408ecab16a06ceaa181ff2e495b8f1a9d170fa
Author: Fiona Glaser <fiona@x264.com>
Date:   Fri Feb 24 13:16:52 2012 -0800

    Add full-recon API option
    Fully reconstruct frames even without dump-yuv.

commit 5b2c62aec269be7d0b1ff62df09660369f4e20e0
Author: Fiona Glaser <fiona@x264.com>
Date:   Wed Feb 22 13:33:36 2012 -0800

    x86inc: switch to amdnops
    Recent AMD CPUs' instruction decoders choke horribly on extremely long nops (i.e. with 4 prefixes).
    Won't affect much, since we don't use ALIGN much.

commit 42db5e6f8f704a2b0a9edf5d9cd4a17d80e5b816
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Feb 14 16:54:03 2012 -0800

    BMI1 decimate functions
    Intel was nice enough to make tzcnt equal to "rep bsf", which is backwards-compatible.
    This means we don't actually have to add new functions to make it work.

commit 92b0bd9665860d7b48f313d6fd72a583ecb01ddf
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Feb 14 15:07:10 2012 -0800

    Minor asm changes

commit 2535ba17b2598f4155955857c12d52a377a75517
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Feb 9 14:23:52 2012 -0800

    Add row-reencoding support to VBV for improved accuracy
    Extremely accurate, possibly 100% so (I can't get it to fail even with difficult VBVs).
    Does not yet support rows split on slice boundaries (occurs often with slice-max-size/mbs).
    Still inaccurate with sliced threads, but better than before.

commit bc473ddfd2f5925715d2895da666e214ebf04c84
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Feb 9 12:38:44 2012 -0800

    Abstract bitstream backup/restore functions
    Required for row re-encoding.

commit 48e8e52e740fdc7ddca792d4afe240a213f66df5
Author: Anton Mitrofanov <Bugmaster@narod.ru>
Date:   Thu Feb 9 15:27:53 2012 -0800

    Add an small per-MB cost penalty for lowres
    Helps avoid VBV predictors going nuts with very low-cost MBs.
    One particular case this fixes is zero-cost MBs: adaptive quantization decreases the QP a lot, but (before this patch), no cost penalty gets factored in for this, because anything times zero is zero.

commit 1b31a10c7c3210d5eb14d522aaa0cfbe0e7a25e8
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon Feb 13 18:31:51 2012 -0800

    Remove explicit run calculation from coeff_level_run
    Not necessary with the CAVLC lookup table for zero run codes.

commit 9da19fbee621ca5b052891b3c010f8bc89b2ba93
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon Feb 13 13:20:06 2012 -0800

    Export PSNR/SSIM in x264 API

commit 3a5f2fe30aeb5314b74f83b1960e9a40776347e9
Author: Ronald S. Bultje <rsbultje@gmail.com>
Date:   Wed Feb 8 13:10:31 2012 -0800

    x86inc: support yasm -f win64
    Not necessary for x264, as -m amd64 already does the right thing, but used by external users of x86inc.

commit 3131a19cabcdca221ce4cd61a3cff68d99f1a517
Author: Henrik Gramner <hengar-6@student.ltu.se>
Date:   Wed Feb 1 23:52:48 2012 +0100

    Fix incorrect zero-extension assumptions in x86_64 asm
    Some x264 asm assumed that the high 32 bits of registers containing "int" values would be zero.
    This is almost always the case, and it seems to work with gcc, but it is *not* guaranteed by the ABI.
    As a result, it breaks with some other compilers, like Clang, that take advantage of this in optimizations.
    Accordingly, fix all x86 code by using intptr_t instead of int or using movsxd where neccessary.
    Also add checkasm hack to detect when assembly functions incorrectly assumes that 32-bit integers are zero-extended to 64-bit.

commit d52d0b1e6a9323911818c2a89764f6827974e0f7
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Feb 23 09:11:23 2012 -0800

    Fix possible alignment crash when linking from MSVC
    x264_cavlc_init needs to be stack-aligned now.

commit 0a369502ab83c32ccebdb1888e6981ef872baaf0
Author: Anton Mitrofanov <Bugmaster@narod.ru>
Date:   Tue Feb 21 12:58:22 2012 -0800

    Fix rare overflow in 10-bit intra_satd_x3_16x16 asm

commit 38a26cdfc54ffd60c90651f3b96490d772e6dd73
Author: Steven Walters <kemuri9@gmail.com>
Date:   Sat Feb 11 22:56:43 2012 -0500

    ICL: fix out of tree building and resource file usage on Windows

commit 10e1ba55803970ecd240f2057e7dfe0c22fc8efb
Author: Oka Motofumi <chikuzen.mo@gmail.com>
Date:   Mon Feb 6 06:07:34 2012 +0900

    Add error handling for out-of-tree build

commit 0fc5acc6e6c038f6380f614e4dc4e1893b716b7e
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Tue Mar 6 17:34:02 2012 +0400

    Fix RGB colorspace input
    BGR/BGRA input was correct.

commit 282c3cfb22f4ab526d96678249ccdc7f16531811
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon Feb 13 16:40:32 2012 -0800

    Fix interlaced + extremal slice-max-size
    Broke if the first macroblock in the slice exceeded the set slice-max-size.

commit a37a42450cdc31393dae56aed5a726a42fd540d6
Author: Henrik Gramner <hengar-6@student.ltu.se>
Date:   Sun Feb 5 20:43:09 2012 +0100

    Fix regression in r2141
    Broke register preservation in x264_cpu_cpuid and x264_cpu_xgetbv.
    Did not cause any problems.

commit ae289e6f03b76afa8736806e683349e8e59fcc93
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Jan 19 14:56:54 2012 -0800

    TBM, AVX2, FMA3, BMI1, and BMI2 CPU detection support
    TBM and BMI1 are supported by Trinity/Piledriver.
    The others (and BMI1) will probably appear in Intel's upcoming Haswell.
    Also update x86inc with AVX2 stuff.

commit e0581e0878c1995b215c51691af6bdf7a386946f
Author: Loren Merritt <pengvado@akuvian.org>
Date:   Fri Feb 3 06:27:18 2012 +0000

    x86inc: add TAIL_CALL macro to abstract a common asm idiom

commit 04c38190c60658d544801718fc38fa3f745381d9
Author: Fiona Glaser <fiona@x264.com>
Date:   Wed Jan 25 16:44:38 2012 -0800

    Minor asm optimizations/cleanup

commit 6d7c5efcf6f8751f768177bf828973a7bd4fdcf6
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Jan 24 19:03:58 2012 -0800

    Clean up and optimize weightp, plus enable SSSE3 weight on SB/BDZ
    Also remove unused AVX cruft.

commit 047175e610d3d5360f69e4f8168ff6fbafda2465
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon Jan 23 18:57:58 2012 -0800

    XOP frame_init_lowres
    Covers both 8-bit and 16-bit, ~5-10% faster on Bulldozer.

commit abc88d60b5e0d803d6d4f0a5d9ece7dd0bdde0f1
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Jan 17 15:25:10 2012 -0800

    XOP 8x8 zigzags
    Field: 35(mmx) ->16(xop) cycles
    Frame: 32(ssse3)->20(xop) cycles

commit aa47955a0ec65218e8bb967d36689069baca5fd1
Author: Fiona Glaser <fiona@x264.com>
Date:   Mon Jan 23 15:09:38 2012 -0800

    AVX 32-bit hpel_filter_h
    Faster on Sandy Bridge.
    Also add details on unsuccessful optimizations in these functions.

commit d7407cf81816fff7ab32ceb2398575724e8cc737
Author: Fiona Glaser <fiona@x264.com>
Date:   Fri Jan 27 16:29:30 2012 -0800

    x86inc: add high halfword register support
    Might be useful in a few cases.

commit acabceb6530d1858bcd009b055e217c75344c442
Author: Ronald S. Bultje <rsbultje@gmail.com>
Date:   Wed Jan 25 13:53:59 2012 +0800

    Change %ifdef directives to %if directives in *.asm files
    This allows combining multiple conditionals in a single statement.

commit 82d8cdde567b1c1e8d2046bbb831d0daafe8213b
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Jan 22 22:13:52 2012 +0400

    Use TV range algorithm for bit-depth conversions
    Such sources are more common, so better to be correct for the common case.
    This also produces less error for the case of full range than the previous algorithm produced for the case of TV range.

commit 27a7b05b8330d0756e5e3f6669282561030f54fa
Author: Hii <hiiragikei@gmail.com>
Date:   Wed Jan 25 16:29:22 2012 +0800

    Bump dates to 2012

commit 762f677e095a40e1927086bb08799c01e05c2ee4
Author: Henrik Gramner <hengar-6@student.ltu.se>
Date:   Sat Jan 28 21:38:27 2012 +0100

    Add Windows resource file
    Displays version info in Windows Explorer.

commit 545b41caa5903ebcb5d9336a59f9bf5a50a45037
Author: Sergey Radionov <RSATom@gmail.com>
Date:   Mon Jan 16 13:22:44 2012 -0800

    Fix win32 pthread_cond_signal
    Isn't used by x264 currently, so didn't cause a problem.
    Fix backported from libav.

commit 697a11e8ecb1376cddd4a8d4f4fa693e41c1987e
Author: Mans Rullgard <mans@mansr.com>
Date:   Wed Feb 1 15:55:25 2012 -0800

    ARM: align asm functions to 4 bytes.
    Some linkers apparently fail to correctly align ARM functions when mixing with Thumb code.

commit f59b310fd87b643b59d6e109e49fdf9d0a04ce91
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sun Jan 22 13:00:23 2012 +0400

    Fix normalization of colorspace when input is packed YUV 4:2:2

commit 9fb055856a617f5ddca15a0c5745ff1c1486ad9a
Author: Fiona Glaser <fiona@x264.com>
Date:   Sat Jan 21 12:54:40 2012 -0800

    Force keyint-min 1 with Blu-ray
    Fixes an issue with referencing across I-frames that's prohibited in Blu-ray for some godforsaken reason.

commit 77cfcb6acf648da00eb4ddb52bcb7006bc64a61a
Author: Oka Motofumi <chikuzen.mo@gmail.com>
Date:   Sun Jan 29 20:34:41 2012 +0900

    Fix crash in --demuxer y4m with unsupported colorspace

commit 30829c0c7e6bbf40d1b3ed5fcb5a45d85407978f
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Mon Jan 16 14:02:53 2012 -0800

    Fix overread/possible crash with intra refresh + VBV

commit 26c8303472b837e301d789ba569eae01955cf7f6
Author: Loren Merritt <pengvado@akuvian.org>
Date:   Wed Jan 18 15:47:07 2012 -0800

    Fix trellis 2 + subme >= 8
    Trellis didn't return a boolean value as it was supposed to.
    Regression in r2143-5.

commit 7d804baf3bca6ad33e18ccd0a838274214a8a7a0
Author: Loren Merritt <pengvado@akuvian.org>
Date:   Fri Jan 6 15:53:29 2012 +0000

    CABAC trellis opts part 4: x86_64 asm
    Another 20% faster.
    18k->12k codesize.
    
    This patch series may have a large impact on encoding speed.
    For example, 24% faster at --preset slower --crf 23 with 720p parkjoy.
    Overall speed increase is proportional to the cost of trellis (which is proportional to bitrate, and much more with --trellis 2).

commit dd354db4db2f26e63ed36eb790052c6794e5a684
Author: Loren Merritt <pengvado@akuvian.org>
Date:   Fri Jan 6 15:53:04 2012 +0000

    CABAC trellis opts part 3: make some arrays non-static

commit 4abcf60a04e358b87da284f3a5fac3e2949b6de1
Author: Loren Merritt <pengvado@akuvian.org>
Date:   Thu Dec 22 17:56:06 2011 +0000

    CABAC trellis opts part 2: C optimizations
    
    Hoist the branch on coef value out of the loop over node contexts.
    Special cases for each possible coef value (0,1,n).
    Special case for dc-only blocks.
    Template the main loop for two common subsets of nodes, to avoid a bunch of branches about which nodes are live.
    Use the nonupdating version of cabac_size_decision in more cases, and omit those bins from the node struct.
    CABAC offsets are now compile-time constants.
    Change TRELLIS_SCORE_MAX from a specific constant to anything negative, which is cheaper to test.
    Remove dct_weight2_zigzag[], since trellis has to lookup zigzag[] anyway.
    
    60% faster on x86_64.
    25k->18k codesize.

commit 253cd7baefb7f5d101725034b2c37afacc012305
Author: Loren Merritt <pengvado@akuvian.org>
Date:   Thu Dec 22 17:55:06 2011 +0000

    CABAC trellis opts part 1: minor change in output
    Due to different tie-break order.

commit 0d7a9100d12c618acea3f01b8bb9cc306f475b47
Author: Henrik Gramner <hengar-6@student.ltu.se>
Date:   Sun Jan 8 04:14:10 2012 +0100

    x86inc improvements for 64-bit
    
    Add support for all x86-64 registers
    Prefer caller-saved register over callee-saved on WIN64
    Support up to 15 function arguments

commit 8a6a062e11d4074c081d076408cb0bd6def1af8e
Author: Ilia Valiakhmetov <zakne0ne@gmail.com>
Date:   Sun Jan 15 04:47:58 2012 -0600

    High bit depth SSE2/AVX add8x8_idct8 and add16x16_idct8
    From Google Code-In.

commit a35fd4194dd7004abe6f66679496beded405515a
Author: Edward Wang <edward.c.wang@compdigitec.com>
Date:   Wed Jan 4 15:35:54 2012 -0800

    MMX/SSE2/AVX predict_8x16_p, high bit depth fdct8
    From Google Code-In.

commit 9301bbd39fb0a49b1e986f9a7c29685439686de4
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Dec 22 14:03:15 2011 -0800

    XOP 8-bit fDCT
    Use integer MAC for one of the SUMSUB passes.  About a dozen cycles faster for 16x16.

commit c83edc0427e78c58683af99b80e0234c77b3e41a
Author: Cristian Militaru <cristipiticul@yahoo.com>
Date:   Wed Jan 4 12:38:08 2012 -0800

    High bit depth intra_sad_x3_4x4
    From Google Code-In.

commit 9c0fa2d63f549a44f869562cffa9c041a32ae41d
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Dec 8 13:45:41 2011 -0800

    Use a large LUT for CAVLC zero-run bit codes
    Helps the most with trellis and RD, but also helps with bitstream writing.
    Seems at worst neutral even in the extreme case of a CPU with small L2 cache (e.g. ARM Cortex A8).

commit de7aed78cd2f70017f3c479d8f8dc32d52cee607
Author: Matt Habel <habelinc@gmail.com>
Date:   Fri Dec 16 23:16:09 2011 -0800

    High bit depth intra_sad_x3_8x8, intra_satd_x3_4x4/8x8c/16x16
    Also add an ACCUM macro to handle accumulator-induced add-or-swap more concisely.

commit d9dee734a9af1788461def43321f19be6a3d2d72
Author: Shitiz Garg <mail@dragooon.net>
Date:   Sat Dec 3 15:34:57 2011 -0800

    MMX 10-bit predict_8x8c_h and predict_8x16c_h
    From Google Code-In.

commit 7496fc4aeaaaf5b470b1eb0f73ce8ea71d0116f2
Author: Aaron Schmitz <me@aaronschmitz.com>
Date:   Wed Nov 30 00:15:45 2011 -0600

    Some MBAFF x86 assembly functions.
    deblock_chroma_420_mbaff, plus 422/422_intra_mbaff implemented using existing functions.
    From Google Code-In.

commit b8d7b8acb48b45afbfd7efb5baac79475682684a
Author: George Stephanos <gaf.stephanos@gmail.com>
Date:   Thu Dec 1 16:53:45 2011 -0800

    More ARM NEON assembly functions
    predict_8x8_v, predict_4x4_dc_top, predict_8x8_ddl, predict_8x8_ddr, predict_8x8_vl, predict_8x8_vr, predict_8x8_hd, predict_8x8_hu.
    From Google Code-In.

commit e269ca55e5244280afd0347c1088083cf7043d48
Author: Ilia <zakne0ne@gmail.com>
Date:   Mon Nov 28 05:20:09 2011 -0800

    More 4:2:2 asm functions
    High bit depth version of deblock_h_chroma_422.
    Regular and high bit depth versions of deblock_h_chroma_intra_422.
    High bit depth pixel_vsad.
    SSE2 high bit depth and MMX 8-bit predict_8x8_vl.
    Our first GCI patch this year!

commit 5d66c5011488539f99ceafdb47b0856a8e9dae0b
Author: Henrik Gramner <hengar-6@student.ltu.se>
Date:   Thu Dec 8 16:14:35 2011 +0100

    SSE2 and SSSE3 versions of sub8x16_dct_dc
    Also slightly faster sub8x8_dct_dc

commit 3ea6a8b22e0aa89e3749e9c95edfeaad9d341b7e
Author: Steven Walters <kemuri9@gmail.com>
Date:   Mon Dec 5 08:46:34 2011 -0500

    Resize filter updates
    Use AVPixFmtDescriptors to pick the most compatible x264 csp for any pixel format.
    Fix deprecated use of av_set_int.
    Now requires libavutil >= 51.19.0

commit f71d047d0bc129eb9f4724e023bf888a9124338b
Author: Oka Motofumi <chikuzen.mo@gmail.com>
Date:   Thu Jan 5 14:23:50 2012 -0800

    Add out-of-tree build support

commit 5539220e5afc641a6747c6d95f41e5efbe5858e1
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Dec 16 18:17:00 2011 +0400

    Limit SSIM to 100db
    Avoids floating point error for infinite SSIM (lossless).

commit 13c236172f0ff40ca149a2e862498457cd32ccb9
Author: Reynaldo H. Verdejo Pinochet <reynaldo@collabora.com>
Date:   Wed Jan 4 13:16:12 2012 -0300

    Fix wrong conditional inclusion of inttypes.h
    inttypes.h is required by encoder/ratecontrol.c for SCNxxx macros, and HAVE_STDINT_H does not imply having inttypes.h.
    stdint.h is a subset of inttypes.h, but this isn't enough for x264.
    This change fixes building x264 with Android's toolchain.

commit 2df9d45db64110854e6da6a2037d6c432c5463fe
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed Dec 21 11:08:56 2011 +0400

    Fix crash with sliced threads and input height <= 112

commit e3d311813f3931133962f7ab8ee2305d231df83d
Author: Phillip Blucas <pblucas@gmail.com>
Date:   Mon Dec 19 17:43:41 2011 -0600

    Fix loading custom 8x8 chroma quant matrices in 4:4:4

commit 9fd7ccb2b635276d019e137844c693b525f92244
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Dec 16 01:48:07 2011 +0400

    Fix PCM cost overflow

commit 1d70d0e56003b762439ad4b5d8e72729b51516ae
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Dec 9 01:54:22 2011 +0400

    Fix overflow in 8-bit x86 vsad asm function

commit b6ce6c64c17071804676435da9b1c07b902857e3
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Wed Dec 7 19:14:52 2011 +0400

    Fix crash in --fullhelp when compiled against recent ffmpeg
    Don't assume all pixel formats have a description.

commit c3ba63bbe83bd20d06a64cfecd6b878e8f49bc13
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Dec 6 14:39:21 2011 -0800

    Fix regression in r2118
    Broke trellis with i16x16 macroblocks.

commit 9dc2391576b35acb55c04773049a0b817f306969
Author: Fiona Glaser <fiona@x264.com>
Date:   Wed Nov 30 13:02:12 2011 -0800

    Modify MBAFF chroma deblock functions to handle U/V at the same time
    Allows for more convenient asm implementations.

commit d0bf649fcc1a79da12e220c4364aeca6045dfbed
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Nov 10 16:16:13 2011 -0800

    CABAC trellis optimizations: use SIMD quant
    Significant speed increase, minor change in output due to rounding.

commit 6767f967831048669e45e65681f37011483b4fa0
Author: Steven Walters <kemuri9@gmail.com>
Date:   Sun Nov 6 09:48:30 2011 -0800

    YUV range detection and support for x264CLI
    Two new options: --input-range and --range.
    --input-range forces the range of the input in case of misdetection; auto by default.
    -- range sets the range of the output; x264cli will convert if necessary, TV by default.
    --fullrange is now removed as a CLI option (but the libx264 API is unchanged).

commit f9a4c4d9828c1cc60135d0301981ea71fd90f6ca
Author: Kieran Kunhya <kieran@kunhya.com>
Date:   Fri Nov 4 20:09:13 2011 +0000

    Pass through user data

commit 1c774e936a315fdfb92a35c402b351a1c542a13a
Author: Fiona Glaser <fiona@x264.com>
Date:   Thu Oct 27 14:05:56 2011 -0700

    Remove unpredictable branch in CABAC dqp

commit f3a7517cb9b06a580623cbea0f140be534b99877
Author: Loren Merritt <pengvado@akuvian.org>
Date:   Sun Oct 23 23:15:11 2011 +0000

    x86inc: AVX symmetry optimization
    3-arg AVX ops with a memory arg can only have it in src2,
    whereas SSE emulation of 3-arg prefers to have it in src1 (i.e. the move).
    So, if the op is symmetric and the wrong one is memory, swap them.
    Eliminates redundant moves in some cases when using 3-operand without AVX with memory arguments.
    Also fix movss and movsd in some cases, and flag shufps correctly as float.

commit 5ebbcd8748ae8d8b184db5a8f9b46a9ad865f0ae
Author: Anton Mitrofanov <Bugmaster@narod.ru>
Date:   Tue Nov 29 13:45:13 2011 -0800

    checkasm: shut up gcc warnings, fix some naming of functions in results

commit 561f71ebf741370075b970fb9d31a593cf47782f
Author: Mans Rullgard <mans@mansr.com>
Date:   Mon Nov 28 16:29:12 2011 -0800

    checkasm: fix build on ARM
    Because of how ALIGNED_ARRAY_16 is defined on ARM, array initialisers cannot be used here.  Use memset() instead.

commit 24bf90abde21e77c574f2bd43e38a3222c3183ef
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat Nov 12 01:31:49 2011 +0400

    Improve makefile rules
    Remove the need for "make clean" after most reconfigures.

commit 87b23e25eee0c04bb47957445e7cf941a7d8b980
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat Nov 12 00:47:48 2011 +0400

    Mark some local functions as static, cosmetics

commit 2ecbcd73d60d2f749696b39627c91e28a396538b
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Fri Nov 11 23:19:02 2011 +0400

    Fix crash if timecode file opening fails

commit f1387840b98560ae34aea9ca09d55984812ad50b
Author: Fabian Greffrath <fabian+debian@greffrath.com>
Date:   Fri Nov 11 13:25:43 2011 -0800

    Configure: force PIC for shared build on PARISC and MIPS

commit e5063ab30bcb79f94774b6d9ce91b098ade01d6d
Author: Anton Mitrofanov <BugMaster@narod.ru>
Date:   Sat Oct 22 19:41:07 2011 +0400

    Improve yasm version check
    Previous check allowed certain earlier versions that weren't fully compatible.

commit 12104b22820b38b4976e83a6ee00dcb59ed959f1
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Oct 18 14:30:26 2011 -0700

    Add fenc prefetching to adaptive quant
    Many fewer cache misses, faster adaptive quant.

commit 9bbfc30284469a70374a75fecfa322c4740dc2b7
Author: Fiona Glaser <fiona@x264.com>
Date:   Tue Oct 18 14:14:03 2011 -0700

    Split prefetch_fenc between colorspaces
    Add 4:2:2 version.

